2007-04-28  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (build_wait_tids): Do not call mono_monitor_enter () here since the
	caller holds threads_lock, leading to deadlocks. Fixes #81476.

2007-04-23  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c: Fix calling convention for CCW on non-windows
	platforms. STDCALL on windows, CDECL everywhere else to work 
	with XPCOM and MainWin COM.
	
	Code is contributed under MIT/X11 license.

2007-04-23  Martin Baulig  <martin@ximian.com>

	Fix #80969.

	* loader.c
	(method_from_memberref): Added `gboolean *used_context' argument.
	(mono_get_method_from_token): Likewise.
	(mono_get_method_full): Don't insert the method in the cache when
	`used_context' is true.


Thu Apr 19 16:45:55 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* threadpool.c, threadpool.h, icall-def.h: patch from
	Robert Jordan to implemnt ThreadPool.SetMaxThreads.

2007-04-18  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (mono_thread_get_stack_bounds): Fix windows build.
	
	* threads.c (mono_thread_get_stack_bounds): Remove an assert which can be triggered.

	* threads.c (mono_thread_get_stack_bounds): New helper function.

	* threads.c (mono_thread_attach): Applied patch from horst.reiterer@fabasoft.com.
	Correctly compute stack bounds when attaching. Fixes #81394.

Wed Apr 18 18:28:41 BST 2007 Paolo Molaro <lupus@ximian.com>

	* reflection.c: fix handling of doubles in custom attributes
	for the arm-fpa format (bug #81368).

2007-04-18  Raja R Harinath  <rharinath@novell.com>

	* reflection.c (assembly_add_win32_resources): Mildly relax an
	bounds check to let the end pointer point just past the end of the
	allocated buffer.  (may fix #81384)

2007-04-17  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : regenerated.

2007-04-07  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (start_wrapper): Call push_appdomain_ref () earlier to fix races where
	the thread is aborted early.

2007-04-04  Martin Baulig  <martin@ximian.com>

	* debug-helpers.c
	(mono_method_desc_full_match): Add support for nested classes.

2007-04-02  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (cominterop_get_managed_wrapper_adjusted): Fix warnings.

2007-04-01  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (abort_appdomain_thread): Avoid handle leakage if we are
	waiting for too many threads.

2007-03-28  Sebastien Pouliot  <sebastien@ximian.com>

	* environment.c: Fix return value check on uname so we can get the 
	executing version on Solaris operating systems.

2007-03-28  Jb Evain  <jbevain@gmail.com>

	* class.c (mono_type_get_name_recurse): Complete the
	fix for the creation of assembly qualified names for
	pointer types. Fixes #81208.

2007-03-27  Dick Porter  <dick@ximian.com>

	* appdomain.c (MONO_CORLIB_VERSION): Increment, as the signature
	of ves_icall_System_Threading_Mutex_ReleaseMutex_internal() has
	changed.

	* threads.c
	(ves_icall_System_Threading_Mutex_ReleaseMutex_internal): Return
	the value of ReleaseMutex().

2007-03-27  Dick Porter  <dick@ximian.com>

	* socket-io.c (ipaddress_to_struct_in_addr): IPAddress is stored
	in little-endian order, not network endian, so must be converted
	to host endian here.  Fixes bug 80593.

2007-03-22  Jb Evain  <jbevain@gmail.com>

	* class.c (mono_type_get_name_recurse): Fix the creation of assembly
	qualified names for pointer types. Fixes #81208.

2007-03-21  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c: Add support for PreserveSigAttribute. 
	
	Code is contributed under MIT/X11 license.

2007-03-14  Zoltan Varga  <vargaz@gmail.com>

	* process.c: Fix endianness issues. Fixes #81126.

	* reflection.c (mono_reflection_create_dynamic_method): Fix the last change so
	multiple circular calls made from the same DynamicMethod work. Fixes #81141.

	* image.c (mono_image_lookup_resource): Make this work on big-endian
	machines.Change API contract so the caller needs to free the return value.
	
	* process.c (process_get_fileversion): Adapt to mono_image_lookup_resource ()
	API change.
	
2007-03-14  Martin Baulig  <martin@ximian.com>

	* debug-helpers.c (mono_type_get_desc): In `MONO_TYPE_ARRAY', use
	mono_type_get_desc() as well.

2007-03-13  Jonathan Chambers  <joncham@gmail.com>

	* icall.c:  Fix environ access in VS.  
	
2007-03-13  Alp Toker  <alp@atoker.com>

	* icall.c (ves_icall_MonoType_GetElementType): For enums, return null
	rather than the underlying type. Based on a patch by Ben Maurer. Fixes
	#63841.

2007-03-12  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_reflection_create_dynamic_method): Add support for 
	circular references among dynamic methods. Fixes #81091.

	* object-internals.h (MonoReflectionDynamicMethod): Add 'referenced_by' field.

2007-03-09  Martin Baulig  <martin@ximian.com>

	* reflection.c (encode_constant): Add support for MONO_TYPE_GENERICINST.

2007-03-09  Jonathan Chambers  <joncham@gmail.com>

	* appdomain.c:  Fix shadow copy on Windows. Use g_snprintf instead
	of snprintf as it doesn't exist on Win32 (VS build); also for uniformity.  
	
	Code is contributed under MIT/X11 license.
        
2007-03-09  Gert Driesen  <drieseng@users.souceforge.net>

	* loader.c: Reapply patch for bug #79424.

2007-03-06  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (mono_type_to_unmanaged): Only convert object to
	MARSHAL_CONV_SAFEHANDLE on the 2.0 profile.

Tue Mar 6 15:39:48 CET 2007 Paolo Molaro <lupus@ximian.com>

	* class-internals.h, class.c, metadata.c, reflection.c: removed unused
	(and incorrectly set) is_reference field from MonoGenericInst.

2007-03-06  Zoltan Varga  <vargaz@gmail.com>

	* assembly.c (mono_assembly_load_from_full): Call mono_assemblies_unlock ()
	a little earlier.

	* icall.c (ves_icall_type_Equals): Rename this to ves_icall_System_Type_EqualsInternal.

	* icall-def.h: Rename Type:Equals to Type:EqualsInternal.

2007-03-05  Miguel de Icaza  <miguel@novell.com>

	* file-io.c (ves_icall_System_IO_MonoIO_Open): Use the new
	FileOptions.1 value to mean "temporary", map that to
	FILE_ATTRIBUTE_TEMPORARY and use that to signal 600 permissions.

	Fixes 80688

2007-03-03  Marek Habersack  <mhabersack@novell.com>

	* appdomain.c: implement MS .Net style shadow copying. Copies of
	the assemblies are made in a subdirectory of the dynamic base
	directory, the assembly names are preserved.
	Copy .mdb and .config files along with the assemblies being shadowed.

2007-02-28  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_object_to_ptr_conv): Emit valid IL for handling HandleRefs.
	(emit_marshal_handleref): Ditto.

	* profiler.c: Applied patch from Tor Lillqvist (tml@novell.com) to fix output
	on Visual C++. Fixes #80671.

Wed Feb 28 16:53:40 CET 2007 Paolo Molaro <lupus@ximian.com>

	* boehm-gc.c, null-gc.c, object.h, object.c: sgen gc fixes
	for clone operations.

2007-02-28  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c: Fix warnings.

Fri Feb 23 15:06:57 CET 2007 Paolo Molaro <lupus@ximian.com>

	* loader.c: allow case-insensitive matching of the dll name
	in dllmap handling when prefixed with "i:".

2007-02-20  Jonathan Chambers  <joncham@gmail.com>

	* threads.c: Fix #ifdef for dummy_apc function for VS.

Tue Feb 20 11:59:42 CET 2007 Paolo Molaro <lupus@ximian.com>

	* threads.c: don't throw in MemoryBarrier (), use lock/unlock.

2007-02-19  Massimiliano Mantione  <massi@ximian.com>
	* class.c (mono_class_setup_vtable_general): Fix bug 75903,
	giving precedence to the methods with a fully qualified name
	(InterfaceName.MethodName) when building the interface sections
	of the vtable.

2007-02-16  Dick Porter  <dick@ximian.com>

	* threadpool.c (append_job): Fix fast-path array handling, so it's
	less likely the array will grow exponentially when the load is
	heavy.

Fri Feb 16 19:17:30 CET 2007 Paolo Molaro <lupus@ximian.com>

	* metadata-internals.h, loader.c: fix dllmap lookup order
	for non-function maps, too, and prepare for fallback code.

2007-02-12  Robert Jordan  <robertj@gmx.net>

	* marshal.c, marshal.h, icall-def.h: rename mono_marshal_realloc
	to ves_icall_System_Runtime_InteropServices_Marshal_ReAllocHGlobal
	and use GlobalReAlloc on WIN32 to be in sync with GlobalAlloc,
	GlobalFree. Fixes a part of bug #77075.

Mon Feb 12 21:10:07 CET 2007 Paolo Molaro <lupus@ximian.com>

	* loader.c: implemented typedef parent in field memberref.

2007-02-11  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c: Fix warnings and remember to call Release on
	IUnknown of RCW.
	
	Code is contributed under MIT/X11 license.

2007-02-10  Miguel de Icaza  <miguel@novell.com>

	* class-internals.h: Add MonoHandleRef definition, and
	handleref_class to mono_defaults. 

	* metadata.c (mono_type_to_unmanaged): If we find HandleRefs in a
	structure, use new conversion MONO_MARSHAL_CONV_HANDLEREF.

	* marshal.c (emit_ptr_to_object_conv): Add support for HandleRefs
	(do nothing on this stage)
	(emit_object_to_ptr_conv): Extract the handle from the HandleRef.  
	(emit_marshal_handleref): New method, used for argument handling
	of HandleRefs. 

2007-02-08  Jonathan Chambers  <joncham@gmail.com>

	* class.c (mono_class_setup_parent): Lazily init com types.
	* domain.c (mono_init_internal, mono_init_com_types): Lazily 
	init com types.
	* object.c (mono_remote_class_vtable): Lazily init com types.
	* class-internals.h: Add iunknown and idispatch to MonoDefaults.
	* object-internals.h: Add MonoComInteropProxy and MonoReflectionGuidAttribute.
	* domain-internals.h: Expose mono_init_com_types.
	* icall-def.h: Add icalls for ComInteropProxy, __ComObject, and Marshal.
	* marshal.c: Add mutex for cominterop use. Init locals for wrapper methods.
	Add support for COM Callable Wrapper marshalling.
	* marshal.h: Add icall definitions.
	* gc.c: Handle freeing of CCWs in finalizer code.
	
	Code is contributed under MIT/X11 license.

Thu Feb 8 12:46:18 CET 2007 Paolo Molaro <lupus@ximian.com>

	* reflection.c: changed all the signature encoding code to use
	a variable-sized buffer.

Wed Feb 7 20:37:23 CET 2007 Paolo Molaro <lupus@ximian.com>

	* marshal.c: locking fixes: never take the loader lock
	or other runtime locks when holding the marshal lock
	(fixes bug#80664).

Wed Feb 7 18:49:10 CET 2007 Paolo Molaro <lupus@ximian.com>

	* marshal.c: make the delegate function pointer mapping
	work for the moving GC.

Mon Jan 29 11:30:46 CET 2007 Paolo Molaro <lupus@ximian.com>

	* marshal.c: fix from Robert Jordan (robertj@gmx.net)
	for bug #80618.

Fri Jan 26 12:49:23 CET 2007 Paolo Molaro <lupus@ximian.com>

	* image.h, loader.c, metadata-internals.h: use mono-dl instead of
	gmodule.

Fri Jan 26 12:00:45 CET 2007 Paolo Molaro <lupus@ximian.com>

	* threadpool.c: made the code moving-GC safe.

Thu Jan 25 20:31:41 CET 2007 Paolo Molaro <lupus@ximian.com>

	* assembly.c, boehm-gc.c, class-internals.h, class.c,
	debug-mono-symfile.c, domain.c, locales.c, marshal.c, metadata.c,
	monitor.c, mono-debug.c, mono-debug.h, object.c, profiler.c:
	warning cleanup.
	* reflection.c: warning cleanup, some threading and moving GC fixes.

Thu Jan 25 16:22:36 CET 2007 Paolo Molaro <lupus@ximian.com>

	* class.c, loader.c: create the needed Set/Get/Address array methods
	as well as the .ctors in mono_class_init (), fixes bug #80567.

2007-01-24  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_layout_fields): When force-aligning a field, make sure
	we doesn't decrease its alignment. Should fix the sparc build.

2007-01-24  Dick Porter  <dick@ximian.com>

	* socket-io.c
	(ves_icall_System_Net_Sockets_Socket_GetSocketOption_obj_internal):
	Create the returned object if we need to ignore an unsupported
	socket option.  Fixes a segfault reported by Atsushi.

Tue Jan 23 18:09:21 CET 2007 Paolo Molaro <lupus@ximian.com>

	* class.c, object.c: restrict GC-tracked fields to
	UIntPtr fields used inside corlib, so we provide better
	type info to the GC and also allow broken packing as in
	bug #80580.

Mon Jan 22 11:24:27 CET 2007 Paolo Molaro <lupus@ximian.com>

	* sgen-gc.c: removed duplicated function.

2007-01-19  Miguel de Icaza  <miguel@novell.com>

	*  socket-io.c (convert_sockopt_level_and_name): return -2 as a
	value that means that the value is not supported, but that we
	should not return a failure, but instead report this as a
	successful operation.

2007-01-19  Raja R Harinath  <rharinath@novell.com>

	Fix tests/bug79956.2.il
	* class.c (mono_type_get_underlying_type): Handle genericinst enums.
	(mono_generic_class_get_class): If the generic definition in an
	enum, copy over other fields related to it.

Thu Jan 18 18:37:28 CET 2007 Paolo Molaro <lupus@ximian.com>

	* metadata.h: fix MONO_TYPE_ISSTRUCT() to not consider
	genericinst enums (bug #79215).

2007-01-17  Massimiliano Mantione  <massi@ximian.com>
	* class.c: Fix bug 80307.

Wed Jan 17 17:09:20 CET 2007 Paolo Molaro <lupus@ximian.com>

	* image.c: if the file table is not present, try to load
	all the modules, since we don't have info about them
	having or not metadata (bug #80517).
	* assembly.c: allow mono_assembly_load_references () to
	work for netmodules.

Wed Jan 17 14:28:30 CET 2007 Paolo Molaro <lupus@ximian.com>

	* image.c, metadata-internals.h, object.c: execute module
	cctors when running on the 2 runtime if present (bug #80487).

Tue Jan 16 15:32:53 CET 2007 Paolo Molaro <lupus@ximian.com>

	* icall.c: optimized InitializeArray() on bigendian.

Tue Jan 16 13:18:51 CET 2007 Paolo Molaro <lupus@ximian.com>

	* icall.c: fix for the broken ARM FPA double format.

Tue Jan 16 12:51:16 CET 2007 Paolo Molaro <lupus@ximian.com>

	* icall.c: handle endian issues for r4 and r8 types, too, in
	the InitializeArray() icall.

2007-01-15  Miguel de Icaza  <miguel@novell.com>

	* loader.c (mono_loader_error_prepare_exception): Clear the error
	once we have extracted the information from it, do this before we
	call into the JIT's class loading mechanisms.

	* object.c (mono_class_create_runtime_vtable): Do not clear the
	loader error before calling mono_class_get_exception_for_failure
	as the loader error is needed inside
	mono_class_get_exception_for_failure to throw the error (thinko).

	Fixes #80521
	
Mon Jan 15 10:27:31 CET 2007 Paolo Molaro <lupus@ximian.com>

	* reflection.c: align fields rva data so it's faster to load at
	runtime.

2007-01-12  Raja R Harinath  <rharinath@novell.com>

	Prepare to simplify GenericMethod handling.
	* class-internals.h (mono_method_get_context): New accessor function.
	* class.c, icall.c, loader.c, reflection.c, verify.c: Use accessor
	rather than directly accessing '->context' field.

	* class-internals.h (_MonoGenericParam.method): Move ...
	(_MonoGenericContainer): ... here.  Add into union with klass field.
	* class.c, icall.c, loader.c, metadata.c, reflection.c:
	Update to changes.

Fri Jan 12 11:58:52 CET 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, class-internals.h, debug-helpers.c: consolidate
	the wrapper type enum and reduce relocations.

2007-01-12  Raja R Harinath  <rharinath@novell.com>

	* reflection.c (inflate_mono_method): Reuse method instantiation
	from the generic method, if available.

2007-01-11  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c (emit_marshal_variant): Fix conv_arg
	type in last commit, based on whether parameter is byref.
	
2007-01-11  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c (emit_marshal_variant): Handle unmanaged->managed
	marshalling.
	(mono_marshal_emit_managed_wrapper): Convert byref arguments of type
	MONO_TYPE_OBJECT back for VARIANT support.

2007-01-11  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c, marshal.h, icall-def.h: Implement 
	Marshal.ReAllocCoTaskMem.

Thu Jan 11 19:00:03 CET 2007 Paolo Molaro <lupus@ximian.com>

	* marshal.c: memory retention fixes: use the proper
	image cache for runtime_invoke method lookups.

Thu Jan 11 18:53:19 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mempool.c: added code to help debug mempool allocations.

2007-01-11  Dick Porter  <dick@ximian.com>

	* socket-io.c (convert_sockopt_level_and_name): Add DontFragment
	support (experimenting with faking it with IP_MTU_DISCOVER for
	systems that don't have IP_DONTFRAGMENT.)
	(ves_icall_System_Net_Sockets_Socket_Disconnect_internal): New
	icall.

	* icall-def.h: new System.Net.Sockets.Disconnect icall.

	* socket-io.h: Add new fields to MonoSocketAsyncResult
	corresponding to the new ones in Socket.cs.

2007-01-11  Raja R Harinath  <rharinath@novell.com>

	Fix IronPython regression mentioned in #80249
	* metadata.c (do_mono_metadata_parse_generic_class): Clear
	'cached_context' field, since it may have been initialized as a
	side-effect of metadata parsing.

	* class-internals.h (_MonoGenericClass.is_inflated): Remove.
	(_MonoGenericClass.cached_class): Move here and rename from lone
	remaining field of ...
	(_MonoInflatedGenericClass): ... this.  Remove.
	* metadata.h, class.c, reflection.c, metadata.c, icall.c: Update
	to changes.

	Fix mcs/tests/test-128.cs regression.
	* reflection.c (encode_cattr_value) [MONO_TYPE_SZARRAY]: Revert
	2007-01-10 change below.
	[MONO_TYPE_OBJECT]: Recurse into array case.

2007-01-11  Raja R Harinath  <harinath@gmail.com>

	* class-internals.h (mono_get_inflated_generic_class): Remove.
	* class.c (mono_get_inflated_generic_class): Remove.
	(mono_generic_class_get_class): Rename from
	mono_class_create_generic.
	(mono_class_from_mono_type) [GENERICINST]: Use it.
	* reflection.c, metadata.c: Update to changes.  Use
	'mono_class_from_mono_type'.

Wed Jan 10 16:19:54 CET 2007 Paolo Molaro <lupus@ximian.com>

	* reflection.c: use passed type when encoding an array element
	in custom attributes (patch from David Mitchell, dmitchell@logos.com).

2007-01-09  Robert Jordan  <robertj@gmx.net>

	* marshal.c (mono_delegate_end_invoke): Add check for unpaired asyc
	result arguments (someDelegate.EndInvoke (unrelatedAres)).
	Fixes bug #80392.

2007-01-09  Raja R Harinath  <rharinath@novell.com>

	* class-internals.h (_MonoInflatedGenericClass.is_initialized): Remove.

	* object.c (set_value): Avoid aliasing between type->data.klass
	and type->data.generic_class.

	* class.c (mono_class_create_generic): Don't use 'is_initialized' field.

2007-01-08  Raja R Harinath  <rharinath@novell.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Avoid aliasing
	between type->data.klass and type->data.generic_class.

2007-01-08  Lluis Sanchez  <lluis@ximian.com>

	* marshal.c: In MS.NET, StringBuilder objects are not copied by
	value in out parameters.

2007-01-08  Raja R Harinath  <rharinath@novell.com>

	Simplify invariant for MonoGenericClass::klass field.
	* class.c (mono_class_create_generic): Verify 'klass' is null.
	* metadata.c (do_mono_metadata_parse_generic_class): Don't
	initialize 'klass' field.

2007-01-05  Raja R Harinath  <rharinath@novell.com>

	Ongoing work to avoid redundant data and simplify invariants.
	* class-internals.h (_MonoGenericMethod.class_inst): Rename from
	'generic_class', and change type to a GenericInst.
	(_MonoGenericContext.class_inst): Likewise, rename from 'gclass'.
	* class.c, loader.c, metadata.c, reflection.c: Update to changes.

2007-01-05  Atsushi Enomoto  <atsushi@ximian.com>

	* class.c : skip io-layer under PLATFORM_WIN32.

2007-01-03  Tor Lillqvist  <tml@novell.com>

	Fix #80305: In a bundled executable, look in the bundled exe
	assembly to determine the runtime version. Add the possibility to
	bundle also the machine.config file.
	
	* assembly.c (mono_assembly_open_from_bundle): Make
	non-static. Allow being called even if we have no bundled
	assemblies, and return NULL right away in that case.

	* domain-internals.h: Declare mono_assembly_open_from_bundle()
	here.

	* domain.c (app_config_parse): Take an assembly exe file name as
	parameter instead of a config file name. Check for a bundled
	config file for that assembly by calling
	mono_config_string_for_assembly_file() (see below) before looking
	for one in the file system.
	(get_runtimes_from_exe): Corrsponding change to call of
	app_config_parse().
	(get_runtimes_from_exe): Check for bundled assembly exe file first
	by calling mono_assembly_open_from_bundle(). If no bundled
	assembly exe file is found, call mono_image_open() as before to
	look it up in the file system.

	* mono-config.c: Add variable bundled_machinec_onfig.
	(mono_config_string_for_assembly_file): New function.
	(mono_config_for_assembly): Move code snippet that looks for a
	bundled assembly .config file into the above new function. Call
	it.
	(mono_register_machine_config, mono_get_machine_config): New
	functions to set and retrieve

	* assembly.h: Declare mono_register_machine_config().

	* mono-config.h: Declare mono_get_machine_config() and
	mono_config_string_for_assembly_file().

	* icall.c: No declaration of environ necessary on Win32. It is
	declared (as a macro expanding to a function call) in stdlib.h.
	(ves_icall_System_Configuration_DefaultConfig_get_bundled_machine_config):
	New internal mono function. Returns the value of
	mono_get_machine_config() as a Mono string.

	* icall-def.h: Add get_bundled_machine_config().

2007-01-04  Raja R Harinath  <rharinath@novell.com>

	Remove redundant field
	* class-internals.h (_MonoGenericContext.container): Remove field.
	* loader.c (mono_method_get_signature_full): Don't parse a
	"container" for a signature parse when the signature is inflated
	immediately.
	(method_from_methodspec): Likewise, for a generic_inst.
	* class.c, metadata.c, reflection.c: Update to changes.

2006-01-04  Raja R Harinath  <rharinath@novell.com>

	* class-internals.h (_MonoGenericClass): Rename 'context' field to
	'cached_context', and change semantics -- it starts off NULL, and
	is initialized on demand.
	* class.c (mono_generic_class_get_context): New accessor to
	replace 'context' field accesses.
	(mono_class_get_context): New helper.
	(*): Update to changes.
	* icall.c, loader.c, metadata.c, reflection.c: Update to changes.

2007-01-03  Miguel de Icaza  <miguel@novell.com>

	* marshal.c (mono_string_to_byvalstr): Fix thinko, shorten len
	before the memcpy.   Fixes Marshal2 regression.

2007-01-02  Jb Evain  <jbevain@gmail.com>

	* blob.h: add a MONO_TYPE_ENUM definition
	* reflection.c (load_cattr_value, create_custom_attr, create_custom_attr_data):
	fix the encoding of arrays of enums in custom attributes.

	Fixes #79666.

2007-01-01  Miguel de Icaza  <miguel@novell.com>

	* marshal.c (mono_string_to_byvalwstr): Fix this routine.   The
	string is null terminated, but only cut the string short if it
	overflows the buffer.   
	
	(mono_string_to_byvalstr): Also fix this routine.   The code here
	was not properly terminating a string (it was only terminated
	because of the previous catch-all memset). 

	I left the memset, because I do not know if applications expect
	the runtime to clear this region. 

	Fixes #79944.

	* icall.c (ves_icall_System_Reflection_Assembly_InternalGetType):
	Clear the error before returning to unmanaged code to prevent the
	runtime from being confused later on (fixes  80420).
	(ves_icall_type_from_name): Always call mono_loader_clear_error
	after parsing a type that could have failed.
	(ves_icall_System_Reflection_Assembly_GetTypes): ditto.

	* loader.c (mono_loader_clear_error): Fix indentation.

2006-12-28  Martin Baulig  <martin@ximian.com>

	* mono-debug.h (MONO_DEBUGGER_VERSION): Bump to 58.

Fri Dec 22 20:04:57 CET 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c: patch from Rolf Bjarne Kvinge to fix
	getting a token for an EnumBuilder.

Fri Dec 22 19:49:07 CET 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c: be more careful in case resource generation
	fails to create the data array.

Fri Dec 22 18:17:40 CET 2006 Paolo Molaro <lupus@ximian.com>

	* sgen-gc.c: write barrier for clone and fix unregister handles.

Fri Dec 22 18:15:33 CET 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c: some fixes needed in the generics code for the moving GC.

2006-12-22  Robert Jordan  <robertj@gmx.net>

	* icall.c (ves_icall_System_Array_SetValueImpl): Take enums into
	account. Fixes bug #80299.

2006-12-21  Raja R Harinath  <rharinath@novell.com>

	Fix WaitHandle usage in delegates.
	* object-internals.h (mono_wait_handle_get_HANDLE): Declare.
	* object.c (mono_wait_handle_new): Use the property set method to
	initialize the handle.
	(mono_wait_handle_get_handle): New.
	* threadpool.c (mono_async_invoke): Use it.
	* threads.c (ves_icall_System_Threading_WaitHandle_WaitAll_internal):
	Likewise.
	(ves_icall_System_Threading_WaitHandle_WaitAny_internal): Likewise.

2006-12-21  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c (emit_marshal): Call emit_marshal_variant and
	emit_marshal_com_interface when applicable.
	(emit_marshal_variant, emit_marshal_com_interface): Add
	methods for this case and remove if's from emit_marshal_object.
	
Wed Dec 20 11:03:56 CET 2006 Paolo Molaro <lupus@ximian.com>

	* filewatcher.c: updated to use the mono-dl API instead of gmodule.

2006-12-19  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c (ves_icall_System_Runtime_InteropServices_Marshal_AllocHGlobal,
	ves_icall_System_Runtime_InteropServices_Marshal_FreeHGlobal): Use GlobalAlloc
	and GlobalFree on Windows. Remove FIXME.

Tue Dec 19 16:18:16 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mono-mlist.h, mono-mlist.c, Makefile.am: linked list
	implementation for managed objects.

Tue Dec 19 14:28:03 CET 2006 Paolo Molaro <lupus@ximian.com>

	* object.c: implemented code to be used for checking
	that no reference field overlaps with non-references.

Tue Dec 19 14:10:37 CET 2006 Paolo Molaro <lupus@ximian.com>

	* threadpool.c: fix queue code to be compatible with the
	moving GC.

2006-12-18  Miguel de Icaza  <miguel@novell.com>

	* marshal.c (emit_object_to_ptr_conv): Handle null safehandles
	in structures by throwing ArgumentNullException.

	(emit_marshal_safehandle): Also when they are null parameters.

	(emit_marshal_safehandle): Add support for ref
	SafeHandles parameters

Mon Dec 18 19:14:44 CET 2006 Paolo Molaro <lupus@ximian.com>

	* profiler.c: updated to use the mono-dl API instead of
	gmodule.

Mon Dec 18 19:02:37 CET 2006 Paolo Molaro <lupus@ximian.com>

	* profiler.c: updated to use the mono-dl dynamic loading
	API instead of gmodule.

Mon Dec 18 18:16:22 CET 2006 Paolo Molaro <lupus@ximian.com>

	* profiler.c: use readlink, older versions of glib don't have
	g_file_read_link ().

Mon Dec 18 16:40:34 CET 2006 Paolo Molaro <lupus@ximian.com>

	* profiler.c: try to detect the path to mono if libc fails to provide
	a useful name (bug #80286).

2006-12-16  Raja R Harinath  <rharinath@novell.com>

	Fix #80242
	* icall.c (ves_icall_Type_GetNestedType): If the type is a generic
	instance, use the generic type definition instead.
	(ves_icall_Type_GetNestedTypes): Likewise.
	* class.c (mono_class_create_generic): Always set the
	nested_classes of a generic instance to NULL, even if the generic
	type definition has nested types.

2006-12-15  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c (mono_string_from_bstr): Revert previous Windows change
	and fix on Linux.
	
2006-12-15  Miguel de Icaza  <miguel@novell.com>

	* marshal.c (mono_string_from_bstr): Jon Chambers pointed out that
	my arguments were in the wrong order.   I also fixed the Windows
	version which seems to have had the same issue.

	(mono_free_bstr): On Unix, this is g_free.
	(mono_string_from_bstr, mono_string_to_bstr): Implement bstr
	conversions (for the tests in corlib to pass).

2006-12-14  Miguel de Icaza  <miguel@novell.com>

	* marshal.c (emit_ptr_to_object_conv): For now, ignore
	MONO_MARSHAL_CONV_SAFEHANDLE on return values (we need to throw an
	exception if a ref SafeHandle in a struct has changed).
	
	(emit_struct_conv): Do not perform layout checks for classes
	derived from SafeHandle, as those are specially handled. 

	(emit_object_to_ptr_conv): Add support for
	MONO_MARSHAL_CONV_SAFEHANDLE conversion. 

	(emit_marshal_safehandle): Implement conversion of return values
	of safehandles (MARSHAL_ACTION_CONV_RESULT).
	
	* threads.c: WaitHandle now is compiled with two different handles
	"IntPtr os_handle" for 1.x and "SafeWaitHandle safe_wait_handle"
	for 2.0.
	
	(ves_icall_System_Threading_WaitHandle_WaitAll_internal) 
	(ves_icall_System_Threading_WaitHandle_WaitAny_internal): Adjust
	these routines to cope with both kinds of fields.

2006-12-12  Miguel de Icaza  <miguel@novell.com>

	* metadata.c (mono_type_to_unmanaged): Handle the case where
	type->data.klass is a SafeHandle, and in that case, return the
	size of a pointer (MONO_NATIVE_INT) and set the conversion to be
	MONO_MARSHAL_CONV_SAFEHANDLE. 

2006-12-11  Miguel de Icaza  <miguel@novell.com>

	* marshal.c (emit_marshal): Hook up to the MONO_TYPE_CLASS and
	MONO_TYPE_OBJECT cases and check for a SafeHandle here before
	calling emit_marshal_object.

	(emit_marshal_safehandle): Implement marshalling of
	SafeHandle parameters (no ref support yet).

	(MarshalAction): Document the defines as I implement
	them for SafeHandle.

	(emit_marshal_object): indentation police.

	* class-internals.h: Define MonoSafeHandle.
	Add safehandle_class to MonoDefaults type.

	* verify.c: Add System.Runtime.InteropServices.SafeHandle to the
	list of classes to check for fields. 

	* domain.c (mono_init_internal): Add SafeHandle to the list of
	mono_defaults loaded.

2006-12-15  Raja R Harinath  <rharinath@novell.com>

	Fix #80253
	* reflection.c (mono_reflection_bind_generic_parameters): If the
	generic type definition is a type builder, ensure that it is fully
	initialized before instantiating it.  Kill some dead code.

Thu Dec 14 17:02:59 CET 2006 Paolo Molaro <lupus@ximian.com>

	* object.c: clear the loader_error () before loading
	more metadata stuff (bug #80258).

Thu Dec 14 12:49:47 CET 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c, icall-defs.h: type modifiers icalls for
	parameters and properties.

Wed Dec 13 19:29:50 CET 2006 Paolo Molaro <lupus@ximian.com>

	* object.c, icall.c: fixed warnings.

Mon Dec 11 11:03:10 CET 2006 Paolo Molaro <lupus@ximian.com>

	* marshal.c: fixed a couple of leaks and coding style in a few places.

2006-12-08  Dick Porter  <dick@ximian.com>

	* process.c: Cope with NULL ProcessStartInfo arguments on windows
	too.  Patch from Jonathan Chambers <joncham@gmail.com>, fixes bug
	80173.

Thu Dec 7 15:20:31 CET 2006 Paolo Molaro <lupus@ximian.com>

	* process.c: ProcessStartInfo may have only filename set and
	arguments can be NULL.

Tue Dec 5 19:19:34 CET 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c: fix leak found by Robert Jordan.

Tue Dec 5 17:53:10 CET 2006 Paolo Molaro <lupus@ximian.com>

	* marshal.c, marshal.h: generate managed method to access an element
	of a multi-dimensional array.

2006-11-30  Paolo Molaro (lupus@ximian.com)

	* metadata.c, marshal.c: locking fixes when writing to image->mempool.

Thu Nov 30 11:11:37 CET 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c: back out GetFields () fix until the serialization code is
	fixed to not depend on the incorrect behaviour.

Wed Nov 29 22:01:46 CET 2006 Paolo Molaro <lupus@ximian.com>

	* profiler.c: provide defaults if none are set.

Tue Nov 28 12:54:51 CET 2006 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, attrdefs.h: new public header file with
	constants for attributes for use by embedders.

Tue Nov 28 11:44:52 CET 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c: GetFields () fix for bug #80064.

Tue Nov 28 10:56:01 CET 2006 Paolo Molaro <lupus@ximian.com>

	* filewatcher.c, filewatcher.h, icall-def.h, icall.c, locales.c:
	removed long unused icalls.

2006-11-27  Jonathan Chambers  <joncham@gmail.com>
  
	* marshal.c: 
		(mono_marshal_emit_managed_wrapper): Level of indirection for 
		mono_marshal_get_managed_wrapper so that a wrapper for a managed method
		can be generated without a delegate class.
		(mono_marshal_get_managed_wrapper): Move wrapper logic to mono_marshal_emit_managed_wrapper.
	
	Signed-off-by: Jonathan Chambers <joncham@gmail.com>

2006-11-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* console-io.c: add the 'signal' call removed by mistake. Fixes bug
	#80069.

Mon Nov 27 19:29:13 CET 2006 Paolo Molaro <lupus@ximian.com>

	* boehm-gc.c, null-gc.c, sgen-gc.c, mono-gc.h, icall.c,
	icall-def.h: added icalls needed by System.GC.

Thu Nov 23 20:01:12 CET 2006 Paolo Molaro <lupus@ximian.com>

	* loader.c: ensure the class in catch clauses is handled
	correctly for generics methods (fixes bug#79980).

Thu Nov 23 17:31:58 CET 2006 Paolo Molaro <lupus@ximian.com>

	* monitor.h, monitor.c: added mono_locks_dump () function
	to help debug deadlocks involving managed locks.

2006-11-13  Dick Porter  <dick@ximian.com>

	* file-io.c (get_file_attributes): If the file is a symlink try
	and get the stat data for the target, but also add the
	FILE_ATTRIBUTE_REPARSE_POINT flag.  This is an attempt to follow
	the specs for the windows symlink support, but will probably have
	to be reworked when I have test data from a vista machine.  Fixes
	bug 79887.

2006-11-13  Dick Porter  <dick@ximian.com>

	* gc.c (mono_domain_finalize): 
	* marshal.c (mono_delegate_begin_invoke): 
	* threadpool.c (socket_io_init, mono_thread_pool_init)
	(mono_thread_pool_finish): 
	* monitor.c (mono_monitor_try_enter_internal): 
	* threads.c (mono_thread_resume, mono_thread_init)
	(mono_thread_suspend_all_other_threads)
	(mono_thread_execute_interruption): 
	* appdomain.c (mono_domain_unload): Check for NULL error returns
	from CreateThread(), CreateEvent() and CreateSemaphore().  See bug
	75733.

2006-11-11  Miguel de Icaza  <miguel@novell.com>

	* process.c
	(ves_icall_System_Diagnostics_Process_CreateProcess_internal):
	Only close the handle if the value of the handle is not
	INVALID_HANDLE_VALUE.  This just makes the process a bit more
	robust.

	Improvement for #75733, so that we do not run into this problem. 

	
	* assembly.c (check_path_env, check_extra_gac_path_env): Do not
	include empty directories from MONO_PATH or MONO_GAC_PREFIX in our
	internal variables.  Fixes #79462 
	

2006-11-09  Dick Porter  <dick@ximian.com>

	* socket-io.c (ves_icall_System_Net_Sockets_Socket_Poll_internal):
	Use poll() not select().  Fixes bug 79397.

2006-11-09  Raja R Harinath  <rharinath@novell.com>

	Fix #79872
	* assembly.c (mono_assembly_load_from_full): Check that the given
	image has an assembly manifest.

2006-11-09  Ankit Jain  <jankit@novell.com>

	* tabledefs.h (ASSEMBLYREF_RETARGETABLE_FLAG):
	(ASSEMBLYREF_ENABLEJITCOMPILE_TRACKING_FLAG):
	(ASSEMBLYREF_DISABLEJITCOMPILE_OPTIMIZER_FLAG): Add AssemblyRef flags.

2006-11-07  Dick Porter  <dick@ximian.com>

	* socket-io.c (ves_icall_System_Net_Dns_GetHostByAddr_internal):
	Put the old resolver behaviour back for pre-2.0 profiles.

Tue Nov 7 16:56:24 CET 2006 Paolo Molaro <lupus@ximian.com>

	* threadpool.c: precise GC and locking fixes.

Tue Nov 7 11:02:42 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class.c: don't load types that have an explicit unaligned
	managed reference. Provide better info in the TypeLoad exception.
	Part of the fix for bug #79744.
	* object.c: use the correct check for class type load issues.

Mon Nov 6 17:07:43 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class.c: enforce alignment of fields with managed references
	even when Pack=1 is forced by the user (bug #77788).

2006-11-03  Dick Porter  <dick@ximian.com>

	* socket-io.c (ves_icall_System_Net_Dns_GetHostByAddr_internal):
	If the address reverse lookup fails, return it as the hostname
	anyway.  Fixes bug 79721.

2006-11-03  Dick Porter  <dick@ximian.com>

	* threads.c (ves_icall_System_Threading_Thread_SpinWait_internal):
	Fix build on Windows.

2006-11-02  Dick Porter  <dick@ximian.com>

	* icall-def.h: 
	* object-internals.h: 
	* exception.c (mono_get_exception_thread_interrupted): 
	* threads.c: Implement Thread.Interrupt and Thread.SpinWait.
	Fixes bug 74525.

	* monitor.c (ves_icall_System_Threading_Monitor_Monitor_wait):
	Check for pending Thread.Interrupt.

2006-10-27  Massimiliano Mantione  <massi@ximian.com>
	* loader.c: Fixed bug 79684.

2006-10-27  Dick Porter  <dick@ximian.com>

	* file-io.c (get_file_attributes): Force symlinks to directories
	to be returned as a regular file.  Fixes bug 79733.
2006-10-26  Dick Porter  <dick@ximian.com>

	* file-io.c (ves_icall_System_IO_MonoIO_Open): If we're calling
	CreateFile to open a directory then we need to set the
	FILE_FLAG_BACKUP_SEMANTICS flag.  Fixes bug 75285.

2006-10-23  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_method_get_object): Cache the MonoMethod class and its
	friends.

Mon Oct 23 03:06:06 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* sgengc.c: small cleanup of timer code.

Mon Oct 23 02:49:08 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* sgen-gc.c: fix some warnings and start adding support for
	complete object removal on domain unload.

2006-10-22  Gert Driesen  <drieseng@users.sourceforge.net>

	* assembly.c: build_assembly_name should not consider a version
	number without build or revision number invalid. Fixes bug #79715.

2006-10-18  Jonathan Chambers  <joncham@gmail.com>

	* icall.c: Have ves_icall_System_Diagnostics_DefaultTraceListener_WriteWindowsDebugString
	call kernel32 function OutputDebugString directly.
	
	Signed-off-by: Jonathan Chambers <joncham@gmail.com>
	
Tue Oct 17 16:59:59 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c: small cleanup, using a function to insert a MonoString
	in the string heap.

Tue Oct 17 16:45:27 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c: moving GC fixes.

Mon Oct 16 16:53:12 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* sgen-gc.c, gc-internal.h, gc.c: added API to collect and remove
	all the objects with finalizers belonging to an unloading appdomain.

Mon Oct 16 15:08:41 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* sgen-gc.c: added ability to allocate even when the nursery is fully
	pinned and fixed a couple of bugs.

2006-10-15  Zoltan Varga  <vargaz@gmail.com>

	* threads.h: Revert the last change for now.

	* threads.h (mono_thread_get_pending_exception): Rename this to
	mono_thread_get_undeniable_exception ().

2006-10-15  Gert Driesen  <drieseng@users.sourceforge.net>

	* appdomain.c: Use mono_get_exception_bad_image_format2 to construct
	BadImageFormatException in ves_icall_System_Reflection_Assembly_LoadFrom
	when fname does not refer to valid assembly. This result in a more
	meaningful error message.
	* exception.c: added mono_get_exception_bad_image_format2 which 
	constructs a BadImageFormatException using the ctor taking a custom
	message and the file name. Passing in a NULL msg results in a default
	message.
	* exception.h: define mono_get_exception_bad_image_format2 function.
	* icall.c: in InternalGetAssemblyName, throw BadImageFormatException 
	when file name pointed to an invalid IL image. Use 
	mono_get_exception_file_not_found2 to construct FileNotFoundException,
	as this results in a more meaningful error message.

2006-10-15  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (encode_named_val): Implement proper encoding of arrays. Fixes
	#79465.

2006-10-12  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (mono_type_size): Change the align parameter to guint32 for
	consistency with the other _size functions.
	(mono_type_stack_size): Ditto.

	* class.c object.c icall.c: Fix warnings caused by the above change.

	* class.c (mono_class_get_method_from_name_flags): Fix a typo.

	* image.c (load_metadata_ptrs): Reenable loading of modules with uncompressed metadata.

	* metadata.c class.c loader.c: Add proper support for uncompressed metadata.

Wed Oct 11 17:27:05 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* console-io.h, filewatcher.h, locales.h, marshal.h, monitor.h,
	process.h, rand.h, rawbuffer.h, security-manager.h, security.h,
	socket-io.h, string-icalls.h, sysmath.h, threadpool-internals.h,
	threadpool.h, threads-types.h: mark more internal functions.

2006-10-11  Dick Porter  <dick@ximian.com>

	* socket-io.c (ves_icall_System_Net_Sockets_Socket_Poll_internal):
	Fix typo spotted by Robert Jordan in bug 79352 (though I can't
	reproduce the bug even before applying the fix.)

Tue Oct 10 15:39:39 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c: allow retrieving attributes for arguments in generic
	methods (bug #79241).

Tue Oct 10 11:45:50 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* debug-mono-symfile.c: properly check fopen () result (found by
	coverity).

Tue Oct 10 11:30:52 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c: make error message clearer and fixed two
	issuelets found by Coverity.

2006-10-10  Zoltan Varga  <vargaz@gmail.com>

	* object-internals.h: Remove duplicate definition of mono_method_get_signature_full ().

Mon Oct 9 19:41:44 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* object-internals.h, gc-internal.h, profiler-private.h:
	mark internal functions.

Mon Oct 9 19:28:56 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c: put data in the text section.
	* icall.c: recognize more types in type_from_typename ().
	* process.c, marshal.c: added some GC FIXMEs.

Mon Oct 9 19:27:26 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* loader.c: check for NULL before initializing.

2006-10-09  Zoltan Varga  <vargaz@gmail.com>

	* gc.c (finalizer_thread): Use a non-alertable wait here.

	* class.c loader.c metadata.c: Revert the mono_metadata_decode_table_... changes,
	until the correct solution is found.

2006-10-06  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_module_get_object): Avoid an assert when operating on
	modules with no metadata. Fixes #79596.

	* image.c (load_metadata_ptrs): Put back the error message when
	the #- heap is encountered since the support is not complete yet.

Fri Oct 6 16:57:26 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* gc.c: do not allow the user to SuppressFinalize () a
	delegate because it would leak the trampoline if present.

2006-10-06  Zoltan Varga  <vargaz@gmail.com>

	* class.c metadata.c row-indexes.h blob.h: Applied patch from Jb. Add support for the
	PropertyPtr table.

2006-10-05  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_method_signature): Fix a use of MONO_TABLE_METHOD missed earlier.

	* metadata.c (mono_metadata_get_param_attrs): Ditto.

	* row-indexes.h: Add definitions for *Ptr tables.

	* metadata-internals.h (MonoImage): Add an 'uncompressed_metadata' flag.

	* metadata.c (mono_metadata_translate_token_index): New helper function to
	translate table indexes used in uncompressed metadata.
	(mono_metadata_decode_table_row): Ditto.
	(mono_metadata_decode_table_row_col): Ditto.

	* metadata.c: Add table schema for *Ptr tables.

	* class.c loader.c: Use the new helper function to access the affected metadata
	tables.
	
	* image.c (load_metadata_ptrs): Allow assemblies with uncompressed metadata. Fixes
	#38532.
	
2006-10-04  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_object_to_ptr_conv): Avoid using short branches around IL
	sequences which can be unbounded in size. Fixes #79583.

2006-10-02  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_runtime_class_init): Handle a corner case in handling failure of
	static initialization.

	* domain-internals.h (MonoDomain): Add a 'type_init_exception_hash' field.

	* class-internals.h (MonoVTable): Add an 'init_failed' flag.

	* domain.c (mono_domain_free): Free up type_init_exception_hash.

	* object.c (mono_runtime_class_init): Implement correct semantics when a static
	ctor fails, i.e. throw the same exception on subsequent accesses.
	
2006-09-0  Jonathan Chambers  <joncham@gmail.com>

	* domain.c, class-internals.h: Added ComInteropProxy class to MonoDefaults.
	* marshal.c: Return correct unmanaged size for object when MarshalAs.Struct.
	Emit exception rather than crash in case of COM Callable Wrapper (not yet implemented).
	Handle marshalling of interfaces and VARIANTs contained in structs.
	
	Code is contributed under MIT/X11 license.
	
2006-09-30  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_custom): Fix some corner cases. Fixes	#79471.
	
	* marshal.c (mono_marshal_load_type_info): Allocate memory from the image
	mempool.

2006-09-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* console-io.c: ignore previous SIGINT handler.

2006-09-27  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c class.c: Applied patch from Ricardo Fernandez Pascual 
	(ricardo.fernandez@st.com). Add some new MonoClass and MonoType accessors. Fixes
	#79460, #79461, #79485.

	* class.c (mono_class_from_name_case): Fix incorrect comments. Fixes #79504.

	* marshal.c (mono_marshal_load_type_info): Fix a typo which caused an assert. Fixes
	#79217.

2006-09-26  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_delegate_invoke): Tweak the IL a little so better code
	could be generated from it.

Mon Sep 25 13:29:53 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* rand.c: fix read loop to correctly handle EINTR.

Mon Sep 25 11:33:06 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, icall-def.h, icall.c, verify.c: changed the way
	internal calls are defined to keep methods closer to the declaring
	type and allow a significant reduction in runtime relocations and
	memory usage.

2006-09-21 Gert Driesen  <drieseng@users.sourceforge.net>

        * appdomain.c: Pass NULL to mono_get_exception_file_not_found2 as
        exception message to have FileNotFoundException use the default
        assembly load error message. Fixes bug #79426.
        * exception.c: Support NULL msg in mono_get_exception_file_not_found2.

2006-09-21 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: (start_thread_or_queue) use the root domain when
	creating the thread instead of the async object one.

Thu Sep 21 19:30:04 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* class.c, object.c, class-internals.h, reflection.c:
	for arrays, store element_size inside MonoClass (speedup
	for array object creation).

Thu Sep 21 17:06:43 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c: fixed CodeBase to use the file name and not the module
	name (bug #79365).

Thu Sep 21 12:09:34 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mono-debug.c, mono-debug.h: export find_method as
	mono_debug_find_method ().

Wed Sep 20 19:59:06 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* debug-helpers.c, class-internals.h: added a few functions useful
	when debugging under gdb.

2006-09-19 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* console-io.[ch]: trigger the ConsoleCancelEvent and retrieve
	characters that need special handling.

Tue Sep 19 18:57:38 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mono-config.c: make the os/cpu specification more flexible,
	allowing lists and negation.

2006-09-18  Jonathan Chambers  <joncham@gmail.com>

	* marshal.c: COM Interop fixes. Handle case where method->klass.
	is interface. Handle BSTR/MonoString when null. Use CDECL as 
	calling convention on non-windows platforms. This is for
	compatibility with XPCOM and MainWin COM.
	
	Code is contributed under MIT/X11 license.
	

2006-09-18  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_load_type_info): Handle concurrent and recursive calls
	correctly. Fixes #79217.

	* class-internals.h (MonoClass): Remove unused marshal_info_init_pending field.

Mon Sep 18 16:59:54 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mono-config.c: allow both an os and cpu attribute for dllmap
	and dllentry elemnets to enable a single config file to be used
	for multiple architectures.

2006-09-18  Gert Driesen  <drieseng@users.sourceforge.net>

	* loader.c: MonoLoaderError was cleared too soon on load failure.
	Fixes bug #79424.

Mon Sep 18 15:37:13 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c: use the defining class vtable when accessing a
	static field, not a pobblibly derived class.

2006-09-17  Zoltan Varga  <vargaz@gmail.com>

	* icall.c string-icalls.c: Remove references to unicode.h.

	* unicode.h unicode.c Makefile.am: Remove these unused source files.

	* NOTES: Moved to ../../docs and renamed to thread-safety.txt.

	* marshal.c (mono_marshal_emit_native_wrapper): Add an 'image' argument, 
	indicating the image where custom marshaller types should be looked up.
	(mono_ftnptr_to_delegate): Use the image of the delegate type to look up
	custom marshallers, instead of corlib. Fixes #79425.

2006-09-14  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_object): Fix marshalling of blittable classes and null.

2006-09-14  Jonathan Chambers  <joncham@gmail.com>

	* environment.c (ves_icall_System_Environment_get_ProcessorCount): 
	Implement Environment.ProcessorCount.
	
	* environment.h (ves_icall_System_Environment_get_ProcessorCount): 
	Implement Environment.ProcessorCount.
	
	* icall.c: 
	Add Environment.ProcessorCount icall.
	
	Patch by Jason McFall.

2006-09-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* assembly.c: don't append .exe/.dll when the filename already contains
	one of those extensions.

2006-09-12  Martin Baulig  <martin@ximian.com>

	* class.c (mono_bounded_array_class_get): Also add `IList<object>'
	to array interfaces.

2006-09-11  Martin Baulig  <martin@ximian.com>

	* reflection.c (mono_image_build_metadata): Create the
	MethodImpl's after emitting all types and methods, so we don't
	need another fixup pass for them.

2006-09-11  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_from_name_case): Fix regression introduced by the last
	change.

Mon Sep 11 12:57:15 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* gc-internal.h, appdomain.c, gc.c: force-destroy GC handles on domain
	unload.

2006-09-10  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_method_return_message_restore): Avoid a crash if one of the out
	args is not set. Fixes #78926.

2006-09-08  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_init): Init class->no_special_static_fields from the cached info.

	* image.c (load_class_names): Move this to class.c, and rename it to 
	'mono_image_init_name_cache'.
	(load_modules): Fix a warning.

	* class.c icall.c image.c: Initialize image->name_cache lazily.

	* class-internals.h (MonoGetClassFromName): New hook function to find a class based
	on its name using information in the AOT file.

	* class.c (mono_class_from_name): Use the new hook function.

2006-09-06  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_param_get_objects): Handle enum default parameter values
	correctly.

	* marshal.c (emit_marshal_object): Implement [In, Out] byval marshalling of classes.
	Fixes #79289.
	
2006-09-06  Martin Baulig  <martin@ximian.com>

	* icall.c (mono_lookup_internal_call): Small fix.

2006-09-05  Raja R Harinath  <rharinath@novell.com>

	* debug-mono-symfile.c (mono_debug_open_mono_symbols): Remove
	double g_free.

2006-09-04  Sebastien Pouliot  <sebastien@ximian.com>

	* debug-mono-symfile.c: Fix *some* memory leaks that happens only 
	when --debug is specified.

2006-09-04  Zoltan Varga  <vargaz@gmail.com>

	* class.c (setup_generic_array_ifaces): Fix a warning.

2006-09-04  Miguel de Icaza  <miguel@novell.com>

	* Temporarily remove the patch to assemly.c that checks the
	assembly versions as it breaks our gacutil.

2006-09-03  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (mono_metadata_parse_mh_full): Fix an invalid free.

	* assembly.c (mono_assembly_load_from_full): Avoid loading net 2.0 assemblies into
	a net 1.0 runtime.

	* marshal.c (mono_string_builder_to_utf8): Fix marshalling of StringBuilders
	created using the default ctor. Fixes #79152.
	(mono_string_builder_to_utf16): Ditto.

2006-09-01  Martin Baulig  <martin@ximian.com>

	Fix handling of the generic array interfaces.

	* class-internals.h
	(MonoDefaults): Removed `generic_array_class' and added
	`generic_ilist' class.

	* class.c
	(mono_bounded_array_class_get): Add the new generic array interfaces.
	(setup_generic_array_ifaces): New static method; create vtable
	entries for each method in the generic array interfaces.

	* metadata.c
	(select_container): Allow "parent-less" generic methods.

	* marshal.c
	(mono_marshal_get_generic_array_helper): New public method.

	* icall.c
	(ves_icall_System_Array_InternalArray_GetGenericValueImpl):
	Renamed into ves_icall_System_Array_GetGenericValueImpl() and
	moved the interncall into System.Array.

2006-09-01  Raja R Harinath  <rharinath@novell.com>

	A few more cases of avoiding work on types with ->byref set.
	Has the real fix for #79238
	* icall.c (is_generic_parameter): New helper.
	(ves_icall_Type_GetGenericParameterPosition): Use it.
	(ves_icall_Type_GetGenericParameterAttributes): Likewise.
	(ves_icall_MonoType_get_IsGenericParameter): Likewise.
	(ves_icall_TypeBuilder_get_IsGenericParameter): Likewise.
	(ves_icall_Type_GetGenericTypeDefinition_impl): Return NULL on
	reference types.
	(ves_icall_Type_get_IsGenericTypeDefinition): Return FALSE on
	reference types.
	(ves_icall_Type_get_IsGenericInstance): Likewise.
	(ves_icall_Type_get_IsGenericType): Likewise.

2006-09-01  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_setup_vtable_general): Share identical vtables with the parent
	class if possible.

	* mempool.h (mono_mempool_get_allocated): New helper function.

	* object.c (mono_class_create_runtime_vtable): Fix problem introduced by last
	change.

	* mempool.c: Fix warnings and the calculation of stats.

	* object.c (mono_class_create_runtime_vtable): Fix the AOT optimization.

	* class.c (mono_class_setup_vtable): Update generic_vtable_count stat.

	* loader.c (mono_get_method_from_token): Update method_count stat.

	* class-internals.h (MonoStats): Add some stats.

2006-08-31 Robert Jordan  <robertj@gmx.net>

	* icall.c: Replace the PtrToStringAuto, StringToHGlobalAuto icalls
	with managed variants.
	All code is contributed under the MIT/X11 license.
	
2006-08-31  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (reflection_methodbuilder_to_mono_method): Set 
	method->skip_visibility based up the skipVisibility parameter of DynamicMethods.

	* class-internals.h (MonoMethod): Add a 'skip_visibility' field.

	* marshal.c (mono_marshal_load_type_info): Revert the last change as it can't cope
	with cycles in classes.

	* icall.c (ves_icall_MonoType_get_Name): Add a '&' for byref types. Fixes #79110.

	* marshal.c (emit_marshal_array): Avoid crash when a parameter with type array is 
	missing a [MarshalAs] directive. Fixes #79203.

	* marshal.c (mono_marshal_load_type_info): Fix a race in initializing 
	klass->marshal_info. Fixes #79217.

2006-08-30  Martin Baulig  <martin@ximian.com>

	Committing a patch from Joachim Ante <joe@otee.dk>:
	Add support for binary data symbol stores.

	* debug-mono-symfile.c
	(mono_debug_open_mono_symbol_file): Renamed into
	mono_debug_open_mono_symbols() and added `raw_contents' and `size'
	arguments.

	* mono-debug.c
	(mono_debug_open_image): Added `raw_contents' and `size' args.
	(mono_debug_init_2_memory): New public function.

Fri Aug 25 18:25:23 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c: handle TypedReference in GetTypeCode (bug #79150).

2006-08-23 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* appdomain.c: implement support for ShadowCopyFiles.

2006-08-22  Sebastien Pouliot  <sebastien@ximian.com>

	* string-icalls.c: Add shortcut in ves_icall_System_String_ctor_charp
	when value is NULL (and should remove CID #51).

2006-08-22 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* image.c: moved 2 functions to ../utils.

Tue Aug 22 15:53:29 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* gc.c: cope with the target object of a GC handle being NULL
	(bug #78877).

Tue Aug 22 11:10:33 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* class.c: recursively check parent's explicit implementations
	of interface methods (fixes bug #79125).

2006-08-19  Miguel de Icaza  <miguel@novell.com>

	* filewatcher.c: Avoid warnings when building, do not redefine
	constants that are defined.

	Remove warnings.

2006-08-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* image.c: don't fail when the link points to an absolute path.

2006-08-18  Sebastien Pouliot  <sebastien@ximian.com>

	* decimal.c: Remove dead code (unrequired check) in mono_decimalIncr.
	Fix CID #3.

2006-08-17  Miguel de Icaza  <miguel@novell.com>

	* image.c (full_path): A new method used to obtain the actual path
	of an assembly even in the presence of symbolic links.  

	This is necessary for the case where we are running a binary that
	has been GACed, but we are using the "published" path name
	($prefix/mono/1.0/blah.exe) which happens to point to the real
	file in the GAC.

	This was the source of the failure for the `xsp' command with the
	recent AppDomain changes, as far as the runtime was concerned,
	there were two different assemblies: $prefix/mono/1.0/blah.exe and
	$prefix/mono/gac/blah/version/blah.exe.

	(do_mono_image_open): use full path

2006-08-17  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_class_create_runtime_vtable): Add a FIXME.

2006-08-17  Sebastien Pouliot  <sebastien@ximian.com>

	* marshal.c: Fix mono_marshal_check_domain_image if an invalid 
	domain_id is supplied. Fix CID #241 and corlib's unit tests.

2006-08-17  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_layout_fields): Set min_align to a bigger value for
	small structures. Fixes #78990.

2006-08-17  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_xappdomain_invoke): Use the new helper functions here.

	* appdomain.c (ves_icall_System_AppDomain_createDomain): Fix a warning.

2006-08-16 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* appdomain.c:
	* marshal.c: don't load all the assemblies from a domain into newly
	created ones. The new domains might have different rules and load
	assemblies from different locations. Fixes bug #76757.

	Patch by Lluis. Conflicts resolved by Brian Crowell.

2006-08-16  Alp Toker  <alp@atoker.com>

	* socket-io.c: First half of the fix for #79084.
	Set sa_size to the length of the content, not that of the struct.
	Don't add NULL suffix to the content, this should be done in
	managed code if needed.

2006-08-14  Raja R Harinath  <rharinath@novell.com>

	Fix part of #79012
	* metadata.c (do_mono_metadata_parse_generic_class): Don't SEGV if
	mono_metadata_parse_type returns NULL.

2006-08-13  Atsushi Enomoto  <atsushi@ximian.com>

	* normalization-tables.h : new file for string normalization data.
	* locales.c, locales.h, icall.c :
	  added load_normalization_resource() for string normalization,
	  and icall as well.
	* Makefile.am : added normalization-tables.h to the sources.

2006-08-13  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c: Add more helper functions to reduce code duplication and use them
	everywhere.

2006-08-12  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c: Fix non-x86 stdcall warnings.
	
	* marshal.c marshal.h: Add some helper functions to emit/patch branches, and use 
	them everywhere.

2006-08-11  Jonathan Chambers  <joncham@gmail.com>

	* class.c (mono_bounded_array_class_get): Fix if statement that caused incorrect
	type check on multi-dimensional arrays. Fixes #79000.

2006-08-10  Jonathan Chambers  <joncham@gmail.com>

	* class.c (mono_class_setup_parent): setup is_com_object during class initialization.
	* object.c (mono_remote_class_vtable/mono_object_new_specific): Changed checks
	to use is_com_object instead of MONO_CLASS_IS_IMPORT() macro.
	* class-internals.h: add is_com_object to class structure.
	* marshal.c: Fixed marshalling for IDispatch and IUnknown, added
	null checks to COM object marshalling. Fix .ctor call on RCW.
	* icall.c: Added icall implementation for MonoType.IsCOMObjectImpl.
	
	All code is contributed under the MIT/X11 license.

2006-08-09  Dick Porter  <dick@ximian.com>

	* monitor.c (mono_monitor_cleanup): mono_monitor_cleanup() is
	racing mono_monitor_allocator_lock() somewhere, so don't delete
	the critical section for now.  Found by running and exiting
	monodevelop.

2006-08-10  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (cominterop_get_native_wrapper): Fix a warning.
	(ves_icall_System_ComObject_FindInterface): Ditto.
	(ves_icall_System_ComObject_CacheInterface): Ditto.

	* metadata.c (do_mono_metadata_type_equal): Applied patch from Roberto Costa
	(roberto.costa@st.com). Add support for MONO_TYPE_FNPTR.

2006-08-09 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: treat pipes from process asynchronous reads as sockets
	when reading from them, so we get select/poll or epoll to wait for
	data.

2006-08-07  Sebastien Pouliot  <sebatien@ximian.com>

	* loader.c: Fix a typo (CID #233) in the null check.

2006-08-07  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (mono_domain_unload): Close the thread handle of the unload thread.
	Hopefully fixes #78949.
	
	* metadata.c (mono_metadata_parse_method_signature_full): Applied patch from 
	Roberto Costa (roberto.costa@st.com). Handle vararg signatures without SENTINEL
	bytes. Fixes #78972.

2006-08-03 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* filewatcher.c: we need to set errno here.

2006-08-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* filewatcher.c: let Win32Exception get the error value.

2006-08-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* filewatcher.c: translate errno into win32 errors for Win32Exception
	to know what happened.

2006-08-01  Zoltan Varga  <vargaz@gmail.com>

	* threadpool.c: Fix more warnings.

	* assembly.c (search_loaded): Fix warnings.

	* threadpool.c (mono_thread_pool_finish): Fix warnings.
	(mono_async_invoke): Ditto.

2006-07-28  Jonathan Chambers  <joncham@gmail.com>

	* object.c (mono_remote_class_vtable): Need to create proxy vtable
	entries for __ComObject type in addition to ComImport types.
	* marshal.c: Added support for marshalling COM RCWs. Fixed warning
	about hash table.
	
	All code is contributed under the MIT/X11 license.

Fri Jul 28 19:04:34 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* image.c: avoid tentative loading of modulerefs that contain
	no metadata (P/Invoke library names).

2006-07-28  Dick Porter  <dick@ximian.com>

	* loader.c (mono_loader_cleanup): mono_loader_cleanup() is racing
	mono_loader_lock() somewhere, so don't delete the critical section
	for now.  Found by running and exiting monodevelop.

2006-07-26 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* filewatcher.c: define the inotify syscalls when we're building on
	linux and have sys/syscall.h. The build system might not have support
	for inotify but the target system might have it.

2006-07-26  Miguel de Icaza  <miguel@novell.com>

	* domain.c: Documentation updates.

	* loader.c (mono_free_method): Do not release the method
	information if we are being profiled, as profilers will use this
	information at shut down to present some data to the user.

	This is needed so that the profiler does not crash, as the
	profiler tends to keep MonoMethods around, and they might become
	invalid if we free these.

	(mono_get_method_constrained): Return the original CIL stream
	method as well, so verification can be performed against it.

2006-07-25 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* filewatcher.[ch]: support for inotify file system watcher.
	* icall.c: add new internal calls for the inotify file system watcher.

2006-07-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: Windows also misbehaves on async. connects. Fixes bug
	#78888.

2006-07-20  Dick Porter  <dick@ximian.com>

	* file-io.c (ves_icall_System_IO_MonoIO_Seek): Fix signed/unsigned
	warning.

2006-07-20  Dick Porter  <dick@ximian.com>

	* threads.c (start_wrapper): Do the thread cleanup while we still
	hold a reference to its object.  Fixes bug 78123.

2006-07-18  Kornél Pál  <kornelpal@gmail.com>

	* class-internals.h: Added MONO_WRAPPER_MANAGED_TO_MANAGED wrapper type.
	* debug-helpers.c: Map MONO_WRAPPER_MANAGED_TO_MANAGED to
	  "managed-to-managed".
	* icall.c: Redirect string constructors that take sbyte* to
	  ves_icall_System_String_ctor_RedirectToCreateString.
	* marshal.c: Redirect ves_icall_System_String_ctor_RedirectToCreateString
	  to CreateString () methods with matching signature.
	* reflection.c: Use original security informations for
	  MONO_WRAPPER_MANAGED_TO_MANAGED.
	* security-manager.c: Use original security informations for
	  MONO_WRAPPER_MANAGED_TO_MANAGED.
	* string-icalls.c: Added ves_icall_System_String_ctor_RedirectToCreateString
	  that is a placeholder and only its address should be used.
	* string-icalls.h: Added ves_icall_System_String_ctor_RedirectToCreateString
	  that is a placeholder and only its address should be used.

2006-07-15  Jonathan Chambers  <joncham@gmail.com>

	Begin implementing COM Interop.
	* appdomain.c: Increment corlib version.
	* class.c: Set ComImport classes' parent to __ComObject.
	* loader.c: Mark cominterop methods as such.
	* domain.c: Add __ComObject class to MonoDefaults structure.
	* image.c: Add 2 hashtables to the image for COM Interop related methods
	* metadata.c: Added mono_metadata_type_dup_mp to duplicate a type
	using the mempool allocator
	
	* metadata-internals.h: Add 2 hashtables to the image for COM Interop related methods
	* metadata.h: Added cominterop field to _MonoMethodSignature struct and
	declaration for mono_metadata_type_dup_mp.
	
	* debug-helpers.c: Added strings for two additional wrapper types
	* object.c: Create proxy objects for ComImport classes
	* class-internals.h: Define 2 new method wrapper types, COM Interop remoting target,
	and added __ComObject class to MonoDefaults structure.
	
	* object-internals.h: Finish MonoRealProxy definition, and add definition of
	MonoComInteropProxy and MonoComObject.
	
	* marshal.c: Added support for COM Interop
	(signature_cominterop): Converts managed signature to corresponding
	unmanaged COM signature.
	(cominterop_get_function_pointer): gets unmanaged function pointer via
	COM object vtable
	(cominterop_get_com_slot_for_method): returns vtable slot in COM interface of method
	(cominterop_get_method_interface): returns interface type that method is defined on
	(mono_mb_emit_cominterop_call): emits native call to function pointer
	gotten from vtable
	(cominterop_get_native_wrapper_adjusted): actual wrapper around unmanaged COM call
	that matches signature of unmanaged function.
	(cominterop_get_native_wrapper): wrapper around adjusted method call.
	(cominterop_get_invoke): forwards call from proxy to __ComObject
	(ves_icall_System_Runtime_InteropServices_Marshal_AddRef): Implements Marshal.AddRef 
	(ves_icall_System_Runtime_InteropServices_Marshal_QueryInterface): Implements Marshal.QueryInterface 
	(ves_icall_System_Runtime_InteropServices_Marshal_Release): Implements Marshal.Release 
	
	* marshal.h: Added Marshal icall declarations.
	* icall.c: Added __ComObject icalls. Need to store interfaces in unmanaged code
	so we can access them in finalizer
	
2006-07-14  Dick Porter  <dick@ximian.com>

	* object.c (mono_type_initialization_cleanup): Fix a race
	condition by temporarily commenting out the critical section
	deletion.

2006-07-14  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (create_custom_attr): Fix some warnings.
	(create_custom_attr_data): Ditto.
	(typebuilder_setup_properties): Save custom attrs for properties in dynamic
	types. Fixes #78855.

2006-07-11  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_type_get_name_recurse): Fix the name of 1 dimensional non-szarrays.

	* reflection.c (mono_custom_attrs_free): Fix freeing of dynamic cattr info.

2006-07-08  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (resolve_object): Add support for DynamicMethod.

	* domain.c appdomain.c threads.c monitor.c object.c gc.c: Applied patch from
	Joachim Ante (joe@otee.dk). Fix some shutdown leaks.

2006-07-06  Sebastien Pouliot  <sebastien@ximian.com>

	* process.c: In ves_icall_System_Diagnostics_Process_GetModules_internal 
	don't leak GPtrArray's pdata has we have no use (nor free) for it.

2006-07-01  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Fix passing of generic valuetypes.
	Fixes #77888.

2006-06-30  Raja R Harinath  <rharinath@novell.com>

	* icall.c (ves_icall_MonoMethod_get_base_definition): Simplify
	slightly: remove a shadow local variable.

2006-06-29  Raja R Harinath  <rharinath@novell.com>

	* icall.c (ves_icall_MonoMethod_get_base_definition): Return the
	definition that introduces the virtual function slot.
	Also fix Coverity #105.

2006-06-29  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Reflection_Assembly_GetTypes): Fix support
	for dynamic assemblies. Fixes #78724.

2006-06-28  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_string_to_byvalwstr): Fix this completely broken function.
	Fixes #78722.

2006-06-21  Martin Baulig  <martin@ximian.com>

	* reflection.c
	(method_encode_clauses): Don't assert on `ex_info->handlers' here;
	fixes #76484.

2006-06-21  Zoltan Varga  <vargaz@gmail.com>

	* object.h (mono_array_setref): Cast value to (MonoObject*) to fix warnings.

2006-06-20  Raja R Harinath  <rharinath@novell.com>

	Make 'mono_class_get_full' only inflate TYPESPECs, not TYPEDEFs
	nor TYPEREFs.
	* class.c (mono_class_create_from_typespec): Add 'context' argument.
	Inflate result if necessary.
	(mono_class_get_full): Remove old version.  Rename from
	'mono_class_get' and add 'context' argument.  Pass it to
	..._create_from_typespec.
	(mono_class_get): New.  Simple wrapper to mono_class_get_full.
	(mono_ldtoken): Revert change below.

2006-06-20  Martin Baulig  <martin@ximian.com>

	* class.c (mono_ldtoken): Don't pass the generic context to
	mono_class_get_full() for MONO_TOKEN_TYPE_DEF/REF.  Fixes #78053.

2006-06-15  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_ftnptr_to_delegate): Avoid allocating signature from mempool
	and later freeing it. Fixes #78638.

2006-06-15  Miguel de Icaza  <miguel@novell.com>

	* icall.c (mono_class_get_throw): Revert over-zealous error
	throwing, the caller for mono_class_get_throw will cope with
	errors when classes are not properly initialized already.

	The code still copes with loader exceptions though.

	Fixes the regression in reftype1 and reftype3 from the CAS tests.
	
2006-06-14  Miguel de Icaza  <miguel@novell.com>

	Fixes the `make run1' version of RuntimeAbort (to be commited,
	source is in Bugzilla).
	
	* metadata.c (mono_metadata_interfaces_from_typedef_full): Return
	FALSE on class loading failure instead of returning true.

	* class.c (mono_class_create_from_typedef): It is possible for
	mono_metadata_interfaces_from_typedef_full to fail if a class is
	not found, cope with this.
	

2006-06-14  Dick Porter  <dick@ximian.com>

	* socket-io.c: 
	* process.c: Fix a bunch of signed/unsigned warnings from gcc
	4.1.1

2006-06-12  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : oops, forgot to make it nsync with r61548.

2006-06-09  Jonathan Chambers  <jonathan.chambers@ansys.com>

	* icall.c: Another fix for building mono in Visual Studio.

2006-06-09  Jonathan Chambers  <jonathan.chambers@ansys.com>

	* marshal.c icall.c: Minor fixes for building mono in Visual Studio.
	
2006-06-09  Martin Baulig  <martin@ximian.com>

	* debug-mono-symfile.c: Put this back and really fix it this
	time. Sorry for all the trouble.

2006-06-08  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (mono_class_get_throw): Fix a warning.
	(ves_icall_System_Reflection_Assembly_GetTypes): Allways throw 
	ReflectionTypeLoadException if needed. Fixes #78606.

	* class.c (mono_class_setup_vtable_general): Handle loader errors a bit better.
	(mono_class_init): Ditto.

	* loader.c (mono_loader_set_error_assembly_load): Display a separate warning for
	ref_only exceptions.
	(mono_loader_clear_error): Make this work even if there is no error.

2006-06-08  Jonathan Chambers  <jonathan.chambers@ansys.com>

	* object-internals.h marshal.c marshal.h icall.c: Implement method 
	Marshal.GetComSlotForMethodInfo using internal call.

2006-06-07  Zoltan Varga  <vargaz@gmail.com>

	* class-internals.h: Add a new kind of loader error LOADER_ERROR_ASSEMBLY plus
	a function for signalling it.

	* class.c (mono_class_from_typeref): Use the new kind of loader error when
	a referenced assembly is not found.

	* loader.c (mono_loader_error_prepare_exception): Add support for 
	LOADER_ERROR_ASSEMBLY. Fix formatting.

2006-06-05  Jonathan Chambers  <jonathan.chambers@ansys.com>

	* domain.c appdomain.c class-internals.h marshal.c: Add support 
	for VARIANT marshalling on windows and increment corlib version
	since Variant struct was added.

2006-06-03  Miguel de Icaza  <miguel@novell.com>

	* debug-mono-symfile.c: Revert Martin's previous patch which broke
	stack trace line information:

	(Martin) (mono_debug_symfile_lookup_location): Fix the algorithm:
	(Martin) when looking up B which is between A and C, return A not C.

	Bug is #78573.

	Thanks to Alexander Olk for tracking this down.

2006-06-02  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_set_last_error_windows): Fix build.
	
	* marshal.c (mono_marshal_emit_native_wrapper): Call GetLastError () early and without a wrapper to
	avoid clobbering its value.
	(mono_string_to_lpstr): Fix a warning on windows.

2006-05-31  Zoltan Varga  <vargaz@gmail.com>

	* class-internals.h (MonoClass): Removed obsolete 'dummy' flag.

	* reflection.c loader.c: Removed references to 'dummy' flag.

	* loader.c (mono_loader_error_prepare_exception): Fix a warning.

	* threadpool.c: Make ASyncCall a copy of the managed MonoAsyncCall class so
	it gets GC tracking.

	* object-internals.h (MonoAsyncResult): Add an 'object_data' field which has
	GC tracking.
	
	* object.c (mono_async_result_new): Add an additional parameter 'object_data'.

	* marshal.c threadpool.c: Update callers of mono_async_result_new.

	* appdomain.c: Bump corlib version.

2006-05-30  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c: Use mono_mb_emit_stloc in more places. Use CEE_LDIND_REF and
	CEE_STIND_REF when working with object references.

2006-05-31  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_setup_fields): Call mono_class_init () for class->parent.
	Fixes #78539.

2006-05-30  Miguel de Icaza  <miguel@novell.com>

	* loader.c (method_from_memberref): Fix argument value for
	mono_loader_set_error_method_load (I was passing the MonoClass
	instead of the class name char *).

2006-05-30  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c: Use mono_mb_emit_stloc in more places. Use CEE_LDIND_REF and
	CEE_STIND_REF when working with object references.

2006-05-30  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (mono_debug_print_stack_frame): Reverted the
	mono_method_full_name() change and replace the ':' with a '.'
	here.

2006-05-30  Martin Baulig  <martin@ximian.com>

	* debug-mono-symfile.c
	(mono_debug_symfile_lookup_location): Fix the algorithm:
	when looking up B which is between A and C, return A not C.

2006-05-29  Martin Baulig  <martin@ximian.com>

	* mono-debug.h
	(MonoDebugMethodInfo): Make the typedef public.
	(MonoDebugSourceLocation): New public struct.

	* mono-debug.c
	(mono_debug_source_location_from_address): Removed.
	(mono_debug_source_location_from_il_offset): Removed.
	(mono_debug_il_offset_from_address): Removed.
	(mono_debug_address_from_il_offset): Removed.
	(mono_debug_lookup_method): New public function.
	(mono_debug_lookup_source_location): New public function; replaces
	the old mono_debug_source_location_from_*() functions; see the
	inline documentation.
	(mono_debug_free_source_location): New public function.
	(mono_debug_print_stack_frame): New public function; see the
	inline documentation.

	* debug-mono-symfile.c
	(mono_debug_find_source_location): Renamed into
	mono_debug_symfile_lookup_location(); only take a
	`MonoDebugMethodInfo *' and an `offset' argument; added inline
	documentation.
	(mono_debug_find_method): Renamed into
	mono_debug_symfile_lookup_method().

2006-05-27  Zoltan Varga  <vargaz@gmail.com>

	* assembly.c (mono_assembly_open_full): Dont overwrite the status
	returned by mono_image_open_full ().

	* appdomain.c (ves_icall_System_Reflection_Assembly_LoadFrom): Convert
	MONO_IMAGE_IMAGE_INVALID into a BadImageFormatException. Fixes
	#78517.

	* object.c (compute_class_bitmap): Use class->class_size for static fields. Fixes
	#78518.

2006-05-27  Miguel de Icaza  <miguel@novell.com>

	* class.c (mono_class_from_typeref): handle missing images
	earlier, deals with bug #78418.   Refactor code; 

	Fix a warning introduced in my previous commit (some stale code
	from before I revisited my patch).

	* class.c (mono_class_create_from_typedef): On failure, remove the
	class from the MonoImage->class_cache as the class is not
	initialized;   Fixes the leak pointed out by Paolo.

2006-05-25  Dick Porter  <dick@ximian.com>

	* threads.c (mono_thread_cleanup): Build fix.  Comment out the
	DeleteCriticalSections until I figure out which one may still be
	sometimes locked when mono_thread_cleanup is called.

2006-05-24  Dick Porter  <dick@ximian.com>

	* threads.c (mono_thread_cleanup): Move the threading cleanup out
	of mono_thread_manage and back into its own function, so it can be
	called after the finalizer thread has finished.

	* appdomain.c (mono_runtime_cleanup): Call mono_thread_cleanup

2006-05-24  Zoltan Varga  <vargaz@gmail.com>

	* assembly.c (mono_assembly_open_full): Fix typo introduced by a previous change.
	Fixes #78495.

	* marshal.c (emit_ptr_to_object_conv): Implement marshalling of byval arrays
	with non-blittable elements.
	(emit_object_to_ptr_conv): Ditto. Fixes #78492.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.h (MonoDebuggerEvent): Added
	`MONO_DEBUGGER_EVENT_FINALIZE_MANAGED_CODE'.	

	* mono-debug-debugger.c (mono_debugger_cleanup): Send a
	`MONO_DEBUGGER_EVENT_FINALIZE_MANAGED_CODE' and then set
	`mono_debugger_event_handler' to NULL.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* mono-debug.h (MONO_DEBUGGER_VERSION): Bump to 57.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.h
	(mono_debugger_create_notification_function): Added
	`MonoCodeManager *' argument.

Tue May 23 16:05:47 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* boehm-gc.c, null-gc.c: fix compilation on 64 bit systems.

Tue May 23 13:44:11 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, gc-internal.h, reflection.c: updates for the new GC.
	* sgen.-gc.c, sgen-gc.h: simple generational compacting GC
	implementation.

Tue May 23 13:40:30 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c: precise GC support: objects can't be stored in unmanaged
	memory anymore, even if they are kept alive by other references: since
	they can move the GC needs to be able to always find them.

Tue May 23 12:57:08 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* object.c: precise GC support for static fields. Support
	for moving GCs: write barriers and pinned allocation for interned
	strings.

Tue May 23 12:41:44 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* domain.c, domain-internals.h: precise GC support for the MonoDomain
	structure.

Tue May 23 12:38:56 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* class.c, gc.c: sgen and precise GC updates.

Tue May 23 12:33:24 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* marshal.h, marshal.c: added write barrier wrapper and precise type
	fixes.

Tue May 23 12:31:22 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* object.h, null-gc.c, boehm-gc.c: more write barrier functions and
	support.

Tue May 23 12:27:14 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c: precise and sgen GC updates.

Tue May 23 12:21:46 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* debug-helpers.c, class-internals.h: added write barrier wrapper type.

2006-05-22  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (start_wrapper): Fix a missed guint32 tid declaration.

2006-05-20  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (encode_cattr_value): Fix yet another bug in the encoding of
	MONO_TYPE_OBJECT. Fixes #78462.

2006-05-18  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_vtype): Add support for UnmanagedType.LPStruct 
	and blittable types.

2006-05-17  Miguel de Icaza  <miguel@novell.com>

	* class.c (mono_class_get_exception_for_failure): Implement parts
	of a TODO: if the loader error is set (instead of the class
	error), we return a Loader exception that can be properly thrown
	elsewhere.

	This was exposed by some Winforms 2.0 code that I tried to run
	(Atsushi pointed me to it).

2006-05-17  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_emit_native_wrapper): Make the marshalling code more
	uniform by moving stuff from this function to the proper emit_marshal_XXX functions.
	
	* marshal.c (emit_marshal_vtype): Add limited support for 
	UnmanagedType.LPStruct. Fixes #78427.

	* marshal.c (ves_icall_System_Runtime_InteropServices_Marshal_PtrToStructure): 
	Applied a patch from kangaroo to fix #77523.

2006-05-17  Martin Baulig  <martin@ximian.com>

	* threads.c
	(debugger_thread_vtable): Moved into ../mini/debug-debugger.c.
	(debugger_thread_created): Removed.
	(debugger_thread_exited): Removed.

2006-05-15  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (MONO_CORLIB_VERSION): Bump corlib version.

	* object-internals.h (MonoReflectionResource): Sync with managed version.

2006-05-12  Wade Berrier <wberrier@novell.com>

	* threads.c: Define G_GSIZE_FORMAT for systems with glib < 2.6

2006-05-12  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_fnptr_class_get): Set class->image to corlib for now, since other
	functions try to allocate from the image mempool.

2006-05-12  Dick Porter  <dick@ximian.com>

	* threads.c (mono_thread_attach): Fix usage of GetCurrentThread().

2006-05-12  Lluis Sanchez  <lluis@ximian.com>

	* object.c: The FieldGetter and FieldSetter methods require the full
	name of the class, not only the name. Fixes bug #78277.

2006-05-11  Miguel de Icaza  <miguel@novell.com>

	* loader.c (method_from_memberref): Do not pass the NULL klass to
	mono_loader_set_error_() methods.  Pass the non-NULL value
	(class). 

2006-05-11  Zoltan Varga  <vargaz@gmail.com>

	* assembly.c (mono_assembly_load_from_full): Fix a bunch of warnings.
	(mono_assembly_close): Null out assembly->image->references after freeing it.

	* image.c (mono_image_close): Free image->references.
	
	* reflection.c (mono_image_basic_init): Fix a small memory leak.

2006-05-10  Sebastien Pouliot  <sebastien@ximian.com>

	* marshal.c: In function mono_mb_add_local don't use the mb pointer 
	before checking if it's NULL (g_assert).

2006-05-10  Martin Baulig  <martin@ximian.com>

	* metadata.c (mono_type_size): Kill the g_assert() in MONO_TYPE_GENERICINST;
	I thought I already killed that two months ago, but now it somehow reappeared.

2006-05-10  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (mono_debug_add_method): Allow instantiated generic methods.

2006-05-10  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c: Allocate memory for dynamically created methods in the image
	mempools.

2006-05-10  Sebastien Pouliot  <sebastien@ximian.com>

	* appdomain.c: In ves_icall_System_AppDomain_[Get|Set]Data functions, 
	don't use the ad pointer before checking if it's NULL (g_assert).

2006-05-09  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Reflection_Assembly_InternalGetAssemblyName): Remove
	a redundant (and incorrect) addref. Hopefully fixes sn.exe on windows.

	* marshal.c: Allocate all signatures from mempools.

	* marshal.c: Allocate some more signatures from mempools.

2006-05-09  Miguel de Icaza  <miguel@novell.com>

	* object.c (mono_load_remote_field): The code used to provide a
	temporary variable for returning results if the user did not
	provide a result pointer.  But our temporary variable was allocted
	on the satck.

	Fix calling code to always pass a result area.   Coverity ID 103.

2006-05-06  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (ves_icall_System_Threading_Interlocked_Add_Int): Return the new
	value, not the old. Fixes #78312.
	(ves_icall_System_Threading_Interlocked_Add_Long): Ditto.

	* class.c (mono_bounded_array_class_get): Allocate data from the image mempool.
	(mono_ptr_class_get): Ditto. Also change the cache from a global one to a 
	per-image cache.

	* assembly.c (mono_assembly_close): Free image->references.

	* assembly.c (mono_assembly_names_equal): Fix a warning.
	(mono_assemblies_cleanup): Cleanup more global data.

	* metadata-internals.h (MonoImage): Add 'ptr_cache'.

	* image.c (mono_image_close): Free up the contents of 'array_cache', free up
	ptr_cache and image->modules.

	* image.c (mono_image_init): Allocate array_cache lazily.
	
2006-05-05 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* assembly.c: use GetCurrentThreadId for the hash, as GetCurrentThread
	behavior was changed recently and has bad side effects.

2006-05-05  Zoltan Varga  <vargaz@gmail.com>

	* assembly.c (mono_assembly_open_full): Add a missing mono_image_close ().
	
	* assembly.c (mono_assembly_close): Remove a debug printf.

	* profiler.c (create_profiler): Use mono_aligned_addr_hash.

	* metadata-internals.h image.c assembly.c: Change the reference counting scheme
	to also allow for temporary references between mono_image_open ()/close ().

	* domain.c (get_runtimes_from_exe): Add a FIXME.	

2006-05-04  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c: Fix support for dynamic methods.

	* appdomain.c (mono_runtime_cleanup): Call mono_marshal_cleanup ().

	* marshal.c (mono_marshal_cleanup): New cleanup function.

	* marshal.c: Rewrite the wrapper code to allocate most of its memory from the 
	image mempools.

	* class.c (mono_class_init): Fix leaking class->nested_classes.

	* metadata-internals.h (MonoImage): Add a couple of new wrapper caches.

	* image.c (mono_image_init): Initialize the new cashes.

	* image.c (mono_image_close): Destroy the new cashes.

	* marshal.c: Get rid of most of the static caches in favor of per-image caches.

	* mempool.c (mono_mempool_strdup): New helper function.

	* class-internals.h: Add prototype for mono_loader_unlock ().

	* domain.c (mono_jit_info_table_find): Fix a warning.
	(mono_debugger_check_runtime_version): Ditto.

	* rawbuffer.h rawbuffer.c metadata-internals.h metadata.c class-internals.h 
	class.c loader.c image.h image.c assembly.h assembly.c: Add init () and cleanup ()
	functions to these modules.

	* domain-internals.h domain (mono_cleanup): New internal method to cleanup most
	metadata modules.
	
	* marshal.c (mono_free_bstr): Fix a warning.

	* assembly.c (mono_assembly_open_full): Fix another small leak.

	* object.c: Fix some unload leaks in the remoting code.

	* object-internals.h object-internal.c (mono_string_to_utf8_mp): New helper
	function.

	* assembly.c (mono_assembly_close): Fix a leak when unloading dynamic assemblies.

	* reflection.c: Fix some unload leaks in dynamic assemblies.

2006-05-02  Jonathan Chambers  <jonathan.chambers@ansys.com>

	* marshal.c: Add BSTR support on Win32 (all changes under MIT X11)
	* marshal.h: Add BSTR support on Win32
	* icall.c: Add BSTR icalls
	* metadata.h: Add BSTR enums

2006-04-28  Miguel de Icaza  <miguel@novell.com>

	Work to catch the crash from #76795 and turn it into an
	exception.   As I stubbed out pieces of the VisualBasic support,
	I found a number of places where the code was failing and I added
	checks to those places. 
	
	* metadata.c (do_mono_metadata_parse_generic_class): Make this
	function return a status code.  If we fail to parse the signature
	from mono_metadata_parse_generic_inst, return FALSE.

	* loader.c (mono_get_method_from_token): If we fail to load the
	method (mono_class_get) return NULL.   

	* (method_from_memberref): Return NULL if we are unable to parse
	the method signature

	(mono_loader_error_prepare_exception): Since we now use the
	loader_error flag internally to stop processing, and obtaining
	exceptions that might be thrown will walk this code path the
	proper way of going from a MonoLoaderError into a
	MonoException was convoluted.   This new routine encapsulates the
	process of turning the error into an exception and *clearing* the
	error afterwards.
	
2006-04-27  Miguel de Icaza  <miguel@novell.com>

	Work to catch the crashes from 75075 (cope in Assembly.GetTypes
	with missing assemblies), and to cope with:

		* Missing fieldref from a non-existing assembly.
		* Missing methodref from a non-existing assembly.

	The first batch of work to address *some* of the issues from 76661.
	
	* object.c (mono_class_create_runtime_vtable): If we fail to
	initialize the class raise the exception here. 

	* metadata.c (mono_class_get_overrides_full): If any methods fail
	to load return the failure to the caller.

	* assembly.c: Use REFERENCE_MISSING instead of (gpointer) -1 for
	flagging assemblies that failed to load.   

	Do not crash if we are unable to load the assembly.

	(mono_assembly_close): Do nothing with REFERENCE_MISSING
	assemblies. 

	* loader.c (mono_loader_set_error_type_load): Change the
	convention to always pass unallocated strings, so we make our own
	copies (I know our own code had duplicated strings before, but
	this keeps the normal conventions).
	(method_from_memberref): Call mono_loader_set_error_method_load
	for all possible failures of loading the class. 
	Remove assert, turn into a loader error.

	(mono_loader_error_to_exception): Move this routine from mini
	(mini_loader_error_to_exception) there was no need to have that in
	mini. 

	* class.c (mono_class_from_typeref): If we were not able to load
	the assembly with mono_assembly_load_reference, call the
	mono_loader_set_error_type_load to register the problem.

	(mono_class_setup_fields): If we fail to load the type from
	mono_metadata_parse_type_full, call mono_class_set_failure and
	break from the loop.

	If class->exception_type is set, we do not layout the fields as
	that might crash the runtime, and instead return (from breaking
	from the previous loop).

	(mono_class_setup_vtable): This now returns a boolean indicating
	whether the table was properly setup.   The decision is driven by
	mono_class_get_overrides_full which might run into non-existing
	methods. 
	
	(mono_class_init): Returns TRUE on success or FALSE if there was a
	problem in loading the type (incorrect assemblies, missing
	assemblies, methods, etc).

	When we call mono_class_setup_fields we also check for a potential
	error inside this call (either a class exception or a general
	loader exception).

	(mono_class_create_from_typedef): If the parent fails to load
	(calling mono_class_get_full) return NULL.
	
	** Important **

	calls to mono_metadata_parse_type_full should be checked
	everywhere and set the mono_class_set_failure
	(MONO_EXCEPTION_TYPE_LOAD) if we are not able to get the type.

	The current patch checks the places where my manually constructed
	tests show the errors are showing up, but we should do it
	everywhere. 

	** Important2 **

	mono_class_init return values should be tested everywhere, like
	the previous case this is something that we should audit
	everywhere and not only on the cases exposed by the tests I
	created. 

2006-04-26  Miguel de Icaza  <miguel@novell.com>

	* file-io.c (ves_icall_System_IO_MonoIO_Open): Remove `async'
	boolean parameter and instead pass the information on `options'
	parameter (FileOptions).

	* icall.c: Register the new signature for MonoIO.Open.

	* debug-helpers.c (dis_one): Trying to understand how coverity
	works.  Fix Run 5, item 78.

2006-04-26  Dick Porter  <dick@ximian.com>

	* socket-io.c (hostent_to_IPHostEntry2): Explicitly check for NULL
	dereference.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* mono-debug.h (MONO_DEBUGGER_VERSION): Bump to 56.

	* threads.c (mono_thread_attach): Set `thread->stack_ptr' and call
	debugger_thread_created().
	(debugger_gc_push_all_stacks): Don't handle the main thread in any
	special way.
	(mono_debugger_init_threads): Removed the `main_thread_stack' arg.
	(mono_debugger_finalize_threads): New function; undo the effects
	of mono_debugger_init_threads().
	(mono_debugger_create_all_threads): Removed.

2006-04-24  Zoltan Varga  <vargaz@gmail.com>

	* image.c (mono_image_close): Tidy up trace messages.

	* assembly.c (mono_assembly_close): Ditto.

	* assembly.c (mono_assembly_close): Clear out image->assembly so the image
	no longer references an already freed assembly. Fixes #78168.

2006-04-21  Dick Porter  <dick@ximian.com>

	* threads.c (mono_thread_detach): Fix reference counting when
	detaching threads.

2006-04-21  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Enum_ToObject): Improve exception messages. Fixes
	#78155.

2006-04-19  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_type_to_ldind): New helper function moved here from mini.c
	(mono_type_to_stind): Ditto.

	* marshal.c: Use the new helper functions to simplify code.

	* image.c (mono_image_close): Add some code for help debug assembly unloading
	problems.

	* metadata.c (mono_metadata_parse_type_full): Allocate MonoType's from the
	image mempool.

	* assembly.c (mono_assembly_open_full): Invoke the load hook when the
	assembly was already loaded in another appdomain. Fixes #78083.

2006-04-13  Zoltan Varga  <vargaz@gmail.com>

	* assembly.c (mono_assembly_load_reference): Increase the refcount of the
	referenced assemblies.
	(mono_assembly_close): Decrease the refcount of the referenced assemblies.

	* domain.c (mono_domain_free): Add a trace message.

	* appdomain.c (add_assemblies_to_domain): Ditto.	

	* metadata-internals.h: (_MonoAssembly): Modify the meaning of the ref_count
	field.	

2006-04-12  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Reflection_Assembly_InternalGetAssemblyName): Fix image reference counting.

2006-04-12  Martin Baulig  <martin@ximian.com>

	* threads.c: Use `MONO_DEBUGGER_SUPPORTED' as the conditional, not
	`USE_INCLUDED_LIBGC'.	

2006-04-12  Zoltan Varga  <vargaz@gmail.com>

	* image.c (canonicalize_path): Avoid calling strncpy on overlapping strings if
	the patch contains ../ and a small directory name later. Hopefully fixes
	#78035.

2006-04-10  Martin Baulig  <martin@ximian.com>

	Clean up the debugger's thread-handling code.

	The debugger's thread-handling code has been moved from
	../mini/debug-debugger.c to threads.c.  We now iterate directly
	over the `threads' hash, keep track of exiting threads and also
	use proper locking.

	We can now debug XSP and XSP based applications with the debugger.

	* object-internals.h (MonoThread): Added `gpointer end_stack'.

	* threads.h
	(MonoThreadCallbacks): Removed; this was only used by the debugger.
	(mono_install_thread_callbacks): Likewise.	

	* threads.c (mono_thread_callbacks): Removed.
	(debugger_thread_created, debugger_thread_exited): New static functions.
	(start_wrapper): Call debugger_thread_created().
	(thread_cleanup): Call debugger_thread_exited().
	(mono_gc_stop_world, mono_gc_start_world): Removed; this was never used.
	(mono_debugger_init_threads): New public function.
	(debugger_thread_vtable): Moved here from debug-debugger.c; we now
	iterate directly over the `threads' hash and also use proper locking.

	* mono-debug.h (MONO_DEBUGGER_VERSION): Bumped to 55.

	* mono-debug-debugger.h
	(MonoDebuggerEvent): Added MONO_DEBUGGER_EVENT_THREAD_EXITED.

2006-04-10  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (encode_cattr_value): Fix handling of parameter type=object, 
	argument type=array. Fixes #78057.

2006-04-10  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : regenerated. Fixed bug #69652.

2006-04-07  Zoltan Varga  <vargaz@gmail.com>

	* loader.c metadata.c: Reapply a variant r59116.
	
	* loader.c metadata.c: Revert r59116 to see if it fixes the breakage.

	* class.c (mono_class_setup_interface_offsets): New internal function.

	* reflection.c (ensure_runtime_vtable): Setup interface offsets for dynamic
	interfaces too. Fixes #77398.

	* reflection.c (encode_cattr_value): Add support for 
	parameter type=object, argument type=array.
	(load_cattr_value): Ditto. Fixes #77916.

	* marshal.c (emit_object_to_ptr_conv): Add support for ARRAY_BYVALCHARARRAY.
	(emit_ptr_to_object_conv): Ditto. Fixes #77960.

	* metadata.c (mono_type_to_unmanaged): Use ARRAY_BYVALCHARARRAY when converting
	a byval char array and CharSet is Ansi.

	* metadata.h: Add new marshalling conversion ARRAY_BYVALCHARARRAY.

2006-04-06  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c: Add some locking comments.
	
	* metadata.c (mono_metadata_signature_alloc): Allocate signatures in the image
	mempool.
	(mono_metadata_free_method_signature): Don't free the signature itself.

	* loader.c (mono_free_method): Don't free the signature in non-dynamic methods.	

	* assembly.c (mono_assembly_open_full): Avoid the situation where two assemblies
	reference the same MonoImage.
	(mono_assembly_load_from_full): Add an assert.

2006-04-05  Zoltan Varga  <vargaz@gmail.com>

	* image.c (mono_image_close): Don't put the image we are about to free into the
	loaded_images_guid_hash.

	* marshal.c (mono_mb_emit_ptr): Refactor a common code sequence into this function
	to reduce code duplication.

	* marshal.c: Register the native functions called by this module as icalls, to
	somewhat centralize the creation of MonoMethodSignature's.

	* loader.c (mono_method_signature): Add a cache for method signatures.

	* metadata.c (mono_metadata_get_param_attrs): New helper function to return
	the parameter attributes of a method.
	(mono_metadata_parse_method_signature_full): Refactored the computation of
	parameter attributes into a separate function. Also avoid one allocation in
	most cases.

	* assembly.c (mono_assembly_close): Ditto.

	* image.c (mono_image_close): Log trace messages with INFO level.

	* metadata-internals.h (MonoImage): Add a new 'method_signature' cache.

	* image.c reflection.c: Correct reference counting of image modules.
	
	* metadata.c (mono_metadata_interfaces_from_typedef_full): Allocate the result
	of this function from the image mempool.
	
	(mono_metadata_parse_type_full): Remove the mode != MONO_PARSE_PARAM restriction
	to allow more cached types to be used.

	* mono-debug.c (mono_debug_add_method): Appled patch from
	David S. Miller  <davem@sunset.davemloft.net>: Access 
	minfo->lexical_blocks[] entry elements using read32().

2006-04-04  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_free_method): No longer free the method header for non-dynamic
	methods as it is allocated from the mempool.

	* metadata.c (mono_metadata_parse_mh_full): Allocate method headers from the
	image mempool.

	* metadata-internals.h: Add comments describing the reference counting scheme
	used for MonoImage and MonoAssembly.

	* image.c assembly.c reflection.c: Rework reference counting of images and 
	assemblies so they are freed when the runtime is shut down. Free some 
	additional memory structures when an image is unloaded.
	
2006-04-03  Zoltan Varga  <vargaz@gmail.com>

	* class.c loader.c reflection.c: Allocate more data structures in
	the image mempool.

2006-03-31  Miguel de Icaza  <miguel@novell.com>

	* icall.c
	(ves_icall_System_Environment_InternalSetEnvironmentVariable): Fix
	build on pre glib 2.4 systems.

2006-03-31  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Environment_InternalSetEnvironmentVariable): New icall.

	* icall.c: Fix some warnings.

2006-03-29  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : regenerated.

Wed Mar 29 18:24:42 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* threads.c, object-internals.h, verify.c: changed the culture caching
	code to use a normal MonoArray for storage so the GC can keep track of
	them easily. Fixed bits of the cache logic, too and simplified the
	code.

Wed Mar 29 17:18:16 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* gc-internal.h, null-gc.c, boehm-gc.c, gc.c: enable the finalizer
	thread for non-Boehm GCs.

Wed Mar 29 17:10:05 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* domain.c, object.c, domain-internals.h: reduce the amount of memory
	needed to keep track of the data for static fields.

2006-03-29  Raja R Harinath  <rharinath@novell.com>

	Fix #75172
	* icall.c (ves_icall_Type_GetMethodsByName): Don't use vtable_size
	for interface classes.  Use 'num_methods' instead.
	(ves_icall_Type_GetPropertiesByName): Likewise.  Setup vtable
	before using '->vtable_size' field.

Wed Mar 29 12:53:28 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* domain.c, object.c, domain-internals.h: proxy_vtable_hash
	doesn't contain managed pointers, so use a normal hashtable.

Mon Mar 27 11:15:00 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* reflection.c, class-internals.h, domain.c: fixed handling of types
	used as values for objects in custom attributes (bug #77915):

2006-03-24  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_setup_fields): Added support for generic
	instances; fixes #77580.

2006-03-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* assembly.c: publickeytoken is case insensitive. Fixes bug #77898.

2006-03-24  Dick Porter  <dick@ximian.com>

	* file-io.c (get_file_attributes): More stat macro breakage.
	Fixes bug 77759.

Fri Mar 24 15:26:00 CET 2006 Paolo Molaro <lupus@ximian.com>

	* profiler.c: added the file=filename option in the default profiler
	to output the profile data to filename.

2006-03-22 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* icall.c: CodeBase returns '/' instead of '\\' on windows. Fixes
	bug #77877.

2006-03-22  Martin Baulig  <martin@ximian.com>

	* reflection.c (fieldbuilder_to_mono_class_field): Don't store the
	allocated `MonoClassField *' in `fb->handle'.

Tue Mar 21 17:19:37 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class.c, image.c, metadata-internals.h: implemented new mechanism to
	allocate interface ID to save memory and allow better ID reuse on
	appdomain unload. setup_generic_vtable () removal from Martin.

Tue Mar 21 15:54:30 CET 2006 Paolo Molaro <lupus@ximian.com>

	* object.h, appdomain.c, domain.c, exception.c, icall.c,
	locales.c, marshal.c, object.c, reflection.c, threadpool.c,
	threads.c: introduced MONO_OBJECT_SETREF() macro to be able to insert
	write barriers for reference stores with managed objects accessed with
	C structures in the runtime and in embedding programs.

2006-03-20  Raja R Harinath  <rharinath@novell.com>

	* icall.c (ves_icall_Type_GetInterfaces): Avoid using
	'interface_id' and 'max_interface_id' fields of MonoClasses
	representing open generic types.

Fri Mar 17 18:06:06 CET 2006 Paolo Molaro <lupus@ximian.com>

	* object.h, object.c, icall.c: added functions to deal with
	storing valuetypes that contain references in managed objects.
	* reflection.c, string-icalls.c, threads.c, marshal.c: small
	fixes and comments around uses of mono_array_addr ().

Thu Mar 16 17:16:45 CET 2006 Paolo Molaro <lupus@ximian.com>

	* object.h, icall.c, monitor.c: object.GetHashCode ()
	implementation that supports the moving garbage collector.

Wed Mar 15 16:31:38 CET 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c, threads-types.h, threads.c: implemented finalizer for
	LocalDataStoreSlot.

2006-03-15  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (mono_type_size): Add a fixme.
	(mono_type_stack_size): Ditto.

	* object-internals.h (MonoReflectionAssemblyBuilder): Added 
	'type_forwarders' field.

	* tabledefs.h (TYPE_ATTRIBUTE_FORWARDER): Added new (undocumented) type
	attribute from net 2.0.

	* object.c (mono_vtable_get_static_field_data): Moved this to object.c
	from class.c.

	* class.c (mono_class_setup_fields): Fix a warning.
	
	* class.c (mono_class_from_name): Add support for assemblyref entries
	in the EXPORTEDTYPE table.

	* reflection.c: Add support for handling type forwarders under net 2.0.

	* appdomain.c (MONO_CORLIB_VERSION): Bump corlib version.	
	
2006-03-14  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Reflection_Assembly_GetTypes): Avoid
	overwriting entries in ModuleBuild->types, also clean up the code
	a little. Fixes #77774.

Tue Mar 14 20:21:18 CET 2006 Paolo Molaro <lupus@ximian.com>

	* domain.c, assembly.c, metadata-internals.h, class-internals.h:
	load friend assembly info when present.

2006-03-14  Raja R Harinath  <rharinath@novell.com>

	Fix crasher on gtest-158.cs.
	* metadata.c (mono_metadata_parse_type_full): Avoid canonicalizing
	the return value if the MonoClass we want is yet in an
	inconsistent state.
	* class.c (mono_class_create_from_typedef): Add an comment
	explaining an order dependency between mono_class_setup_parent and
	mono_class_setup_mono_type.

Mon Mar 13 21:13:27 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class.c: documentation updates and events bug fix.

Mon Mar 13 17:28:07 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class.c: some cleanup, locking fixes.

Mon Mar 13 10:46:17 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class.c: fix the generics code to setup nested
	type info to the instantiated type (bug #77770).

Sun Mar 12 16:21:31 CET 2006 Paolo Molaro <lupus@ximian.com>

	* marshal.c: fixed a few type correctness issues.

Sat Mar 11 20:14:44 CET 2006 Paolo Molaro <lupus@ximian.com>

	* loader.c: the Set/Get/Addrtess array methods should be public.

2006-03-11  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (mono_register_jit_icall_wrapper): Fix a warning.
	
	* icall.c (mono_register_jit_icall_wrapper): Register the argument, not
	info->wrapper.

2006-03-10  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (mono_register_jit_icall): Allocate the structure using g_new0.

	* class-internals.h (MonoJitICallInfo): Add 'trampoline' field used by the JIT.

	* mempool.c (mono_mempool_alloc): Speed this up a bit.
	(mono_mempool_alloc0): Ditto.

2006-03-09 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* socket-io.c:
	(create_object_from_sockaddr): it was allocating 4 extra bytes
	for the AF_UNIX data. Fixes bug #77747.

2006-03-09  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_MonoMethodInfo_get_retval_marshal): New icall.

2006-03-09  Dick Porter  <dick@ximian.com>

	* file-io.c (get_file_attributes): Use S_ISLNK not "& S_IFLNK".
	Fixes bug 76966 again.

2006-03-07  Peter Dennis Bartok  <pbartok@novell.com>

	* verify.c (dtfinfo_fields): Updated to match new (serializable) field
	names from r57532
	* appdomain.c: Bumped corlib version to 48 (due to r57532)

2006-03-07  Martin Baulig  <martin@ximian.com>

	* object.c
	(mono_field_get_value_object): Add support for MONO_TYPE_GENERICINST.

2006-03-07  Martin Baulig  <martin@ximian.com>

	* class.c
	(mono_class_get_full): Don't inflate TYPEDEF entries; fixes the
	regression introduced in r56970; see gtest-252.cs.

	* loader.c (mono_get_method_constrained): Correctly handle generic
	methods; see gtest-253.cs.

2006-03-04  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_type_Equals): Handle NULLs. Fixes #77700.

2006-03-04  Martin Baulig  <martin@ximian.com>

	* icall.c (ves_icall_MonoGenericClass_GetParentType): Dynamically
	compute the parent type at runtime, just like we're already doing
	it for interfaces.

	* reflection.c
	(mono_reflection_bind_generic_parameters): Don't compute the
	parent type anymore.

	* class-internals.h (MonoDynamicGenericClass): Removed `parent'.

2006-03-04  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.h
	(mono_debugger_create_notification_function): Allocate memory at
	runtime and return a pointer to it.

2006-03-03  Zoltan Varga  <vargaz@gmail.com>

	* assembly.c: Fix windows build.
	
	* assembly.c: Fix build.

	* assembly.c: Move the contents of os/{unix,win32}/util.c to this file.	

	* gc_wrapper.h: Move the contents of os/gc_wrapper.h to this file.
	
2006-03-03  Dick Porter  <dick@ximian.com>

	* process.c
	(ves_icall_System_Diagnostics_Process_ShellExecuteEx_internal):
	Check parameters before dereferencing them.  Fixes Aaron's part of
	bug 77393.

2006-03-03  Raja R Harinath  <rharinath@novell.com>

	Fix performance regression.
	* loader.c (find_method_in_class): Add 'from_class' argument.
	Rename 'klass' argument to 'in_class'.	The signature is compared
	against the method in 'in_class', and the corresponding method is
	returned from 'from_class'.
	(find_method): Walk both 'in_class' and 'from_class' in parallel.
	(method_from_memberref) [PARENT_TYPESPEC]: Use it to walk the
	type definition and generic instantiation in parallel.
	(mono_get_method_constrained): Update to changes.

Thu Mar 2 12:27:41 CET 2006 Paolo Molaro <lupus@ximian.com>

	* threads.c: make sure the domain is correct, too when doing
	mono_thread_attach ().

2006-03-01  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_create_from_typedef): Mark classes using CharSet.Auto as unicode on
	windows. Fixes #77683.

Wed Mar 1 20:09:25 CET 2006 Paolo Molaro <lupus@ximian.com>

	* object.h, *: introduced specific way to set elements of an array
	of references to be used as write barrier. Still need to audit the
	uses of mono_array_addr.

2006-03-01  Miguel de Icaza  <miguel@novell.com>

	* object-internals.h: New field to cache the assmebly name, patch
	from Tambet Ingo (tambet@ximian.com)

Wed Mar 1 19:13:30 CET 2006 Paolo Molaro <lupus@ximian.com>

	* decimal.h, class-internals.h, metadata-internals.h,
	file-io.h: mark a few function declarations as internal, to
	reduce the number of PLT entries.

2006-02-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* file-io.c: fix typo in warning message.

Tue Feb 28 17:43:20 CET 2006 Paolo Molaro <lupus@ximian.com>

	* loader.c: on unix, lookup the "*A" version of a function
	if charset is auto as a second option before failing.

2006-02-28  Raja R Harinath  <rharinath@novell.com>

	* class.h (mono_class_inflate_generic_method): Revert to two
	argument version.
	* class-internals.h (MonoMethodInflated): Remove 'inflated' field.
	(mono_class_inflate_generic_method_full): Add.
	* class.c (mono_class_inflate_generic_method_full): Rename from
	'mono_class_inflate_generic_method'.  Don't set 'inflated' field.
	(mono_class_inflate_generic_method): New.  Wrapper around ..._full.
	* loader.c, reflection.c: Update to changes.

Sat Feb 25 17:57:21 CET 2006 Paolo Molaro <lupus@ximian.com>

	* icall.c: const fixes and small improvements.

2006-02-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: for asynchronous connect(), enable the same workaround
	for BSD 6 as for the Mac. Fixes bug #77637.

2006-02-24  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_free_asany): Fix handling of blittable
	formatted classes. Fixes #77524.

2006-02-24  Raja R Harinath  <rharinath@novell.com>

	* class.c (inflate_generic_type): Add a couple more
	micro-optimizations.
	(inflate_generic_context): Don't use the 'gmethod' from
	'inflate_with'.
	(mono_class_inflate_generic_method): If the method has generic
	parameters, but the passed-in context doesn't have a 'gmethod',
	create one.  Use the possibly simplified generic instantiation
	from the declaring class instead of the one passed in.

2006-02-24  Raja R Harinath  <harinath@gmail.com>

	Make generic method signature and method header handling lazy.
	* class.c (mono_class_inflate_generic_signature): Move to loader.c.
	(inflate_generic_header): Likewise.
	(mono_class_inflate_generic_method): Rewrite.  Add a 'klass_hint'
	parameter to avoid inflating types.
	(mono_get_inflated_method): Empty out.
	* class.h (mono_class_inflate_generic_method): Update to changes.
	* loader.c (mono_get_method_from_token): Don't parse signature for
	generic methods, nor methods of generic classes.
	(mono_method_signature): Rename from 'mono_method_signature'.
	Inflate signature on demand.
	(mono_method_get_header): Inflate method header on demand.
	* reflection.c: Update to changes.

2006-02-23  Raja R Harinath  <rharinath@novell.com>

	* metadata.c (mono_metadata_inflate_generic_inst): If the
	instantiation is closed, don't bother expanding it in the new
	context.
	* class.c (inflate_generic_class): If the generic instantiation
	doesn't change after inflation, return the argument itself.
	(inflate_generic_type) [MONO_TYPE_MVAR, MONO_TYPE_VAR]:
	Add bounds checks.
	(inflate_generic_context): If neither the generic class nor the
	generic method instantiations change, return the original context.
	* reflection.c (mono_method_get_object): Do
	'mono_get_inflated_method' before accessing the ->klass field.
	(inflate_mono_method): Don't create a MonoGenericMethod unless
	necessary.
	(inflate_method): Don't pass a constructed type as the declaring
	type of a methodbuilder.

Thu Feb 23 11:57:54 CET 2006 Paolo Molaro <lupus@ximian.com>

	* object.c: fix memory overwrite.

2006-02-22  Dick Porter  <dick@ximian.com>

	* threads.c: Don't use G_GNUC_PRETTY_FUNCTION in debug messages,
	it doesn't work any more.
	(mono_threads_request_thread_dump): Fix unused variable warnings.

Wed Feb 22 15:08:44 CET 2006 Paolo Molaro <lupus@ximian.com>

	* metadata.h, metadata-internals.h, monodiet.c, debug-helpers.c,
	mono-debug.c, profiler.c: cleanup: move MonoMethodHeader out of
	the public header file.

2006-02-21  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (ves_icall_System_Runtime_InteropServices_Marshal_StringToHGlobalUni): Fix writing past memory. Fixes #77613.

Tue Feb 21 19:55:11 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class-internals.h, object.c: reduce the size of MonoVTable
	and store the interface_offsets array at negative offsets.

Tue Feb 21 19:53:26 CET 2006 Paolo Molaro <lupus@ximian.com>

	* metadata.c: tweak table descriptors data structures to reduce
	size and runtime relocations.

Tue Feb 21 14:52:13 CET 2006 Paolo Molaro <lupus@ximian.com>

	* marshal.c: fix some types and opcodes to be type-safe
	in marshaling wrappers.

2006-02-21  Ankit Jain  <jankit@novell.com>

	* metadata.h (mono_metadata_decode_signed_value): Add declaration.

2006-02-21  Raja R Harinath  <rharinath@novell.com>

	* metadata.c (get_constraints): Relax debugging checks for monodis.

2006-02-21  Ankit Jain  <jankit@novell.com>

	* metadata.c (mono_metadata_load_generic_params): Move the code
	checking for ambiguous generic params from here to mono/dis/get.c
	* metadata-internals.h (mono_generic_params_with_ambiguous_names): Remove.

2006-02-21  Raja R Harinath  <harinath@gmail.com>

	Fix assertion triggered when compiling nemerle.
	* class.c (mono_get_shared_generic_inst): Rename from
	get_shared_inst and make non-static.
	* loader.c (mono_get_shared_generic_method): New.  Used to create
	the MonoGenericContext-equivalent of a MonoGenericContainer.
	(mono_get_method_from_token): Initialize the 'context' field of
	the created MonoGenericContainer.
	* reflection.c (reflection_methodbuilder_to_mono_method): Likewise.
	* metadata.c (get_constraints): Add sanity check.
	* class-internals.h: Add new internal methods.

	* reflection.c (verify_safe_for_managed_space): New sanity check.
	Currently checks that owner-less generic parameters aren't allowed
	in managed space.
	(mono_type_get_object): Use it.
	* icall.c (ves_icall_MonoType_GetGenericArguments): Remove checks
	that are now in mono_type_get_object.
	(ves_icall_MonoMethod_GetGenericArguments): Likewise.

2006-02-19  Raja R Harinath  <harinath@gmail.com>

	* metadata.c (mono_type_create_from_typespec): Rename from
	mono_type_create_from_typespec_full.  Remove MonoGenericContainer*
	argument and caching of types in the generic container.
	(unwrap_arrays, find_generic_param): Remove.
	* metadata-internals.h: Update.
	* class-internals.h (_MonoGenericContainer): Remove 'types' field.

2006-02-18  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_get_exception_for_failure): Fix a warning.

	* marshal.c (mono_marshal_emit_native_wrapper): Handle FNPTR args and
	return values. Fixes #77581.

	* class.c (mono_fnptr_class_get): Switch name and name_space.

	* marshal.c (mono_marshal_asany): Fix marshalling of blittable formatted
	classes and add support for [In, Out] attributes.
	(mono_marshal_free_asany): Ditto. Fixes #77524.

2006-02-18  Raja R Harinath  <harinath@gmail.com>

	* class.c (mono_class_from_generic_parameter): Make more robust to
	incomplete MonoGenericContainers from monodis.

Fri Feb 17 16:10:34 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class-internals.h: added some more exception types.
	* class.c, metadata.c: added a few checks to handle missing
	types.

2006-02-17  Raja R Harinath  <rharinath@novell.com>

	Use owner-less generic-params some more.
	* class.c (my_mono_class_from_generic_parameter): Remove.
	(mono_class_from_generic_parameter): Handle null image,
	param->name and param->owner.
	(mono_class_from_mono_type): Update.
	(mono_class_create_from_typespec): Remove 'container' parameter.
	If that parameter is non-null, the result is always inflated by
	'mono_class_get_full' anyway.
	(mono_class_get): Rename from _mono_class_get.  Remove 'container'
	parameter.
	(mono_class_get_full): Update.

	* class.c (inflate_generic_type) [GENERICINST]: If the generic
	instance is not open, don't bother inflating.
	(mono_class_setup_fields): Hoist some loop-invariants.  Don't
	parse metadata for inflated classes.
	(_mono_class_get): Change GenericContext* parameter to
	GenericContainer*.
	(mono_class_create_from_typespec): Likewise.  Simplify, and
	implement trivially.  All the cases are handled in
	mono_class_from_mono_type.  Don't inflate returned class.
	(mono_class_get_full): Delegate GENERICINST optimization to
	inflate_generic_type.
	(mono_ldtoken) [TOKEN_TYPE_SPEC]: Use mono_class_get_full() here too.

2006-02-16  Dick Porter  <dick@ximian.com>

	* socket-io.c (create_object_from_sockaddr): Fix typo.
	(create_sockaddr_from_object): Check array lengths before
	potentially accessing items off the end.
	(ves_icall_System_Net_Sockets_Socket_Receive_internal)
	(ves_icall_System_Net_Sockets_Socket_RecvFrom_internal)
	(ves_icall_System_Net_Sockets_Socket_Send_internal)
	(ves_icall_System_Net_Sockets_Socket_SendTo_internal): Fix buffer
	length checks to avoid wraparound overflows.
	(ves_icall_System_Net_Sockets_Socket_Select_internal): Check the
	contents of the array of sockets
	(hostent_to_IPHostEntry2)
	(addrinfo_to_IPHostEntry): IPv6 printed addresses can be 48 bytes.
	Check return value of inet_ntop ().
	(addrinfo_to_IPHostEntry): Fix typo

2006-02-16  Raja R Harinath  <rharinath@novell.com>

	Type metadata parsing doesn't use generic-instantiation information.
	* metadata.c (mono_metadata_parse_array_full): Change
	MonoGenericContext* parameter to MonoGenericContainer*.
	(mono_metadata_parse_type_full): Likewise.
	(mono_type_create_from_typespec_full): Likewise.
	(mono_metadata_parse_mh_full): Likewise.
	(mono_metadata_parse_generic_inst): Likewise.
	(do_mono_metadata_parse_generic_class): Likewise.
	(do_mono_metadata_parse_type): Likewise.
	* metadata-internals.h: Update to changes.
	* class.c (mono_class_find_enum_basetype): Likewise.
	(mono_class_setup_fields): Likewise.
	(mono_class_create_from_typespec): Likewise.
	* loader.c (method_from_methodspec): Likewise.
	(mono_get_method_from_token): Likewise.
	(mono_method_get_header): Likewise.

Thu Feb 16 15:42:13 CET 2006 Paolo Molaro <lupus@ximian.com>

	* marshal.c: handle additional GENERICINST case (patch from
	Thong Nguyen <tum@veridicus.com>).
	Fix a few cases where LDIND_I/STIND_I was used for references.

2006-02-16  Raja R Harinath  <rharinath@novell.com>

	* reflection.c (mono_reflection_get_token): Remove unused variable.

2006-02-16  Martin Baulig  <martin@ximian.com>

	* reflection.c (mono_reflection_get_token): Add support for fields
	in instantiated generic types.

	* icall.c
	(ves_icall_MonoField_Mono_GetGenericFieldDefinition): Removed.

2006-02-15  Martin Baulig  <martin@ximian.com>

	* icall.c
	(ves_icall_MonoMethod_get_HasGenericParameters): Removed.
	(ves_icall_MonoMethod_get_Mono_IsInflatedMethod): Removed.
	(ves_icall_MonoMethod_get_IsGenericMethod): New icall.
	(ves_icall_MonoMethod_get_IsGenericMethodDefinition): New icall.

Wed Feb 15 16:19:24 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class.c, metadata.c, metadata.h, object.c, icall.c,
	marshal.c: changed mono_type_get_underlying_type () to do
	the sensible thing and introduced mono_type_generic_inst_is_valuetype().
	Fixed handling of instantiated generic valuetypes (bug #75479).

2006-02-15  Raja R Harinath  <rharinath@novell.com>

	* metadata.c (mono_metadata_decode_signed_value): Simplify.
	Delegate to mono_metadata_decode_value, and work on the returned value.

	* icall.c (ves_icall_MonoType_GetGenericArguments):
	Add consistency check here too.
	
2006-02-15  Ankit Jain  <jankit@novell.com>

	* metadata.c (mono_metadata_decode_signed_value): Use gint* instead of
	char/short etc.

2006-02-15  Ankit Jain  <jankit@novell.com>

	* metadata.c (mono_metadata_decode_signed_value): New function to decode
	signed values, used only for representing lower bounds of arrays.
	(mono_metadata_parse_array_full): Use new
	mono_metadata_decode_signed_value to decode lower bounds.

2006-02-14  Martin Baulig  <martin@ximian.com>

	* reflection.c
	(mono_reflection_get_token): Support "MonoGenericMethod" and
	"MonoGenericCMethod" and allow generic instances / methods.

2006-02-11  Zoltan Varga  <vargaz@gmail.com>

	* console-io.c (ves_icall_System_ConsoleDriver_GetTtySize): New icall
	to obtain the terminal size using an ioctl.

	* object.c (mono_nullable_init): Revert this as nullable reference
	types are not valid.
	(mono_nullable_box): Ditto.

2006-02-09  Dick Porter  <dick@ximian.com>

	* threads.c (mono_thread_detach): Drop a reference to the thread
	we're detaching.

2006-02-09  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_nullable_init): Handle nullable reference types.
	(mono_nullable_box): Ditto. Fixes #77446.

2006-02-07  Martin Baulig  <martin@ximian.com>

	* icall.c (ves_icall_MonoMethod_get_IsGenericMethodDefinition): Removed.

2006-02-07  Ankit Jain  <jankit@novell.com>

	* socket-io.h (MonoSocketFlags): New. Copy of System.Net.Sockets.SocketFlags
	* socket-io.c (convert_socketflags): New. Convert SocketFlags to native ones.
	(ves_icall_System_Net_Sockets_Socket_Receive_internal): Convert flags using convert_socketflags.
	(ves_icall_System_Net_Sockets_Socket_ReceiveFrom_internal): Likewise.
	(ves_icall_System_Net_Sockets_Socket_Send_internal): Likewise.
	(ves_icall_System_Net_Sockets_Socket_SendTo_internal): Likewise.

2006-02-02  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_create_generic): Set type_token as well.

	* object.c (mono_runtime_invoke_array): Fix handling of byref vtypes to be
	compatible with MS.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* threads.c, gc.c: Removed the `WITH_INCLUDED_LIBGC' section; it
	has never been used so far.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.h: Changed comment at the top of this file;
	the header is not installed, but it's safe to #include it from
	within the JIT.

	* mono-debug.c: Don't #define _IN_THE_MONO_DEBUGGER.
	* mono-debug-debugger.c, debug-mono-symfile.c: Likewise.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* mono-debug.h
	(MonoSymbolTable): Removed the `metadata_info' field.

	* mono-debug.c
	(mono_debug_init_1): Always set `mono_symbol_table->corlib'.

	* mono-debug-debugger.h (MonoDebuggerIOLayer): Removed.
	(mono_debugger_add_builtin_types): Removed.
	(MonoDebuggerInfo): Moved into ../mini/debug-debugger.h.
	(mono_debugger_create_notification_function): We now operate on a
	pre-allocated area; take a `gpointer' and return `void'.

	* mono-debug-debugger.c
	(MonoDebuggerMetadataInfo): Moved into ../mini/debug-debugger.h.
	(mono_debugger_add_builtin_types): Removed.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* threads.c (mono_debugger_create_all_threads): New public method.

Wed Feb 1 18:22:34 CET 2006 Paolo Molaro <lupus@ximian.com>

	* gc-internal.h, boehm-gc.c, null-gc.c: back out the patch, since it
	breaks on several platforms.

2006-02-01  Sebastien Pouliot  <sebastien@ximian.com>

	* assembly.c: the VS.NET build doesn't supply default values for
	MONO_ASSEMBLIES and MONO_CFG_DIR.

2006-02-01  Zoltan Varga  <vargaz@gmail.com>

	* gc-internal.h boehm-gc.c null-gc.c (mono_gc_unregister_thread): New
	helper function.

	* threads.c (mono_thread_detach): Call mono_gc_unregister_thread ().

	* loader.c (method_from_memberref): Fix a warning.

	* metadata.c (mono_metadata_load_generic_params): Fix a warning.

	* marshal.c (emit_struct_conv): Fix marshalling of embedded structs
	with explicit layout. Fixes #77433.

2006-01-31  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_Type_GetInterfaceMapData): Make sure 
	max_interface_id is initialized before using it. Fixes #77398.
	(ves_icall_Type_GetInterfaces): Ditto.

2006-01-30  Raja R Harinath  <rharinath@novell.com>

	* metadata.c (mono_metadata_parse_method_signature_full): Don't
	allocate memory for parameter attributes when parsing memberref
	signatures.
	* loader.c (mono_loader_set_error_method_load): Don't warn.
	(method_from_memberref): Ensure MissingMethodException gets thrown
	if method is not found.  Make warning more informative.

2006-01-29  Raja R Harinath  <harinath@gmail.com>

	Fix #77397
	* icall.c (ves_icall_MonoType_get_IsGenericParameter): Don't
	return true if is byref.
	(ves_icall_TypeBuilder_get_IsGenericParameter): Likewise.
	(ves_icall_MonoType_get_DeclaringType): Return NULL on byref classes.
	(ves_icall_MonoType_get_DeclaringMethod): Likewise.

2006-01-27  Raja R Harinath  <rharinath@novell.com>

	Fix tests/find-method.2.il
	* loader.c (find_method, find_method_in_class): Remove is_inflated
	argument.  Revert 2006-01-18 change.
	(method_from_memberref) [MONO_MEMBERREF_PARENT_TYPESPEC]: If type
	is generic, search for method in its generic definition.
	* class.c (mono_class_setup_vtable_general): Print generic
	arguments of generic types in debugging printf.

2006-01-26  Zoltan Varga  <vargaz@gmail.com>

	* object-internals.h (MonoThread): Add 'thread_dump_requested' field.

	* threads.c (mono_threads_request_thread_dump): New helper function.

2006-01-25  Raja R Harinath  <rharinath@novell.com>

	* metadata.c (mono_type_create_from_typespec_full): Fix caching of types.

2006-01-25  Ankit Jain  <jankit@novell.com>

	* metadata-internals.h (mono_generic_params_with_ambiguous_names): Add declaration and
	move definition to ..
	* metadata.c (mono_generic_params_with_ambiguous_names): .. here.
	
2006-01-25  Ankit Jain  <jankit@novell.com>
	    Raja R Harinath  <rharinath@novell.com>

	* metadata-internals.h (mono_generic_params_with_ambiguous_names): New.
	* metadata.c (mono_metadata_load_generic_params): Fill mono_generic_params_with_ambiguous_names
	as necessary.

2006-01-25  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.h: Moved `MonoDebuggerManager' and
	`MonoDebuggerThread' into debug-debugger.c.

Tue Jan 24 18:53:35 CET 2006 Paolo Molaro <lupus@ximian.com>

	* profiler.c: fix printing of data.

2006-01-24  Atsushi Enomoto  <atsushi@ximian.com>

	* object.c, marshal.c : Fixed runtime part of bug #77315. Reject
	  invalid surrogate in UTF7/UTF8 bytes and don't return NULL.

Tue Jan 24 09:56:16 CET 2006 Paolo Molaro <lupus@ximian.com>

	* object.c: fix deadlock related to string interning.

2006-01-23  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.h (MonoDebuggerIOLayer): Removed.

	* mono-debug-debugger.c (mono_debugger_io_layer): Removed.

2006-01-23  Martin Baulig  <martin@ximian.com>

	* mono-debug.h: Moved the prototypes of some functions which are
	used by the JIT here from mono-debug-debugger.h.

2006-01-21  Martin Baulig  <martin@ximian.com>

	* Makefile.am: Don't install mono-debug-debugger.h.

2006-01-21  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.h: Enforce the private status of this header
	file and removed unneccessary #include's in metadata/*.c and mini/*.c.
	Moved some stuff from mono-debugger-jit-wrapper.h here.

2006-01-20  Raja R Harinath  <rharinath@novell.com>

	* class.c (mono_class_from_typeref): Add a sanity test to help
	catch lack of assembly load/search hooks.

2006-01-19  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_struct_conv): Relax the fields with same offset
	check even more. Fixes #77230.

2006-01-18  Martin Baulig  <martin@ximian.com>

	* loader.c (find_method_in_class): Added `gboolean is_inflated'
	argument; if false, we compare the uninstantiated signatures.
	(method_from_memberref): Compare the uninstantiated signatures;
	fixes #76417.

2006-01-18  Robert Jordan  <robertj@gmx.net>

	* boehm-gc.c, null-gc.c (mono_gc_weak_link_remove):
	Clear the weak link. Fixes bug #77170.

	* gc.c (mono_gchandle_free):
	Reflect *-gc.c changes (tiny optimization).

2006-01-18  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (mono_metadata_signature_dup): Applied patch from
	Aras Pranckevicius (aras@otee.dk). Fix crash when compiled with MSVC.
	Fixes #77288.

2006-01-17  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_struct_conv): Allow fields with the same offset when
	marshalling from native to managed code. Fixes #77230.

2006-01-17 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: fix problem (Mac only) when more than one asynchronous
	connect. Fixes bug #77020.

Mon Jan 16 19:20:43 CET 2006 Paolo Molaro <lupus@ximian.com>

	* class.c: fixed id assignement for nested interfaces (bug #77275).
	Added also better info for --print-vtable debugging.

2006-01-12  Martin Baulig  <martin@ximian.com>

	* icall.c (ves_icall_MonoGenericClass_GetInterfaces): Inflate the
	interfaces on-the-fly; fixes #76625.

	* class-internals.h
	(MonoDynamicGenericClass): Removed `ifaces' and `count_ifaces'; we
	don't need that anymore.

2006-01-12  Miguel de Icaza  <miguel@novell.com>

	* socket-io.c
	(ves_icall_System_Net_Sockets_Socket_GetSocketOption_obj_internal):
	To avoid initing the nested_classes when not needed I turned the
	PeerCredData as a toplevel internal class, as it has to be shared
	anyways. 

	Fixes the CASA issue.

2006-01-11  Ben Maurer  <bmaurer@andrew.cmu.edu>

	* domain.c: Accessors for MonoJitInfo

	* profiler-private.h: Add jitinfo to the end jit hook

	* profiler.[ch]: Define new hooks, called after jitting which give
	the MonoJitInfo that was compiled

2006-01-10  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_setup_events): Add support for generic
	classes; fixes #76440.

2006-01-06  Raja R Harinath  <rharinath@novell.com>

	Fix #77160.
	* icall.c (ves_icall_InternalInvoke): Use mono_get_inflated_method
	on passed-in method.

2006-01-03  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_runtime_invoke_array): Add Nullable support.

	* icall.c (ves_icall_System_Activator_CreateInstanceInternal): Ditto.

2006-01-03  Sebastien Pouliot  <sebastien@ximian.com>

	* file-io.c: Don't consider sockets as directory and avoid an endless
	loop. Fix bug #76966.

2006-01-03  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_nullable_init): New helper function.
	(mono_nullable_box): Ditto.

	* marshal.c (mono_marshal_get_runtime_invoke): Handle Nullables.

	* icall.c (ves_icall_FieldInfo_SetValueInternal): Handle Nullables.

	* icall.c (ves_icall_MonoField_GetValueInternal): Handle Nullables.
	
2006-01-02  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_is_assignable_from): Make T assignable to 
	Nullable<T>.

2005-12-23  Sebastien Pouliot  <sebastien@ximian.com>

	* appdomain.c: Bump corlib version to 46.
	* icalls.c: Renamed CurrentTimeZone to CurrentSystemTimeZone (for
	serialization purpose) and changed ves_icall_System_Reflection_
	Assembly_get_code_base signature to accept a boolean (to escape, or 
	not, the assembly code base).

2005-12-23  Dick Porter  <dick@ximian.com>

	* icall.c: 
	* threads-types.h: 
	* threads.c: Added OpenMutex, OpenSemaphore and OpenEvent icalls.
	CreateEvent icall now returns "created" boolean parameter.

2005-12-22  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_mb_emit_restore_result): Add generics support. Fixes
	#76967.

	* reflection.c (mono_custom_attrs_construct_by_type): Handle the case 
	when attr_klass is an interface. Fixes #77045.

2005-12-20  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_struct_conv): Fix previous patch.
	
	* marshal.c (emit_struct_conv): Add a check for fields with the same
	offset.

2005-12-20  Raja R Harinath  <rharinath@novell.com>

	Fix regression in Mono.C5.
	* class.c (mono_class_create_generic): If 'klass' is an interface
	set up the interface offsets.
	(mono_class_is_assignable_from): Don't throw away generic arguments.

2005-12-19  Raja R Harinath  <rharinath@novell.com>

	* icall.c (ves_icall_System_MonoType_getFullName): Return NULL for
	type parameters.

2005-12-15  Raja R Harinath  <rharinath@novell.com>

	* metadata.c (mono_metadata_parse_method_signature_full): Remove a
	dead store.
	(do_mono_metadata_parse_generic_class): Don't pass the current
	generic context when parsing the type being instantiated: it
	cannot use it, anyway.

	* loader.c (method_from_memberref): Don't inflate a signature if
	it doesn't contain any type parameters.

2005-12-15  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_setup_vtable): Call mono_reflection_get_dynamic_overrides () to get the overrides in dynamic assemblies.

2005-12-14  Martin Baulig  <martin@ximian.com>

	* class.c
	(mono_type_get_name_recurse): Don't return null for type
	parameters and open generic classes.
	(mono_class_setup_methods): Don't exclude generic instances.
	(mono_get_unique_iid): Use different IDs for different
	instantiations of the same generic type.
	(mono_class_setup_vtable): Only use setup_generic_vtable() for
	open generic instances; create a normal vtable for closed generic
	instances.
	(mono_class_setup_vtable_general): We're now also called for
	closed generic instances.

	* reflection.c
	(mono_reflection_bind_generic_parameters): Correctly use
	mono_metadata_lookup_generic_inst() everywhere.

2005-12-14  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_class_create_runtime_vtable): Call 
	mono_class_setup_vtable ().

	* reflection.c (mono_reflection_get_dynamic_overrides): New helper
	function.
	(ensure_runtime_vtable): Initialize the generic vtable lazily. Fixes
	#76959.

	* loader.c (mono_loader_set_error_type_load): Print the type load
	warnings to the console so they are more visible to the user.
	(mono_loader_set_error_method_load): Ditto.

	* reflection.c (ensure_runtime_vtable): Revert the last change as it
	is still broken.
	
	* reflection.c (ensure_runtime_vtable): Fix build.

	* reflection.c (ensure_runtime_vtable): Disable an optimization which
	doesn't work in all cases.

2005-12-13  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_array_new_full): Treat a single dimensional array
	with 0 lower bounds as an szarray. Fixes #76973.

	* reflection.c (custom_attr_visible): Really fix this.

2005-12-12  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (custom_attr_visible): Allow nested public attributes
	as well.

	* class.c (mono_class_setup_vtable_general): Add missing != -1 to an
	interface check.

2005-12-12  Raja R Harinath  <harinath@gmail.com>

	* class.c (set_generic_param_owner): Delete.
	(mono_class_create_from_typedef): Don't set ->owner field of
	generic parameters to "param containers" of enclosing classes.
	* reflection.c (mono_reflection_initialize_generic_parameter):
	Likewise.

2005-12-11  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (custom_attr_visible): Fix build.

2005-12-10  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_custom_attrs_from_builders): Avoid returning
	private attributes.
	
	* reflection.c (reflection_methodbuilder_to_mono_method): Fix
	handling of null parameter defaults.

2005-12-09  Raja R Harinath  <rharinath@novell.com>

	* class.c (mono_class_from_generic_parameter): Don't set
	klass->generic_container.
	(my_mono_class_from_generic_parameter): Likewise.

2005-12-07  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (load_public_key): Fix a warning.
	(method_encode_code): Fix unaligned accesses.

2005-12-07  Martin Baulig  <martin@ximian.com>

	* object-internals.h (MonoReflectionGenericParam): Added `cattrs'.

	* reflection.c
	(write_generic_param_entry): Encode our custom attrs.

	* appdomain.c (MONO_CORLIB_VERSION): Bump to 45.

2005-12-07  Martin Baulig  <martin@ximian.com>

	* reflection.c (encode_new_constraint): Removed; we don't use the
	`NewConstraintAttribute' anymore.

2005-12-06  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Reflection_Assembly_InternalGetType): Do
	not fire a TypeResolve event when Assembly.GetType () is called.

2005-12-05  Ben Maurer  <bmaurer@ximian.com>

	Beginning of support for nullable types in the runtime. Parts of
	this patch are from Martin.

	* appdomain.c (MONO_CORLIB_VERSION): Bump

	* domain.c (mono_init_internal): get the nullable type

	* class.c (mono_class_is_nullable): New method
	(mono_class_get_nullable_param): New mehod
	(mono_class_create_generic): In types T? set cast_class to T

	* class-internals.h (MonoDefaults): new nullable default class
	(mono_class_get_nullable_param, mono_class_get_nullable_param):
	new methods.

2005-12-05  Raja R Harinath  <rharinath@novell.com>

	* metadata.c (select_container): New.  Refactor code to select the
	appropriate GenericContainer given the type of generic parameter
	we are looking for.
	(mono_metadata_parse_generic_param): Take a MonoGenericContainer,
	not a MonoGenericContext.  Use select_container.  Update parameters.
	(do_mono_metadata_parse_type): Combine the code for MONO_TYPE_VAR
	and MONO_TYPE_MVAR.
	(unwrap_arrays): Remove duplicate tests.
	(find_generic_param): Rename from 'has_same_context'.  Now walks a
	generic instantiated class to find any arguments that are generic
	parameters.
	(mono_type_create_from_typespec_full): Use find_generic_param to
	avoid evicting some generic instantiations from the typespec
	cache.

Mon Dec 5 15:07:42 GMT 2005 Paolo Molaro <lupus@ximian.com>

	* reflection.c: fixed writing of doubles on ARM FPA.

2005-12-02  Robert Jordan  <robertj@gmx.net>

	* icall.c: Fixed EventInfo.ReflectedType (#76829).

2005-12-01 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* filewatcher.c: try loading libgamin-1.so.0 before libfam, since at
	least on SUSE 10 they are not the same (on debian, they are just the
	same thing).

2005-12-01  Raja R Harinath  <rharinath@novell.com>

	* icall.c (ves_icall_MonoType_get_DeclaringType): Implement
	DeclaringType for VARs and MVARs.
	* class.c (set_generic_param_owner): Fix initialization of owner
	fields.

Wed Nov 30 15:48:22 CET 2005 Paolo Molaro <lupus@ximian.com>

	* icall.c: fixed Enum.ToObject() to correctly convert the values.

2005-11-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: workaround for a bug that shows up on the Mac:
	select()+connect() on a blocking socket is not like it should
	be, so we proceed to connect() in that case, wasting the I/O
	threadpool thread until connect succeedes. Fixes bug #75436.

2005-11-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: fix typo when setting file descriptor states.

2005-11-28  Raja R Harinath  <rharinath@novell.com>

	* class-internals.h (MonoGenericContainer.is_signature): Remove.	
	* metadata.c (mono_metadata_parse_method_signature_full): Don't
	create a temporary signature container.
	(mono_metadata_parse_generic_param): Update to changes.
	(mono_type_create_from_typespec_full): Update to changes.
	* loader.c (method_from_memberref): Don't use a
	MonoGenericContainer while parsing a memberref signature.
	(method_from_methodspec): Remove dead-store of the 'container'
	variable.  It's overwritten before use.

	* metadata.c (mono_type_create_from_typespec_full): Make debugging
	checks tighter.
	(mono_metadata_parse_generic_param): Likewise.
	* loader.c (find_method_in_class): Does not need a
	MonoGenericContainer.  Use 'mono_method_signature' rather than
	'mono_method_signature_full'.
	(find_method, mono_get_method_constrained, method_from_memberref):
	Update to changes.

	* metadata.c (mono_type_create_from_typespec_full): Ensure that
	owner-less generic-parameters are never evicted from the typespec
	cache.

	* loader.c (method_from_memberref): Don't use the current context
	when parsing signatures.
	(method_from_methodspec, mono_get_method_from_token): Update to changes.

	* metadata.c (do_mono_metadata_parse_generic_class): Avoid
	side-effects in g_assert.
	* loader.c (mono_get_method_from_token): Resolve klass earlier so
	that we don't potentially lose information.

2005-11-26  Dick Porter  <dick@ximian.com>

	* icall.c:
	* threads.c: icalls to implement basic (ie, not named)
	System.Threading.Semaphore.

2005-11-24  Dick Porter  <dick@ximian.com>

	* process.c
	(ves_icall_System_Diagnostics_Process_ShellExecuteEx_internal):
	Use GetProcessId() if it's available.

2005-11-23  Zoltan Varga  <vargaz@gmail.com>

	* icall.c threads-types.h threads.c: Add Exchange<T> icall.

2005-11-23  Raja R Harinath  <rharinath@novell.com>
	    Ankit Jain  <jankit@novell.com>

	* loader.c (mono_get_method_from_token): Initialize 'method' field
	of all generic parameters before parsing the signature.  Remove
	code that "fixed"-up MVAR references.

2005-11-23  Ankit Jain  <jankit@novell.com>

	* metadata.c (mono_metadata_has_generic_params):
	(mono_metadata_load_generic_param_constraints):
	(mono_metadata_load_generic_params): Move duplicate code ...
	(mono_metadata_get_generic_param_row): ... here. Returns the
	first row-id in GenericParam table for a given owner (token).
	* metadata-internals.h (mono_metadata_get_generic_param_row): Add
	prototype.

2005-11-23  Raja R Harinath  <rharinath@novell.com>
	    Ankit Jain  <jankit@novell.com>

	* metadata.c (mono_metadata_class_equal): Pass signature_only when
	comparing VARs too.
	* icall.c (ves_icall_MonoType_get_DeclaringMethod): Look at 
	type->data.generic_param only if the type is an MVAR.
	(ves_icall_MonoMethod_GetGenericArguments): Ensure that we don't
	leak owner-less VARs and MVARs into managed space.

2005-11-21  Martin Baulig  <martin@ximian.com>

	* class-internals.h
	(MonoMethod): Moved the `generic_container' here from
	`MonoMethodNormal' since we now also need it for
	`MonoMethodPInvoke';
	(MonoMethodNormal): Moved the `generic_container' to `MonoMethod'.
	(MonoMethodInflated): Replaced the `MonoMethodNormal nmethod' with
	an union containing both `MonoMethodNormal' and
	`MonoMethodPInvoke'.

	* loader.c
	(mono_get_method_from_token): Allow implementing generic methods
	as interncalls.

	* threads.c
	(ves_icall_System_Threading_Interlocked_CompareExchange_T): New
	icall.

2005-11-17  Dick Porter  <dick@ximian.com>

	* icall.c: 
	* process.h: 
	* process.c: Split the Process Start_internal icall into
	ShellExecuteEx_internal and CreateProcess_internal, which are
	called depending on whether UseShellExecute is true.  Fixes bug
	76670.

	* appdomain.c (MONO_CORLIB_VERSION): Incremented

2005-11-17  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_ptr_to_object_conv): Get rid of the 'usize' and
	'msize' parameters, use the information in 'mspec' instead.
	(emit_object_to_ptr_conv): Ditto.

	* marshal.c (emit_struct_conv): Handle explicit layout structs with
	fields out of order. Fixes #76733.

2005-11-17  Ankit Jain  <jankit@novell.com>

	* metadata.c (mono_type_create_from_typespec_full): Remove unnecessary g_assert.

2005-11-16  Atsushi Enomoto  <atsushi@ximian.com>

	* icall.c : renamed MakeGenericMethod -> MakeGenericMethod_impl for
	  bug #76575.

2005-11-16  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_class_compute_gc_descriptor): Disable typed allocation
	for types with non-auto layout. Fixes #76717.

2005-11-16  Ankit Jain  <jankit@novell.com>

	* class.c (my_mono_class_from_generic_parameter): param->owner can be null.
	* metadata.c (mono_metadata_parse_generic_param): Create a dummy MonoGenericParam 
	if generic_context is null.
	  (mono_metadata_generic_param_equal): param->owner can be null.
	  (mono_type_create_from_typespec_full): Don't cache the MonoType if param->owner is
	null.

2005-11-16  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (create_dynamic_mono_image): Set md_version_minor to
	the correct value.

2005-11-15  Martin Baulig  <martin@ximian.com>

	* object.c (set_value): Use mono_class_from_mono_type() instead of
	the hack for generic instances; fixes #76136.

2005-11-15  Zoltan Varga  <vargaz@gmail.com>

	* metadata-internals.h (_MonoImage): Add 'md_version_major/minor'
	fields.

	* image.c (load_metadata_ptrs): Initialize the new fields.

	* reflection.c (create_dynamic_mono_image): Ditto.

	* reflection.c (build_compressed_metadata): Use the new fields.

	* icall.c (ves_icall_System_Reflection_Module_get_MDStreamVersion): New
	icall.

	* icall.c (mono_assembly_icalls): Remove obsolete get_MetadataToken
	icall.
	
2005-11-15  Ankit Jain  <jankit@novell.com>
	    Raja R Harinath  <harinath@gmail.com>

	* class-internals.h (_MonoGenericContainer.types): New. Cache for MonoTypes.
	* metadata.c (mono_type_create_from_typespec_full): Use MonoType from the
	new per-generic_container cache if the cached MonoType's context matches
	the current context.
	  (has_same_context): New. Check if the VARs or MVARs in a GENERIC_INST refer
	to the expected context.
	  (unwrap_arrays): New. Get the element MonoType for an ARRAY/SZARRAY.

2005-11-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* appdomain.c: Update MONO_CORLIB_VERSION to 42, since
	we changed the signature of an icall.
	* icall.c: Modify to mono_double_ParseImpl return true/false 
	depending on the success, instead of throwing the exception. This will
	help us in Double.TryParse methods.
	
2005-11-14  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_object): Throw an exception when
	marshalling 'object' instead of crashing. Fixes #76696.

2005-11-11  Zoltan Varga  <vargaz@gmail.com>

	* class-internals.h: Add prototype for mono_type_get_full_name ().

2005-11-11  Dick Porter  <dick@ximian.com>

	* threads.c (mono_thread_manage): Make sure the main thread has
	abandoned all its mutexes when cleaning up.  Fixes bug 74680.

2005-11-11  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_loader_set_error_type_load): Log a warning to the
	console about the missing type.
	(mono_loader_set_error_method_load): Ditto.

2005-11-09  Miguel de Icaza  <miguel@novell.com>

	* mono-config.c (mono_get_config_dir): Set the system defaults if
	none is specified.

	* assembly.c (mono_set_dirs): New API entry point to set the
	assembly and the config directory in one call

2005-11-09  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_ftnptr_to_delegate): Throw a NotSupportedException if
	the ftnptr was created from a delegate in a domain other than the
	current domain. Fixes #75377.

	* exception.h exception.c: Add mono_get_exception_not_supported ().

2005-11-08  Martin Baulig  <martin@ximian.com>

	* mono-debug.h (MONO_DEBUGGER_VERSION): Bump to 53.

2005-11-07  Sebastien Pouliot  <sebastien@ximian.com>

	* security-manager.h: Added definitions to deal with strongname key 
	pairs bigger (and smaller) than 1024 bits.
	* reflection.c: Remove hardcoded strongname size (128 bytes) and 
	adjust wrt the public key length being used.

2005-11-03  Atsushi Enomoto  <atsushi@ximian.com>

	* marshal.c, icall.c : reverted sig->pinvoke changes which broke
	  Windows build (r51396-51397).

2005-11-03  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_setup_vtable_general): Also add generic
	methods to the vtable; fixes #76581.

2005-11-01  Miguel de Icaza  <miguel@novell.com>

	* string-icalls.c (ves_icall_System_String_ctor_encoding): Make
	sure that we lookup GetString method from the System.Text.Encoding
	class, not the derived class or we get an empty method.

	Fixed class #76612.

2005-10-25  Miguel de Icaza  <miguel@novell.com>

	* assembly.c (mono_assemblies_init): Do not set the Mono root dir
	if it has been previously set (embedders). 

	Make mono_set_rootdir available also on Unix.

005-10-24  Robert Jordan  <robertj@gmx.net>

	* assembly.c: fixed MONO_ASSEMBLIES to be NULL on cygwin as well.

2005-10-30  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c icall.c: Clean up the usage of sig->pinvoke flag. Now
	only calls which are made to native code use this flag.

	* icall.c (ves_icall_System_Reflection_FieldInfo_GetUnmanagedMarshal): Remove the check for FieldBuilders as it is now done in managed code.

2005-10-29  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c (ves_icall_System_Reflection_FieldInfo_GetUnmanagedMarshal):
	Add support for FieldBuilders.

2005-10-29  Martin Baulig  <martin@ximian.com>

	* mono-debug.c
	(mono_debug_using_mono_debugger): New public method; returns
	whether we're running inside the debugger.

2005-10-27  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_reflection_get_custom_attrs_info): Add support
	for Method/Constructor/FieldBuilders.

2005-10-26  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (module_add_cattrs): Save custom attributes for global methods
	and fields as well.

2005-10-26  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.c
	(MonoDebuggerMetadataInfo): Added `klass_parent_offset'.

2005-10-24  Raja R Harinath  <harinath@gmail.com>

	* icall.c (base64_to_byte_array): Don't pass an out-of-range
	integer to isspace.

2005-10-21  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_vtype): Correctly handle [In,Out] modifiers
	when passing valuetypes byref. Fixes #76502.

2005-10-19  Jackson Harper  <jackson@ximian.com>

	* profiler.c: Don't put a . in front of types that are not in a
	namespace.

2005-10-18  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_Type_GetField): Applied patch from Robert Jordan (robertj@gmx.net). Fixes #75515.

2005-10-15  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c: Add generics support to the ldfld/stfld wrappers. Fixes
	#76436.
	(mono_marshal_get_ldflda_wrapper): Fix a warning.

2005-10-13  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* assembly.c metadata-internals.h icall.c: Define an additional
	parameter for mono_assembly_name_parse_full, so we can avoid creating
	S.R.AssemblyName.Version when no version info wasn't passed.
	
2005-10-09  Miguel de Icaza  <miguel@novell.com>

	* class.c (mono_type_get_full_name): Reimplement method that was
	removed. 

	* image.c: Some docs

2005-10-10  Zoltan Varga  <vargaz@gmail.com>

	* profiler.c (output_newobj_profile): Fix printing of Total memory
	on x86.

2005-10-08  Zoltan Varga  <vargaz@freemail.hu>

	* profiler.c: Add support for allocations > 2GB. Fixes #74886.

2005-10-08  Gert Driesen  <drieseng@users.sourceforge.net>

	* threads.c: remove debug output.

2005-10-08  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c (mono_thread_manage): Fix crashes if more than 64
	threads need to be aborted. Hopefully fixes #75899.

	* assembly.c (mono_stringify_assembly_name): New helper function.

	* class.c: Use mono_stringify_assembly_name instead of the similar
	static function.

	* assembly.h assembly.c: Add support for calling a postload search 
	hook if an assembly cannot be loaded.

	* appdomain.c: Register new search hooks which call the AssemblyResolve
	events in AppDomain. Fixes #75231

2005-10-07  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (mono_debug_add_method): Create a wrapper entry for
	methods without debug info.

2005-10-07  Zoltan Varga  <vargaz@gmail.com>

	* class-internals.h debug-helpers.c marshal.h marshal.c: Add ldflda
	wrappers.

2005-10-06 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* file-io.c: now that we return symlinks, use lstat and, when the file
	is a symbolic link, stat, to get the file attributes. Also avoid the
	conversion to/from utf16/external.

2005-10-06  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_layout_fields): Compute klass->has_references
	correctly if an embedded valuetype is not yet initialized. Fixes
	#76331.

2005-10-04  Martin Baulig  <martin@ximian.com>

	* metadata.c
	(mono_metadata_load_generic_param_constraints): New public
	function; splitted the constraints loading out from
	mono_metadata_load_generic_params().

	* class.c (mono_class_create_from_typedef): Call
	mono_metadata_load_generic_param_constraints() after setting up
	the type and creating our parent; fixes #75329.

2005-10-04  Martin Baulig  <martin@ximian.com>

	* icall.c (ves_icall_MonoGenericClass_GetParentType): Allow
	non-dynamic parent classes.

2005-10-04  Atsushi Enomoto  <atsushi@ximian.com>

	* file-io.c : win32 build fix (ETXTBSY seems not found).

2005-10-04  Martin Baulig  <martin@ximian.com>

	* reflection.c
	(mono_image_get_methodspec_token): Make the cache actually work;
	fixes #75974.

2005-10-04  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_name_from_token): Removed the unneccessary
	`MonoGenericContext *' argument.

2005-10-04  Martin Baulig  <martin@ximian.com>

	* loader.c
	(method_from_methodspec): Make the caching work again; fixes the
	performance regression from #76262.

2005-10-04 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* file-io.c:
	* file-io.h:
	* icall.c: replace FindFirst/FindNext/FindClose calls with a new
	GetFileSystemEntries that performs the same work but without going
	into io-layer, locking, etc.

2005-09-30  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (ves_icall_System_Threading_Thread_Abort): Handle 
	ThreadState_Stopped as well. Fixes #76047.

2005-09-29  Martin Baulig  <martin@ximian.com>

	* class.c
	(inflate_generic_context): If the new context has a `gmethod', set
	its `container' that that gmethod's `container'.

	* metadata.c
	(mono_metadata_parse_generic_param): Simplify things;
	`generic_container = generic_context->container;' is just fine.

	* loader.c (method_from_methodspec): Code cleanups.

Wed Sep 28 17:06:01 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* decimal.c: fix warning (and let gcc generate correct
	code on ARM with optimizations).

2005-09-28  Martin Baulig  <martin@ximian.com>

	* loader.c
	(method_from_memberref): Added `MonoGenericContext *class_context'
	argument; this is used when parsing a MONO_MEMBERREF_PARENT_TYPESPEC.
	(method_from_methodspec): If we're a memberref, use the enclosing
	context when parsing its parent.  Fixes #76262; see gtest-206.cs.

2005-09-28  Martin Baulig  <martin@ximian.com>

	* object.c (mono_runtime_invoke_array): Added support for
	MONO_TYPE_GENERICINST; fixes #75917.

2005-09-27  Martin Baulig  <martin@ximian.com>

	* reflection.c (encode_type): For `MONO_TYPE_CLASS/VALUETYPE', use
	`k->byval_arg.type' to determine the actual type.

	* loader.c (method_from_methodspec): Removed some hacks.

2005-09-27  Ben Maurer  <bmaurer@ximian.com>

	* class-internals.h (mono_field_is_deleted): Do the test for
	rtspecialname before we check the actual name of the field. This
	prevents us from dereferencing a pointer into the string table,
	saving us from accessing a few pages

	* *.c: Replace the use of {Enter,Leave}CriticalSection with
	macros. This will allow a deadlock debugger to easily be plugged
	in.

2005-09-27  Martin Baulig  <martin@ximian.com>

	* loader.c (method_from_methodspec): Create a "signature"
	MonoGenericContainer and use mono_get_method_full().  Fixes #75584.

2005-09-27  Martin Baulig  <martin@ximian.com>

	* class.c
	(inflate_generic_class): Correctly set the new context's
	container.

	* loader.c
	(find_method, find_method_in_class): Take a `MonoGenericContainer *'
	instead of a `MonoGenericContext *'.
	(mono_method_signature_full): Take a `MonoGenericContainer *'
	instead of a `MonoGenericContext *'.

	* metadata.c
	(mono_metadata_parse_signature_full): Take a `MonoGenericContainer *'
	instead of a `MonoGenericContext *'.
	(mono_metadata_parse_method_signature_full): Likewise.

2005-09-26  Martin Baulig  <martin@ximian.com>

	* class.c
	(mono_class_from_generic_parameter): Set `klass->generic_container'
	(mono_class_from_generic_parameter): Likewise.
	(mono_bounded_array_class_get): We inherit the generic container
	from the element class.

	* loader.c
	(find_method, find_method_in_class): Take a `MonoGenericContext *'
	argument rather than computing it here.
	(method_from_memberref): Correctly set the generic context before
	parsing the signature.  Fixes #75681.

2005-09-26  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_class_has_special_static_fields): Fix warnings.

2005-09-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* assembly.c: Add parse_public_key function, to
	par the public keys. Also added mono_assembly_name_parse_full,
	to define it the parsed key should be freed or not.
	* icall.c: Added ves_icall_System_Reflection_AssemblyName_ParseName,
	to parse a long format assembly name.
	* metadata-internals.h: Keep mono_assembly_name_parse_full as
	private, since calling it to preserve the key requires
	freeing it manually.
	
2005-09-26  Atsushi Enomoto  <atsushi@ximian.com>

	* locales.c : removed HAVE_ICU part.

2005-09-24  Zoltan Varga  <vargaz@freemail.hu>

	* object.c (mono_class_create_runtime_vtable): Avoid calling 
	field_is_special_static if the klass has no special static fields.

	* class-internals.h (MonoClass): Add 'no_special_static_fields' flag.
	(MonoCachedClassInfo): Likewise.

	* object.c (mono_class_has_special_static_fields): New helper function.

2005-09-23  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_create_from_typedef): Don't call 
	interfaces_from_typedef_full for enums.
	(mono_class_create_from_typedef): Compute the base types of enums directly
	without calling mono_class_setup_fields ().
	(mono_class_find_enum_basetype): New helper function.

	* reflection.c (mono_image_build_metadata): Emit type names+namespaces at
	one place inside the string heap.
	
Fri Sep 23 19:37:46 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* class.c: locking fixes, code cleanups, some docs added.
	Allocate some data structures in the image mempool.

2005-09-23  Zoltan Varga  <vargaz@gmail.com>

	* rawbuffer.c: Remove unneccessary set_n_pagefaults () routine and update
	the example code.
	
Fri Sep 23 18:27:02 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* class-internals.h, class.c, reflection.c: reduce memory taken by
	MonoClass.

Fri Sep 23 17:56:21 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* metadata.c, metadata.h, loader.h: documentation updates, code and
	API cleanups.

2005-09-23  Zoltan Varga  <vargaz@gmail.com>

	* rawbuffer.c: Remove unneccessary set_n_pagefaults () routine and update
	the example code.

	* rawbuffer.h rawbuffer.c: Add code and APIs to help determine the number of
	page faults caused by the runtime while reading metadata.

2005-09-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* socket-io.c: the field names were changed 3 months ago and no one
	realized until bug #76077 got filed!

2005-09-20  Martin Baulig  <martin@ximian.com>

	* icall.c (assembly_icalls): Removed some unused debugger icalls.

2005-09-20  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (mono_debug_add_type): Ignore array types and don't
	write the rank into the class entry.

2005-09-20  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.c (MonoDebuggerMetadataInfo): Added some stuff.

2005-09-19  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (MONO_CORLIB_VERSION): Bump corlib version.

	* icall.c (custom_attrs_defined_internal): New icall.

	* reflection.c (mono_reflection_get_custom_attrs_by_type): New helper
	function.
	(mono_custom_attrs_construct_by_type): New helper function.

2005-09-17  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (ves_icall_System_Runtime_InteropServices_Marshal_StringToHGlobalUni): Null
	terminate the resulting string. Fixes #76123.

2005-09-16  Martin Baulig  <martin@ximian.com>

	* mono-debug.c
	(mono_debug_add_method): Ignore inflated methods for the moment.

2005-09-14  Martin Baulig  <martin@ximian.com>

	* debug-mono-symfile.h (MONO_SYMBOL_FILE_VERSION): Bump version to 39.

2005-09-13  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (mono_class_get_overrides_full): Modify signature to explicitly
	return a success/failure indication.
	(mono_metadata_interfaces_from_typedef_full): Ditto.
	(get_constraints): Ditto.

2005-09-12  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_array): Fix handling of null arrays.
	
	* marshal.c (emit_marshal_array): Add support for returning string
	arrays from delegates. Fixes #76063.

	* marshal.c: Use the emit_ldloc/stloc macros where possible.

2005-09-11  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (ves_icall_System_Threading_Thread_MemoryBarrier): New
	icall.

2005-09-09  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c icall.c: Fix after mono_get_exception_type_load
	signature change.

	* assembly.c (mono_assembly_get_assemblyref): New helper function.
	(mono_assembly_load_reference): Use the new helper.

	* class-internals.h (MonoLoaderError): New structure containing 
	information about type loading errors.

	* class-internals.h loader.c: Add APIs to store per-thread loader
	error information.

	* loader.c class.c: Set the loader error if needed.

	* exception.h exception.c: Add functions to throw MissingMethod/MissingFieldExceptions.

Thu Sep 8 18:54:07 BST 2005 Paolo Molaro <lupus@ximian.com>

	* decimal.c: fixed to handle the broken ARM fp format.

Wed Sep 7 22:17:58 BST 2005 Paolo Molaro <lupus@ximian.com>

	* icall.c: on ARM use the libc strtod(), since bsd_strtod() seems
	broken.

2005-09-06  Martin Baulig  <martin@ximian.com>

	* domain.c (supported_runtimes): Added v2.0.50727.

Tue Sep 6 11:40:24 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* culture-info.h: reduce the size of some structures.

2005-09-05  Martin Baulig  <martin@ximian.com>

	Reflect latest API changes in the August CTP.

	* icall.c
	("Type.BindGenericParameters"): Renamed to "MakeGenericType".
	("MonoType.HasGenericArguments"): Removed.
	("MonoMethod.BindGenericParameters"): Renamed to
	"MakeGenericMethod".
	("MethodBuilder.BindGenericParameters"): Renamed to
	"MakeGenericMethod".	

2005-09-05  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.c: Moved the debugger icalls into icall.c.

2005-09-05  Martin Baulig  <martin@ximian.com>

	Applying a patch from Michal Moskal <malekith@nemerle.org>.

	* icall.c (ves_icall_Type_get_IsGenericType): Return true also if
	generic_container is non-NULL.

2005-09-05  Martin Baulig  <martin@ximian.com>

	Applying a patch from Michal Moskal <malekith@nemerle.org>.

	* object.c (set_value): In MONO_TYPE_VALUETYPE, add generics support.

2005-08-29  Michal Moskal  <malekith@nemerle.org>

	* reflection.c (encode_locals,
	mono_reflection_sighelper_get_signature_local): Increase buffer sizes
	for large generic types.

2005-09-05  Martin Baulig  <martin@ximian.com>

	Applying a patch from Michal Moskal <malekith@nemerle.org>.

	* class.c (mono_dup_array_type): New public method.
	(mono_metadata_signature_deep_dup): New public method.
	(dup_type): Correctly duplicate array and function types.

2005-09-05  Martin Baulig  <martin@ximian.com>

	Applying a patch from Michal Moskal <malekith@nemerle.org>.

	* reflection.c (get_default_param_value_blobs): Handle generic types
	and generic methods.

2005-09-02  Sebastien Pouliot  <sebastien@ximian.com>

	* class.c: Fixed error reporting (method/class were inversed) for 
	inheritance demands.
	* security-manager.c|h: Added the AppDomain when calling the managed
	System.Security.SecurityManager.InheritanceDemand method.

2005-09-01  Raja R Harinath  <rharinath@novell.com>

	* reflection.c (encode_marshal_blob): 'marshaltype' and
	'marshaltyperef' are alternate sources for the custom marshaler
	name.

Wed Aug 31 17:39:54 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* class.c: fix creation of array classes with rank == 1
	(patch by Ankit Jain <jankit@novell.com>).

Wed Aug 31 17:35:19 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* object.c: fix check for creating the bound data for arrays vs
	szarrays.

2005-08-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* object.c: configuration file name is now based on the executable name,
	not the image name. Fixes bug #75931.

2005-08-29  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_thread_interrupt_checkpoint_call): Load the
	flag using LDIND_U4 since it leads to smaller and faster code on ia64.

2005-08-25  Zoltan Varga  <vargaz@gmail.com>

	* rand.c: Use wincrypt.h instead of WinCrypt.h.

2005-08-24  Ankit Jain  <jankit@novell.com>
	    Raja R Harinath  <rharinath@novell.com>

	* class.c (mono_class_from_typeref): Don't call mono_class_init as we might've been
	  called by it recursively.
	  (mono_class_init): Remove special case in pending_init handling, since it's
	  superseded by the fix to mono_class_from_typeref.

2005-08-22  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c (ves_icall_System_Threading_Thread_Thread_internal): Remove the 
	BROKEN_THREAD_START stuff.

2005-08-21  Zoltan Varga  <vargaz@freemail.hu>

	* class-internals.h object.c: Add a new kind of trampoline called a delegate 
	trampoline.

	* domain-internals.h domain.c: Add a has for delegate trampolines to MonoDomain.
	
	* object.c (mono_delegate_ctor): Replace the original function address with
	a delegate trampoline.

2005-08-21 Gert Driesen <drieseng@users.sourceforge.net>

	* icall.c: add boolean argument to base64_to_byte_array and 
	InternalFromBase64String to control whether a whitespace-only string
	is allowed (or should casue a FormatException to be thrown). We need
	this as the behavior has changed between MS.NET 1.x and 2.0, and we
	to match the MS behaviour in both profiles.
	* appdomain.c: Bump corlib version.

2005-08-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	This patch implements a big portion of publisher policy
	support, used to bind assembly versions and redirect
	one assembly from version A to version B.

	* assembly.c:
	New GSList loaded_assembly_bindings, for storing the cached
	assembly bindings.
	(assembly_binding_maps_name): New static function for checking if a 
	assembly binding information maps an assembly name.
	(mono_assembly_binding_info_free): New function for freeing
	assembly binding information resources.
	(get_publisher_policy_info): New static function for retrieving 
	assembly binding information from a MonoImage.
	(compare_versions): New static function for comparing an assembly
	binding information data and the version of an assembly name.
	(check_policy_versions): New static function for checking if an
	assembly binding info mapping an assembly name is valid for it.
	(mono_assembly_load_publisher_policy): New static function for
	loading the 'policy.major.minor.MyAssembly' image for an assembly
	with an assembly name 'aname'.
	(mono_assembly_bind_version): New static function for updating
	assembly redirection.
	(mono_assembly_apply_binding): New static function for applying
	assembly binding.
	(search_binding_loaded): New static function for searching 
	loaded assembly binding infos in the cache domain.
	(mono_assembly_load_full): Don't apply assembly binding for
	reflection only assemblies.

	* metadata-internals.h: Add MonoAssemblyBindingInfo,
	which contains information about assembly binding. Also
	declare signature for mono_config_parse_publisher_policy ()
	function, used to retrieve pub policy info.
	
	* mono-config.c:
	(publisher_policy_start): New static function used to parse publisher 
	policy config files.
	(publisher_policy_parser): New static MonoParseHandler containing 
	the functions used when parsing config files.
	(mono_config_parse_publisher_policy): New function for parsing
	publisher policy files.
	
2005-08-20  Zoltan Varga  <vargaz@freemail.hu>

	* object.c (mono_delegate_ctor): Add support for IA64 function descriptors.

	* marshal.c (mono_delegate_free_ftnptr): Ditto.

	* object.c (mono_get_addr_from_ftnptr): New helper function.

	* object.h (mono_array_addr): Fix unaligned access warnings on IA64.

	* appdomain.c (MONO_CORLIB_VERSION): Bump corlib version.

2005-08-19  Dick Porter  <dick@ximian.com>

	* threads.c, threads.h, appdomain.c, appdomain.h,
	profiler-private.h, monitor.c, object.c, object-internals.h,
	profiler.c, mono-debug-debugger.h, profiler.h: Use a gsize to
	store the thread ID, so it can hold a 64 bit value if needed.

2005-08-19  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_reflection_create_dynamic_method): Store the
	handle class into the method references as well so ldtoken works in
	dynamic methods.

	* icall.c (ves_icall_MonoField_GetValueInternal): Add support for generic
	types.

2005-08-19  Ankit Jain <jankit@novell.com>

	Fix #75847.
	* marshal.c (mono_marshal_get_ptr_to_struct): Build method signature 
	  here rather than using the method signature of a arbitrary function
	  named 'System.Runtime.InteropServices.Marshal::PtrToStructure' with 
	  two arguments.
	  Hack done with Harinath.

2005-08-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: disable printing stack traces when we get a exception
	in a threadpool thread. I need to do more testing to figure out which
	cases actually print this. Fixes bug #75828.

2005-08-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* icall.c: there might be ignored whitespace after the last '='. This
	fixes length computation and bug #75840.

2005-08-18  Zoltan Varga  <vargaz@freemail.hu>

	* assembly.c (mono_assembly_load_full): Consider .exe extension as
	well. Fixes #75809.

	* reflection.c (create_custom_attr): Fix unmanaged memory leak. Fixes
	#75784.
	
	* reflection.c (create_custom_attr_data): Ditto.

2005-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	* locales.c, culture-info.h : removed RegionLCIDMap.
	* culture-info-tables.h : regenerated.

2005-08-16  Martin Baulig  <martin@ximian.com>

	* class.c (mono_type_get_name_recurse): Small fix.

2005-08-16  Atsushi Enomoto  <atsushi@ximian.com>

	* locales.c : indentation fixie.

2005-08-15  Atsushi Enomoto  <atsushi@ximian.com>

	* object-internals.h,
	  locales.h,
	  locales.c,
	  culture-info.h,
	  icall.c : added RegionInfo table support.
	* culture-info-table.h : regenerated for region support.

2005-08-14  Kamil Skalski  <nazgul@nemerle.org>

	* reflection.c (resolve_object): handle all kinds of MonoMethod
	including generic ones

2005-08-12  Ankit Jain <jankit@novell.com>

	* get.c (dis_stringify_variant_type): New. Stringify MonoMarshalVariant.
	  (dis_stringify_marshal_spec): Add new case for MONO_NATIVE_SAFEARRAY. 

2005-09-12  Lluis Sanchez  <lluis@ximian.com>

	* process.c: Don't close a thread handle when it's NULL. This is a
	workaround for bug #75733.

2005-08-11  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_string_encoding): Fix handling of CharSet.Auto. Fixes #75769.

2005-08-10  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c (ves_icall_Type_get_IsGenericType): New icall.

2005-08-09 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: if a work item in the thread pool has a callback that
	catches a exception, don't propagate it after invoking the callback.
	Fixes bug #75336.

2005-08-08  Zoltan Varga  <vargaz@freemail.hu>

	* class.c (class_compute_field_layout): Rename this to mono_class_setup_fields.

	* class-internals.h (MonoCachedClassInfo): Add some new fields.

	* class.c (mono_class_init): Load field info lazily in the AOT case.	

	* reflection.c (mono_image_load_module): Fix error checking. Fixes #75660.

2005-08-03  Ankit Jain  <jankit@novell.com>

	Fix #75683.
	* loader.c (mono_method_signature_full): Use MONO_CALL_DEFAULT if
	  PInvoke calling convention is 0.

2005-08-02  Zoltan Varga  <vargaz@freemail.hu>

	* socket-io.c (convert_sockopt_level_and_name): Applied patch from 
	Julien Puydt (julien.puydt@laposte.net). Add check for IPV6_PKTINFO.

Mon Aug 1 16:52:12 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* gc-internal.h, threads.c, null-gc.c, boehm-gc.c: added interface
	to handle threads not started by the GC (patch by Michael Meeks
	<michael.meeks@novell.com>).

2005-07-31  Kamil Skalski  <nazgul@omega.pl>

	* reflection.c: Make buffer used in emitting types larger for some
	big generic types (patch by Michal Moskal).

2005-07-30  Zoltan Varga  <vargaz@freemail.hu>

	* mono-debug.c: Fix some (not all) alignment problems.

2005-07-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* appdomain.c (ves_icall_System_AppDomain_LoadAssemblyRaw):
	Invoke mono_image_load_from_data_full passing the refonly
	parameter.

	* assembly.c
	(mono_assembly_open_from_bundle): Add the refonly argument, 
	in order to pass it to other methods it calls to.
	(do_mono_assembly_open): Add the refonly argument, in order 
	to pass it to other methods it calls to.
	(mono_assembly_open_full): Invoke do_mono_assembly_open passing
	the refonly parameter to it.

	* image.c: Add loaded_images_refonly_hash and
	loaded_images_refonly_guid_hash to cache the reflection
	only loaded images.
	(mono_images_init): Initialize the hash tables used for
	caching the reflection only images.
	(load_modules): Invoke mono_image_open_full passing the refonly
	parameter to load the modules the correct way.
	(build_guid_table): Add the refonly argument, to re-build the 
	correct hash table.
	(do_mono_image_open): Added the refonly argument, in order to
	define it for the loaded image.
	(mono_image_loaded_full): New function, which receives an
	additional parameter to look for the image in the refonly or
	non-refonly section.
	(mono_image_loaded): Updated, using mono_image_loaded_full.
	(mono_image_loaded_by_guid_full): The same case that happens
	with mono_image_loaded_full.
	(mono_image_loaded_by_guid): Likewise.
	(register_image): Use the ref_only variable inside MonoImage
	to decide in which hash table store the current image.
	(mono_image_open_from_data_full): Rename
	mono_image_open_from_data to mono_image_open_from_data_full,
	adding the refonly argument, to define the ref_only variable 
	inside MonoImage.
	(mono_image_open_from_data): Return 
	mono_image_open_from_data_full.
	(mono_image_open_full): Rename mono_image_open to
	mono_image_open_full, receiving the new refonly argument,
	to pass it to inner methods.
	(mono_pe_file_open): Update this function, to open
	a MonoImage as a non-refonly image.
	(mono_image_close): Use the refonly variable inside
	MonoImage to remove the image from the correct caches.

	* image.h: Add the signatures of mono_image_open_full,
	mono_image_open_from_data_full, mono_image_loaded_full,
	mono_image_loaded_by_guid_full.

	* metadata-internals.h: Add the ref_only field to 
	MonoImage.
	
2005-07-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* icall.c (ves_icall_System_Reflection_GetReferencedAssemblies):
	Fix the last behavior, which used to load the assemblies and
	extract MonoReflectionAssemblyName information, instead of
	extract it from the metadata tables. Needed for Reflection
	Only assemblies.
	
2005-07-29  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.c
	(mono_debugger_lock, mono_debugger_unlock): g_assert() if we're
	not initialized.

	* mono-debug.c
	(mono_debug_address_from_il_offset): Check whether we have
	debugging support before attempting to take the lock.
	(mono_debug_source_location_from_address): Likewise.
	(mono_debug_source_location_from_il_offset): Likewise.
	(mono_debug_il_offset_from_address): Likewise.
	(mono_debug_address_from_il_offset): Likewise.

2005-07-29  Zoltan Varga  <vargaz@freemail.hu>

	* class.c (mono_class_from_name_case): Add support for dynamic images.
	Fixes #75650.

	* object.c (mono_class_compute_gc_descriptor): Add a workaround
	for #75479.

2005-07-28  Zoltan Varga  <vargaz@freemail.hu>
	
	* reflection.c (mono_method_get_object): Fix warning.

2005-07-28  Martin Baulig  <martin@ximian.com>

	* mono-debug.c
	(mono_debug_add_wrapper): Also write the wrapper type.

2005-07-28  Zoltan Varga  <vargaz@freemail.hu>

	* class-internals.h (MonoCachedClassInfo): Add has_nested_classes field.
	
	* class.c (mono_class_init): Avoid reading nested classes if the AOT
	data indicates the class has none.

2005-07-26  Ben Maurer  <bmaurer@ximian.com>

	* mono-debug.c, debug-mono-symfile.c: Replace the use of the
	loader lock with the debugger lock. Prevents deadlocks for beagle.

	Beagle can now run on an smp box for a weekend without any
	issues. Woohoo!

2005-07-26  Zoltan Varga  <vargaz@freemail.hu>

	* class.c (mono_bounded_array_class_get): Avoid crash if eclass is
	in a module. Fixes #75629.

2005-07-26  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (mono_debug_add_wrapper): New static method.
	(mono_debug_add_method): Call mono_debug_add_wrapper() if we're an
	interncall or a wrapper.

	* mono-debug.h (MonoDebugWrapperData): New public typedef.
	(MonoDebugDataItemType): Added `MONO_DEBUG_DATA_ITEM_WRAPPER'.
	(MONO_DEBUGGER_VERSION): Bump to 51.

	* mono-debug-debugger.c
	(mono_debugger_add_type): Removed this empty function.
	(mono_debugger_add_method): Likewise.

2005-07-22  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c (ves_icall_Type_GetMethodsByName): Call setup_vtable () 
	before accessing method->slot.

2005-07-21  Jb Evain  <jbevain@gmail.com>

	* reflection.c (method_encode_clauses/class): Handle filters clauses.
	Fixes #75010.

2005-07-21  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (emit_marshal_custom): Implement byref marshalling. Fixes
	#75587.

2005-07-20  Zoltan Varga  <vargaz@freemail.hu>

	* image.h image.c: Add mono_image_get_guid () API function.

2005-07-19  Ben Maurer  <bmaurer@ximian.com>

	There were issues when multiple threads tried to load
	assemblies. A deadlock was created between assemblies_mutex and
	mono_domain_assemblies_lock. This fixes the issue by making the
	assembly ref counting be lock free. See bug 75586.
	
	* image.c (mono_image_close): The add ref function here was using
	Interlocked operations while the unref was using a mutex and a
	--. I don't think this was ever a bug that would be exposed in a
	non-pendantic way (ie, by an embedder doing a ref on one thread
	and an unref on another), but for the sake of correctness, this is
	now Interlocked.

	* assembly.c (mono_assembly_addref): Use InterlockedIncrement
	(mono_assembly_load_reference): Call mono_assembly_addref rather
	than touching the refcount ourselves.
	(mono_assembly_close): Use InterlockedDecrement to unref the
	assembly. Don't acquire the lock unless it is actually needed.

2005-07-12  Zoltan Varga  <vargaz@freemail.hu>

	* class.c (mono_class_layout_fields): Fix calculation of has_references
	for generic types.

2005-07-12  Martin Baulig  <martin@ximian.com>

	Applying a patch from Michal Moskal <malekith@nemerle.org>.

	* metadata.c
	(mono_type_hash): Provide better hashing for generic instances.
	(mono_generic_inst_hash): Improve hashing.
	(mono_generic_class_hash): Likewise.

	* reflection.c (mymono_metadata_type_hash): Improve hashing for
	generic instances.

2005-07-12  Martin Baulig  <martin@ximian.com>

	* reflection.c (mono_reflection_create_runtime_class): Remove the
	hack for generic type definitions and non-`Run' assemblies.
	(mono_reflection_bind_generic_parameters): Also use
	`klass->wastypebuilder' to check for TypeBuilders.

2005-07-12  Zoltan Varga  <vargaz@freemail.hu>

	* class.c (mono_class_layout_fields): Fix calculation of has_references
	for generic types.

	* class.c (inflate_generic_class): Fix a leak.
	(mono_class_init): Fix calculation of gchimpl and has_finalize fields
	for generic types.

2005-07-11  Martin Baulig  <martin@ximian.com>

	* icall.c (ves_icall_Type_BindGenericParameters): Don't crash here
	on error.

2005-07-11  Martin Baulig  <martin@ximian.com>

	* loader.c (find_method): Also lookup in
	`mono_defaults.object_class' if we're an interfaces; fixes #75460.

2005-07-07  Zoltan Varga  <vargaz@freemail.hu>

	* appdomain.c (mono_domain_unload): Don't free the error message
	before passing it to mono_get_exception_...

	* reflection.c (CACHE_OBJECT): Fix the race introduced by the previous patch.
	
Thu Jul 7 19:59:31 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* threads.c: try to better guess an available RT signal (bug #75387).

2005-07-07  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (CACHE_OBJECT): Don't hold the domain lock between CHECK_OBJECT
	and CACHE_OBJECT.

2005-07-07  Martin Baulig  <martin@ximian.com>

	* class.c (mono_type_get_name_full): Return NULL for
	MONO_TYPE_NAME_FORMAT_FULL_NAME if we have any generic parameters;
	fixes #75408.

2005-07-07  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c (mono_threads_abort_appdomain_threads): Wait for threads to
	exit the appdomain as well being aborted.

	* threadpool.c: Create all threadpool threads inside the root appdomain, and
	change back to the root domain after calling managed code. This enables
	appdomains using threadpools to be unloaded.

2005-07-07  Martin Baulig  <martin@ximian.com>

	* class-internals.h
	(MonoInflatedGenericClass): Moved the `MonoType *parent' field
	into `MonoDynamicGenericClass' since we only need it for dynamic
	types.

	* reflection.c (mono_class_bind_generic_parameters): We don't need
	to compute the `parent' here.

2005-07-07  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : regenerated.

2005-07-06  Martin Baulig  <martin@ximian.com>

	* icall.c
	(ves_icall_FieldInfo_SetValueInternal): Add MONO_TYPE_GENERICINST.

	* object.c (set_value): Add MONO_TYPE_GENERICINST; fixes #75299.

2005-07-06  Martin Baulig  <martin@ximian.com>

	* metadata.c (mono_metadata_class_equal): Add MONO_TYPE_SZARRAY if
	we're doing a signature-only comparision; fixes #74945.

2005-07-06  Martin Baulig  <martin@ximian.com>

	* class-internals.h (MonoGenericClass): Moved some things out into
	a new `MonoInflatedGenericClass' type.	
	(MonoInflatedGenericClass): New type; the `klass' of a
	`MonoGenericClass' is now computed lazyly in
	mono_get_inflated_generic_class().	

	* class.c (mono_get_inflated_generic_class): New public function.
	(mono_class_inflate_generic_method): Removed the unused
	`MonoClass *' argument.
	(setup_generic_vtable): Don't call mono_get_inflated_method() on
	all the methods.
	(mono_class_create_generic): Make this static and merge it with
	mono_class_create_generic_2(); we're now called automatically from
	mono_get_inflated_generic_class().

	* loader.c (mono_method_signature): Call
	mono_get_inflated_method() here.

2005-07-06  Zoltan Varga  <vargaz@freemail.hu>

	* object.c (mono_class_create_runtime_vtable): Allow MONO_TYPE_FNPTR as
	type of fields with RVA.

	* class.c (mono_class_from_generic_parameter): Avoid calling mono_class_init ()
	for this pseudo class.
	(my_mono_class_from_generic_parameter): Likewise.
	(mono_class_init): Allow interfaces to have cctors.

2005-07-05  Zoltan Varga  <vargaz@freemail.hu>

	* domain-internals.h domain.c: Add functionality to create MonoJitInfo structures
	lazily for AOT methods.

2005-07-05  Martin Baulig  <martin@ximian.com>

	* loader.c (mono_lookup_pinvoke_call): g_ascii_strcasecmp()
	returns FALSE for a successful match, not TRUE.

2005-07-05  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c (mono_method_get_index): Optimize this a bit.

2005-07-04  Martin Baulig  <martin@ximian.com>

	* class.c
	(class_compute_field_layout): Move the check for generic type
	definitions into mono_class_layout_fields().  Fixes #74684.
	(mono_class_from_generic_parameter): Correctly compute
	`klass->parent'; fixes #75457.

	* reflection.c (register_assembly, register_module): Make sure
	`domain->rejobject_hash' is already created.

2005-07-02  Martin Baulig  <martin@ximian.com>

	* class-internals.h
	(MonoGenericClass): Move `count_ifaces' and `ifaces' into
	`MonoDynamicGenericClass'.	

2005-07-01  Lluis Sanchez  <lluis@ximian.com>

	* icall.c: In ves_icall_InternalExecute() dont't assert if the value
	returned by a field getter is null, since null is a valid value.

2005-07-01  Martin Baulig  <martin@ximian.com>

	* reflection.c (mono_reflection_generic_class_initialize): Update
	the `dgclass->fields [i].parent' to the correct class.
	(mono_image_get_fieldref_token): Use the declaring type, not the
	reflected type.

2005-07-01  Martin Baulig  <martin@ximian.com>

	* loader.c (find_method): Also look in the interfaces; fixes #75429.

2005-06-30  Ben Maurer  <bmaurer@ximian.com>

	* threads.c (thread_cleanup): assert that thread != NULL
	(wait_for_tids_or_state_change): We were using the wrong variable
	when accessing wait->threads. `i' was always out of the bounds of
	the array.

2005-06-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* loader.c: map user32 and kernel32 to libMonoSupportW

2005-06-28  Zoltan Varga  <vargaz@freemail.hu>

	* appdomain.c (unload_thread_main): Mark this as WINAPI.

2005-06-28  Martin Baulig  <martin@ximian.com>

	* loader.c (method_from_methodspec): Fix #75334.

2005-06-28  Martin Baulig  <martin@ximian.com>

	Fix #74953 - Arrays now implement the generic IList<T> interface
	on the 2.0 platform.

	* class-internals.h (MonoDefaults): Added `generic_array_class'.

	* reflection.c (mono_class_bind_generic_parameters): New public
	function; similar to mono_reflection_bind_generic_parameters(),
	but operates on a `MonoType *' and not on a `MonoReflectionType *'.

	* domain.c (mono_init_internal): Try to initialize.
	`mono_defaults.generic_array_class' here; this'll only succeed if
	we're using the 2.0 corlib.

	* icall.c
	(ves_icall_System_Array_InternalArray_GetGenericValueImpl): Added
	interncall for "System.Array/InternalArray`1:GetGenericValueImpl".
	(mono_lookup_internal_call): Added support for nested classes.

	* loader.c
	(mono_get_method_from_token): Set `result->signature->pinvoke' if
	we're an interncall and have generic arguments.

	* class.c
	(mono_class_inflate_generic_methods): Allow interncalls and PInvoke.
	(mono_bounded_array_class_get): If we're on the 2.0 corlib, use an
	instance of System.Array.InternalArray<T> for arrays, so they
	implement the generic IList<T> interface.

2005-06-27  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (emit_marshal_string): Applied patch from Itamar Rogel
	(chastamar@yahoo.com). Fixes #75374.	

2005-06-27  Atsushi Enomoto <atsushi@ximian.com>

	* culture-info-table.h: regenerated.

2005-06-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* icall.c: handle spaces correctly for base64 strings.

2005-06-26  Ben Maurer  <bmaurer@ximian.com>

	* *.c: Kill some warnings.

2005-06-23  Duncan Mak  <duncan@novell.com>

	* socket-io.c (is_loopback): Cast 'ptr' to 'struct in6_addr *' so
	that this builds on Solaris 10 (x86).

2005-06-23  Martin Baulig  <martin@ximian.com>

	* class.c
	(mono_type_get_name_recurse): Don't use a duplicate '[', ']' for
	generic type definitions.

2005-06-23  Martin Baulig  <martin@ximian.com>

	Fix #75331.

	* metadata.c (mono_class_get_overrides): Renamed to
	mono_class_get_overrides_full() and added a `MonoGenericContext *'.
	(method_from_method_def_or_ref): Added `MonoGenericContext *' and
	pass it to mono_get_method_full().

2005-06-22  Ben Maurer  <bmaurer@ximian.com>

	* reflection.c (mono_reflection_create_runtime_class): take the
	mono_domain_lock in this method. Prevents deadlocks

2005-06-22  Martin Baulig  <martin@ximian.com>

	* loader.c (method_from_methodspec): Fix #75330.

2005-06-22  Martin Baulig  <martin@ximian.com>

	* reflection.c (type_get_qualified_name): Use
	mono_type_get_name_full() with MONO_TYPE_NAME_FORMAT_REFLECTION.
	(_mono_reflection_get_type_from_info): Added `MonoImage *image'
	argument; use it if we don't have an assembly name.

2005-06-22  Lluis Sanchez Gual  <lluis@novell.com>

	* object.c: In mono_message_init, set "copy out" flag for in
	parameters with the [Out] flag.

2005-06-21  Martin Baulig  <martin@ximian.com>

	* class.c
	(mono_type_get_name_recurse): Correctly handle MONO_TYPE_SZARRAY
	and MONO_TYPE_PTR.

2005-06-21  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_init): Don't initialize `class->fields' for
	generic instances since they're initialized again in
	compute_field_layout().	
	(compute_field_layout): Set the field's `generic_info' here; fix
	#75320.	

2005-06-21  Martin Baulig  <martin@ximian.com>

	* class-internals.h
	(MonoGenericMethod): Added `MonoGenericClass *generic_class'.

	* metadata.c (mono_metadata_generic_method_equal): Also
	distinguish the `generic_class'; fixes #75334.

2005-06-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* domain.c:
	* appdomain.c:
	* domain-internals.h:
	* reflection.c: 'domain_assemblies' field is now protected by its own
	lock. Don't call into managed code to run the AssemblyLoad event if we
	now there are no registered delegates for it.

2005-06-20  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_is_assignable_from): Use a custom version of
	mono_class_has_parent() to make things work for generic instances;
	fix #75300.

2005-06-20  Martin Baulig  <martin@ximian.com>

	* loader.c (method_from_methodspec): Apply a patch from
	Kamil Skalski <nazgul@nemerle.org> to fix #75296.

2005-06-20  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_init): Reverted Zoltan's last change; it
	breaks generics.

2005-06-19  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c (wait_for_tids_or_state_change): Add missing locking.

2005-06-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* socket-io.c: fix the index in the socket array for writable/error
	sockets. Fixes bug #75306.

2005-06-17  Zoltan Varga  <vargaz@freemail.hu>

	* class.c (mono_class_init): Allow interfaces to have static ctors.

2005-06-17  Martin Baulig  <martin@ximian.com>

	* loader.c (method_from_methodspec): Use `context->container' when
	parsing the `gmethod->inst'.

2005-06-17  Martin Baulig  <martin@ximian.com>

	* class.c (mono_type_get_name_recurse): Don't add the assembly
	name for type arguments.

2005-06-15  Martin Baulig  <martin@ximian.com>

	* reflection.c (mono_image_get_inflated_method_token): Encode
	correct klass; fixes #75260.

2005-06-13 Michal Moskal <malekith@nemerle.org>

	* icall.c: Make GetCorrespondingMethod/Constructor take
	MonoReflectionMethod method not MonoMethod. Removed
	MonoType.GetCorrespondingField, and make
	MonoGenericType.GetCorrespondingField take name not
	MonoClassField.

2005-06-13  Michal Moskal <malekith@nemerle.org>

        * reflection.c (field_encode_signature, encode_locals):
         Make sizes of buffers for types larger (for big generic types).
	 (create_generic_typespec,
	 mono_reflection_sighelper_get_signature_local,
	 mono_reflection_sighelper_get_signature_field):
	 Add asserts for too small buffers.

2005-06-15  Martin Baulig  <martin@ximian.com>

	* icall.c (ves_icall_MonoGenericClass_GetParentType): Return NULL
	if our parent is not a dynamic type.

2005-06-15  Martin Baulig  <martin@ximian.com>

	* class-internals.h (MonoTypeNameFormat): New enum.

	* class.c
	(mono_class_get_name_full): Renamed to mono_type_get_name_full().
	(mono_type_get_full_name): Removed.
	(mono_type_get_name_full): Take a `MonoTypeNameFormat format'
	argument instead of the boolean's.

	* icall.c (ves_icall_System_MonoType_getFullName):
	Added `gboolean assembly_qualified'.	

	* reflection.h
	(MonoTypeNameParse): Added `GPtrArray *type_arguments'.

	* reflection.c (mono_reflection_parse_type): Parse the new type
	name format.

2005-06-12 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* icall.c: no need to convert from utf16 to utf8 and then back again
	after the call to GetLogicalDrives.

2005-06-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* icall.c: frombase64. Fix problems exposed by new tests.

2005-06-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* icall.c: added internal calls for converting char [] and strings in
	base64 into byte [].

2005-06-10  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_create_generic_2): Read the nested classes
	from the metadata rather than from `gklass->nested_classes' since
	`gklass' might not be initialized yet.

2005-06-09  Duncan Mak  <duncan@novell.com>

	* *.h: Added G_BEGIN_DECLS and G_END_DECLS where appropriate to
	all public headers. Fixes #74919.

2005-06-09  Lluis Sanchez Gual  <lluis@novell.com>

	* domain.c: The key for proxy_vtable_hash is now a pointer
	array. Added new GHashFunc and GCompareFunc functions for this.

	* class.h: The list of interfaces in MonoRemoteClass is known in
	advance and can't grow (we create a new MonoRemoteClass if needed),
	so now the interface array can be allocated together with
	MonoRemoteClass.
	
	* object.c: Added a new method create_remote_class_key.
	Fixed mono_remote_class so it does not depend on
	mono_upgrade_remote_class.
	Removed extend_interface_array.
	Added new method clone_remote_class(), which makes a copy of a remote
	class and adds a new interface or class to it.
	mono_upgrade_remote_class() now creates a new remote class (or gets
	it from the cache) if an vtable upgrade is needed. In this way
	we make sure that other objects sharing the same remote class
	don't get the new vtable with unwanted interfaces.
	
	* object-internals.h:
	* object.h: Moved mono_upgrade_remote_class to object-internals.h.
	
	* marshal.c: Track changes in mono_upgrade_remote_class().

2005-06-08  Kamil Skalski <nazgul@nemerle.org>
	* icall.c: Add runtime methods for obtaining members of inflated
	class, which were created from supplied non-inflated members. It
	is used in internal Get{Method,Constructor,Field} methods in
	System.Type

2005-06-09  Martin Baulig  <martin@ximian.com>

	* reflection.c
	(mono_reflection_bind_generic_method_parameters): Fix #75169.

2005-06-08  Carlos Alberto Cortez <calberto.cortez@gmail.com>
	* reflection.c (mono_image_basic_init): Define
	Version in MonoDynamicAssembly. 
	
2005-06-08  Martin Baulig  <martin@ximian.com>

	Fix #75136.

	* loader.c
	(mono_method_signature_full): New public method; takes a
	`MonoGenericContext *'.
	(find_method): Use mono_method_signature_full() and pass the
	klass'es context to it.

	* class.c (mono_class_is_inflated_method): Use
	mono_method_signature_full() and pass the context to it.

Wed Jun 8 19:26:38 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* object.c: add proper locking in mono_remote_class_vtable(),
	fixes possible memory corruption.

2005-06-08  Michael Meeks  <michael.meeks@novell.com>

	* marshal.c (mono_remoting_marshal_init): set
	initialized after initialization.

2005-06-08  Atsushi Enomoto  <atsushi@ximian.com>

	* locales.c : hush.

2005-06-06  Michael Meeks  <michael.meeks@novell.com>

	* object.c (extend_interface_array): fix really silly
	memory corrupting / comparison bug.

2005-06-07  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* reflection.c: Functions added to support the creation
	of CustomAttributeData, which includes Attribute data
	used by ReflectionOnly methods.

	* reflection.h:  mono_reflection_get_custom_attrs_data and
	 mono_custom_attrs_data_construct added (functions exposed).

	 * icall.c: Added mono_reflection_get_custom_attrs_data
	 as icall.
	
2005-06-07  Zoltan Varga  <vargaz@freemail.hu>

	* Makefile.am (libmonoruntime_la_SOURCES): Revert last change at
	lupus's request.

2005-06-06  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c (ves_icall_Mono_Runtime_GetDisplayName): Fix warning.

	* reflection.c (reflection_methodbuilder_to_mono_method): Fix encoding of
	dynamic DllImportAttribute.

	* icall.c (ves_icall_MonoMethod_GetDllImportAttribute): Fix decoding of 
	dynamic DllImportAttribute.

	* Makefile.am (libmonoruntimeinclude_HEADERS): Export tabledefs.h too.
	Fixes #75162.

2005-06-05 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threads.c: avoid segfault when an unstarted thread is aborted.

2005-06-05  Kornél Pál <kornelpal@hotmail.com>

	* icall.c: Added ves_icall_Mono_Runtime_GetDisplayName:
	Returns the name and version of the runtime for reporting.

2005-06-04 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* appdomain.c: bump corlib version.
	* object-internals.h: new field in MonoReflectionAssembly.

2005-06-03 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* object-internals.h: Carlos forgot to add this field.

2005-06-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* icall.c: Added create_version to create instances
	of Version of MonoReflectionAssemblyName. This change helps
	the AssemblyName tests to keep running fine.
	
2005-06-03  Lluis Sanchez Gual  <lluis@novell.com>
  
	* object.c (mono_method_return_message_restore): A somehow less
	intrusive fix for #75138.

2005-06-03  Raja R Harinath  <rharinath@novell.com>

	* object.c (mono_method_return_message_restore): Fix computation
	of expected number of out args.

2005-06-02  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_image_get_method_info): Fix the case when the
	charset is empty.

2005-06-02  Lluis Sanchez Gual  <lluis@novell.com> 

	* object.c: Added missing null check in
	  mono_method_return_message_restore.

2005-06-02  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_image_get_method_info): Handle the case when
	dllentry is empty.

2005-06-02  Lluis Sanchez Gual  <lluis@novell.com>

	* object.c: When creating the vtable for a proxy, take into account
	all inherited interfaces, not only the ones registered in
	iclass->interfaces. This fixs bug #74996.
	Also, in mono_method_return_message_restore, verify that the array
	of out args has the expected lengh.

2005-06-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* socket-io.c: update the timeout in Poll when the call is interrupte.

2005-06-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* socket-io.c: support abort/suspend in Select_internal after last
	change.

2005-06-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: remove warning.

2005-06-01 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* icall.c:
	* socket-io.[ch]: Select_internal uses poll() now when available, thus
	removing the 1024 limit from select(). Runtime part of the fix for
	bug #71203.

2005-05-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* socket-io.c: when resolving the addresses for the same
	host returned by gethostname(), get the local IPs from the interface
	list. Loopback addresses are discarded if the are interfaces up with
	non-loopback ones. Fixes bug #63265.

2005-05-27  Vladimir Vukicevic  <vladimir@pobox.com>

	* appdomain.c, verify.c, object-internals.h, reflection.c:
	bumped corlib number to 36, and added new extra_flags field
	to ReflectionMethodBuilder and friends.  Fixes #75060.

Fri May 27 14:45:56 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* gc.c: register a new weak link only if the object is non-null
	(fixes bug#75047).

2005-05-26  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info.h : short time pattern too.

2005-05-26  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info.h : expand long time pattern string length.

2005-05-25  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : update (more French date format; #72788).

2005-05-25  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c (ves_icall_InternalInvoke): Avoid type checks on this if
	the method is static. Fixes #75029.

2005-05-25  Lluis Sanchez Gual  <lluis@novell.com>

	* reflection.c: Update the table_idx field of method builders after
	saving the module, since it can change. This is a workaround for
	bug #74914. 

2005-05-25  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : update (additional French date format).

2005-05-20  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c (ves_icall_type_Equals): Revert last change.
	
	* icall.c (ves_icall_type_Equals): Turn the g_print into an assert.

	* icall.c (ves_icall_type_GetTypeCode): Rename the icall to GetTypeCodeInternal.

2005-05-20  Sebastien Pouliot  <sebastien@ximian.com>

	* class-internals.h: Added executioncontext_class field to 
	MonoDefaults structure.
	* domain.c: Cache System.Threading.ExecutionContext class in 
	mono_defaults.
	* object.c: Capture the ExecutionContext for asynchroneous calls in
	 mono_async_result_new.
	* object-internals.h: Added execution_context and original_context 
	fields to MonoAsyncResult. Added execution_context to MonoThread.
	* security-manager.c|.h: Added mono_get_context_capture_method to 
	return the capture method (if required by the security manager or by
	the framework version used).
	* threadpool.c: Apply capture (if present) ExecutionContext in 
	mono_async_invoke and revert to original context after it completes.

2005-05-19  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : updated (real hacky solution for zh-CHT).

2005-05-18  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : zh-CHT related workaround.

2005-05-12  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (emit_marshal_custom): Add some error checking and call the
	methods in the ICustomMarshaler interface. Fixes #74875.
	
	* marshal.c (emit_marshal_array): Implement [Out] marshalling in
	native->managed wrappers.

2005-05-12  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.cs (mono_debugger_lock/unlock): Always lock
	here and use the loader lock.

	* mono-debug.c: Properly lock when the debugger is not attached.
	(mono_debug_init): Release the initial lock if we're not running
	in the debugger.

2005-05-12  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (emit_marshal_custom): Pass through NULL values without
	calling the custom marshalling routines.

	* marshal.c (emit_ptr_to_object_conv): Implement ftnptr->delegate
	conversion in structures. Fixes #74882.

2005-05-12  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : zh-* cultures were missing.

2005-05-12  Lluis Sanchez Gual  <lluis@novell.com>

	* threads.c: Added a new event background_change_event which is signaled
	when a thread changes its background mode.
	Moved here several checks previously done in managed code. The checks
	require the thread lock, and using the thread lock in managed code
	can result in deadlocks.
	Merged Start_internal and Thread_internal into a single method. Now 
	Thread_internal does all work of creating and starting a thread.
	Added icalls for setting and getting the state of the object. Moved from
	managed code to avoid locking there.
	Added wait_for_tids_or_state_change() which is called instad of
	wait_for_tids when waiting for non-backround threads to end. This method
	will return if one of the threads ends or the background_change_event
	is signaled.
	* threadpool.c: use ves_icall_System_Threading_Thread_SetState() to set
	the background mode. This method signals the background_change_event
	event.
	* icall.c:
	* threads-types.h: Added icalls for ClrState, SetState and GetState, and
	removed Start_internal.
	
2005-05-11  Martin Baulig  <martin@ximian.com>

	* mono-debug.h (MonoSymbolTable, MonoDebugMethodAddress): Changed
	to order of some fields to get proper alignment on 64-bit machines.

2005-05-11  Martin Baulig  <martin@ximian.com>

	* mono-debug.c, mono-debug-debugger.c: Revert Paolo's locking
	changes as they're broken and completely fuck up the debugger.

	* mono-debug.c (mono_debug_add_method): Properly unlock on error.

2005-05-10  Martin Baulig  <martin@ximian.com>

	* reflection.c (mono_reflection_generic_class_initialize): Don't
	call mono_class_setup_parent() here.

2005-05-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* metadata/socket-io.c: on windows, getsockopt/setsockopt for
	send/receive timeout use an integer in milliseconds. We were using a
	struct timeval.

2005-05-06 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* locales.c:
	(internal_get_cultures): reserve the first slot of the array for the
	InvariantCulture, which will be filled in managed code.

2005-05-06  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_image_fill_module_table): Initialize the
	GENERATION field as well.

2005-05-05 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* monitor.c: ignore calls to Monitor.Exit even if no one ever called
	Monitor.Enter on the object.

2005-05-05  Lluis Sanchez Gual  <lluis@novell.com>

	* threads.c: Enable the wait for running threads when exiting.
	* icall.c: Suspend all threads before exiting.

2005-05-05  Zoltan Varga  <vargaz@freemail.hu>

	* assembly.c (mono_assembly_load_reference): Fix warning.

2005-05-04 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: changed the default number of threads per cpu. From now
	on, the default will be 20 + (5 * number of cpus) instead of 50.

2005-05-04  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c (mono_method_get_signature_full): Add locking here.

2005-05-03  Lluis Sanchez Gual <lluis@novell.com>

	* appdomain.c: Moved methods for parsing and freeing assembly
	names to assembly.c.
	* assembly.c, domain-internals.h: Created public methods for parsing
	assembly names. Fixed mono_assembly_load_with_partial_name:
	it now finds the best match, taking into account the version,
	token and culture specified in the partial name. Also return
	the latest version if no version information is specified.

Mon May 2 15:47:57 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* threadpool.c: replace check for SocketAsyncCall class.

2005-05-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool-internals.h:
	* Makefile.am: added threadpool-internals.h

	* threadpool.c: call mono_unhandled_exception on exceptions not handled
	that happen in threadpool threads (tested on MS).
	(mono_thread_pool_remove_socket): new function that dispatch any pending
	AIO call on a socket that is closing. By now only epoll really needs it,
	as select/poll wake up when the socket closes.


	* socket-io.c: call mono_thread_pool_remove_socket in Close_internal.

2005-05-01  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_managed_wrapper): Handle changing the calling convention.

2005-05-01  Lluis Sanchez Gual  <lluis@novell.com>

	* gc.c: In mono_gc_cleanup(), wait for 2 seconds, not 2000 seconds.

2005-04-30  Lluis Sanchez Gual  <lluis@novell.com>

	* threads.c: In mono_thread_suspend_all_other_threads, if a thread
	has an abort request, convert it into a suspend request.

2005-04-30  Ben Maurer  <bmaurer@ximian.com>

	* marshal.c (mono_marshal_get_managed_wrapper): give a friendly
	warning for the usage of `UnmanagedFunctionPointerAttribute' which
	is not supported yet.

2005-04-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* image.c: register assemblies loaded from data (bundles) in the loaded
	assemblies hash. Fixes bug #74772.

2005-04-29  Martin Baulig  <martin@ximian.com>

	* class.c (mono_type_get_name_recurse): Update to the new naming
	schema from the latest .NET 2.x beta2.
	(mono_class_setup_vtable_general): If we're a generic instance,
	copy the vtable from our generic type definition and inflate all
	the methods in it.

	* loader.c (find_method): Update to the new naming schema from the
	latest .NET 2.x beta2.

2005-04-29  Raja R Harinath  <harinath@gmail.com>

	* class.c (mono_class_init): Add a mono_loader_unlock to the
	#74734 fix.

2005-04-28  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c (ves_icall_System_Environment_Exit): Remove the 
	suspend_all_other_threads () call for the time being, since it can hang.

	* threads.c (mono_thread_manage): Similarly, disable the waiting for
	the background threads to exit, since it can also hang.

	* class.c (mono_class_init): Applied patch from Ankit Jain 
	(radical@gmail.com). Avoid pending init errors when a field refers
	to a nested class using a typeref. Fixes #74734.

	* icall.c (ves_icall_System_Reflection_Assembly_GetModulesInternal): Fix
	this for dynamic modules.

2005-04-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threads.c: don't wait for threads that are in the process of aborting
	or aborted. Set the 'shutting_down' flag before cleaning the threadpool
	and waiting for background threads to finish. This makes xsp and
	mod-mono-server exit without random length delays and/or hangs.

2005-04-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* icall.c: remove duplicate assignment from GetReferencedAssemblies.

2005-04-25  Zoltan Varga  <vargaz@freemail.hu>

	* class.c (mono_class_is_assignable_from): Call is_assignable_to for
	dynamic types to prevent infinite loops. Fixes #74727.

	* reflection.c (mono_reflection_call_is_assignable_from): Rename to
	..._is_assignable_to.

2005-04-25  Sebastien Pouliot  <sebastien@ximian.com>

	* security.c: Fixed #74698 where sysconf returned -1 on FreeBSD.

2005-04-25  Martin Baulig  <martin@ximian.com>

	Upgrade to the latest .NET 2.x beta (Visual Studio 2005 Beta 2).

	* domain.c
	(supported_runtimes): Change "v2.0.40607" -> "v2.0.50215".

	* row-indexes.h (MONO_GENERICPARAM_KIND): Removed.

	* reflection.c (build_compressed_metadata): Set metadata header
	version to 2.0.

2005-04-23  Zoltan Varga  <vargaz@freemail.hu>

	* sysmath.c (ves_icall_System_Math_Round2): Use modf to decompose the
	number into an integral and a decimal part. Fixes #70473.

	* marshal.c (ves_icall_System_Runtime_InteropServices_Marshal_OffsetOf): Ignore static fields. Fixes #74703.

2005-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : reflected the latest locale-builder output.

2005-04-23 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: check for SuspendRequested too when deciding if
	mono_thread_interruption_checkpoint should be called.

2005-04-23 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* appdomain.[ch]: added function to set the shutting_down flag to TRUE.
	* threads.c: remove interruption_mutex and use Interlocked instead. When
	suspending all the threads, wait for all the suspended events at once.
	If we're shutting down and get an APC that is going to be queued,
	call mono_thread_execute_interruption immediately, as the thread might
	be sleeping on a pthread condition or mutex.

	* icall.c: call mono_runtime_set_shutting_down before suspending the
	threads.

	Fixes bug #74693. And now xsp is happier when exiting.

2005-04-22  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c (mono_stack_walk): Fix #74690.

2005-04-22  Martin Baulig  <martin@ximian.com>

	* mono-debug.h (MonoDebugMethodJitInfo): Added
	`MonoDebugMethodJitInfo *jit'.

	* mono-debug.c (mono_debug_read_method): Cache the
	MonoDebugMethodJitInfo in `address->jit'.
	(mono_debug_free_method_jit_info): New public method.

2005-04-22  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_is_assignable_from): Disallow
	type parameter -> interface.

2005-04-21  Dick Porter  <dick@ximian.com>

	* threads.c (mono_thread_create): Turn an assertion into an error.

2005-04-20  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c object.c icall.c: Fix some gcc 4.0 warnings.
	
	* threads.c marshal.h marshal.c exceptions.h exceptions.c appdomain.c: 
	Fix some gcc 4.0 warnings.

Wed Apr 20 16:09:06 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* file-io.c: fix alt dir separator char on unix systems
	and cleanup (fixes bug #71214).

2005-04-19  Lluis Sanchez Gual  <lluis@novell.com>

	* marshal.c: Use CALLVIRT instead of CALL when dispatching
	a call to a remote domain, since the method may be an
	interface method in the client domain. This fixes bug #74192.

2005-04-17 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: recv/send are now performed before going back to managed
	code to save one transition.

2005-04-16 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* metadata/socket-io.c: fixed semantics in Socket.Blocking icall.

	* metadata/threadpool.c: removed hack to workaround the bug above.

	Fixes bug #74618.

2005-04-16  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c reflection.h: Fix handling of parameter defaults in
	dynamic methods. Also fixes handling of parameter attributes.
	Fixes #74609.

	* mono-debug.c (mono_debug_close_image): Fix warning.

2005-04-15 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* socket-io.h: replaced old unused field with new 'blocking'.
	* threadpool.c: restore socket blocking state on windows(tm).

2005-04-14  Sebastien Pouliot  <sebastien@ximian.com>

	* icall.c: don't return the codebase in the AssemblyName[] returned by
	ves_icall_System_Reflection_Assembly_GetReferencedAssemblies.
	* object-internals.h: Removed FIXME (fields were presents) and fixed
	versioncompat declaration.

2005-04-14 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: sometimes we get EBADF from epoll but the epollfd is
	not closed, so don't cleanup when it happens.

2005-04-13  Chris Toshok  <toshok@ximian.com>

	* mono-debug-debugger.h: change prototype for
	mono_debugger_lookup_type.

	* mono-debug-debugger.c (mono_debugger_lookup_type): reinstate
	this function, although it should probably be named
	mono_debugger_init_type.

2005-04-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: fix non-AIO case.

2005-04-13  Zoltan Varga  <vargaz@freemail.hu>

	* profiler.c (mono_profiler_install_simple): Add a 'jit' option to
	the built-in profiler to measure just JIT compilation times.

2005-04-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: the epollfd might be closed by another thread at
	any time, so ignore EBADF at treat it as a "we're closing" sign.

2005-04-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: release the semaphores with a count equals to the number
	of working threads in both IO and regular pools. Fixed typo that messed
	up the count of IO pool threads. Don't initialize the pipe handles if
	we're using epoll.

2005-04-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: some systems don't like a NULL when deleting the socket
	from epoll.

2005-04-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: fix semaphore allocation.

2005-04-12 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: added epoll() based implementation for asynchronous IO
	that is used instead of the default poll() when available.
	It can be disabled by setting MONO_DISABLE_AIO.

2005-04-12 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: windows needs 'closesocket' and instead of returning
	0 when the stream is closed while in select, it returns -1. Fixes bug
	#74573.

2005-04-12  Zoltan Varga  <vargaz@freemail.hu>

	* class.c (class_compute_field_layout): Fix the regression caused by
	the previous try.

2005-04-12 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: separate pool for socket async. IO.
	* threadpool.h: mono_max_worker_threads is not a global any more.

2005-04-10  Zoltan Varga  <vargaz@freemail.hu>

	* class.c (class_compute_field_layout): Fix #74549.

2005-04-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: select() on windows doesn't allow pipe handles, soooo
	use 2 connected sockets instead.

2005-04-08  Miguel de Icaza  <miguel@novell.com>

	* mono-config.c: Add new entry point for mkbundle
	mono_config_parse_memory. 

2005-04-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: removed another unused function.

2005-04-08  Ankit Jain  <radical@corewars.org>

	* reflection.c (get_default_param_value_blobs): Add 'types'
	parameter to get the types encoded in the constant table.
	(mono_param_get_objects): Use the type from the constant table,
	not the type of the parameter, when creating default values.
	Handle null default values correctly.

2005-04-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* file-io.c:
	* file-io.h:
	* threadpool.c:
	* threadpool.h:
	* icall.c:
	* socket-io.c: removed dead code for async IO.

2005-04-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* socket-io.h: 2 more fields in MonoSocketAsyncResult.

	* threadpool.c: intercept socket async. calls and pass them to a thread
	that is polling and dispatching the job items to the threadpool as
	socket become ready. Fixes bugs #71217, #71933.

	* icall.c: Removed AsyncReceive and AsyncSend. Speed up for copies
	between char and short/ushort arrays.

	* socket-io.c: remove dead code.

2005-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* locales.c,
	  icall.c : removed InternalToUpper_Comp() and
	  InternalToLower_Comp().

2005-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* char-conversions.h : The tables were incorrectly generated. Should
	  be generated against invariant culture.

2005-04-04  Zoltan Varga  <vargaz@freemail.hu>

	* object.c (mono_runtime_invoke_array): Fix return value when 
	passing pre-created valuetype objects to ctors.

	* gc.c (mono_gchandle_is_in_domain): Applied patch from Jon Larimer 
	(jlarimer@gmail.com). Avoid crashes when the wrapper object is null.
	Fixes #74338.

2005-03-30  Sebastien Pouliot  <sebastien@ximian.com>

	* domain.c: removed g_assert for runtimesecurityframe_class. This is 
	only used with --security and hides the wrong corlib version error.

2005-03-30  Joshua Tauberer  <tauberer@for.net>

	* class.c: Changed mono_class_name_from_token so that types
	outside of a namespace don't have an initial period.  Improved
	the g_warning message used in _mono_class_get when loading
	fails.
	* assembly.c: In mono_assembly_load_reference, when an assembly
	can't be found, "No such file or directory" is misleading and
	unhelpful because a few paths were checked for the presence of
	the assembly.  When that happens (ENOENT), display a nicer
	message indicating the directories that were searched.  In all
	cases, the warning is made easier to read for non-hackers.

2005-03-29  Sebastien Pouliot  <sebastien@ximian.com>

	* assembly.c: Set MONO_ASSEMBLIES to NULL when compiling from a VS.NET
	project/solution.
	* appdomain.h|domain.c: Removed inline from functions.
	* appdomain.c: Reduced warnings when compiling on windows.
	* icall.c: Fixed output_debug declaration to gunichar2*.
	* mono-config.c: Reduced warnings when compiling on windows.
	* rand.c: Added missing "windows.h". Added missing return value.
	* rawbuffer.c: Added missing winsock2.h for windows.
	* sysmath.h: Added mono-compiler.h header to allow/ease 
	compilation with non-GCC compilers.
	* threads.c: Fixed declarations to compile with VS.NET C compiler.
	Removed cast warnings.

	Adapted from the work of J Lothian (for VC6).

2005-03-29  Zoltan Varga  <vargaz@freemail.hu>

	* assembly.c (mono_assembly_load_corlib): Do not try loading corlib
	from default_path.

2005-03-27  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_managed_wrapper): Fix bogus assert on
	the 2.0 profile.

2005-03-27  Raja R Harinath  <harinath@gmail.com>

	* Makefile.am (assembliesdir): Fix.  If it is arch-dependent it
	has to be in $(exec_prefix).  $(prefix) is for arch-independent
	stuff, and it would probably use $(prefix)/share rather than
	$(prefix)/lib.

2005-03-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* console-io.c: added 2 includes that might be missing.

2005-03-24  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_managed_wrapper): Fix crashes in 2.0
	profile.

	* reflection.c (create_custom_attr): Allocate the params array using
	alloca so it gets GC tracking.

2005-03-23  Chris Toshok  <toshok@ximian.com>

	* mono-debug-debugger.c (mono_debugger_runtime_invoke): comment
	out some spew.

2005-03-24  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (assembly.lo, mono-config.lo): Rebuild when Makefile
	changes to pick up any changes in prefix, etc.

2005-03-23  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_managed_wrapper): Remove fixme.
	
	* marshal.c (mono_marshal_get_managed_wrapper): Remove debugging output.
	* marshal.c (mono_marshal_get_managed_wrapper): Add support for the modopt(CallConvCdecl).

2005-03-23  Zoltan Varga  <vargaz@freemail.hu>

	* class-internals.h object-internals.h class.c reflection.c: Extend the
	mono_lookup_dynamic_token () function to return the class of the
	token as well. 

	* class.c (mono_ldtoken): Handle MEMBERREFS in the dynamic case as
	well. Fixes #73848.

2005-03-23  Sebastien Pouliot  <sebastien@ximian.com>

	* security-manager.c: Skip inheritance checks for intra-corlib
	class inheritance and method overrides. This skips a lot of checks
	and (anyway) permissions cannot work until corlib is loaded.

2005-03-23  Martin Baulig  <martin@ximian.com>

	* marshal.c (mono_marshal_get_stfld_wrapper): Add support for
	MONO_TYPE_GENERICINST.	

2005-03-23  Martin Baulig  <martin@ximian.com>

	* metadata.c (mono_type_to_unmanaged): Add MONO_TYPE_GENERICINST.

Tue Mar 22 16:57:01 CET 2005 Paolo Molaro <lupus@ximian.com>

	* class.c: added locking comments to some functions.
	Cache the interface offsets arrays (saves about 20 KB
	of runtime memory in a typical app).
	Reduce the time overhead in mono_class_setup_supertypes ().

Tue Mar 22 16:35:57 CET 2005 Paolo Molaro <lupus@ximian.com>

	* icall.c: speedup and fix leaks in GetMethodsByName and
	GetPropertiesByName.

Tue Mar 22 16:34:29 CET 2005 Paolo Molaro <lupus@ximian.com>

	* reflection.c: some locking fixes.

Tue Mar 22 15:13:54 CET 2005 Paolo Molaro <lupus@ximian.com>

	* metadata.c: added missing break in case statement.

2005-03-22  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_runtime_invoke): Add support for
	typedbyref return values. Fixes #73941.

2005-03-17  Sebastien Pouliot  <sebastien@ximian.com>

	* security-manager.c|h: Added demandunmanaged method and 
	suppressunmanagedcodesecurity class to MonoSecurityManager.
	Renamed aptc class to allowpartiallytrustedcallers.

2005-03-17  Martin Baulig  <martin@ximian.com>

	* class.c (inflate_generic_type): Add MONO_TYPE_ARRAY.

2005-03-16 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* file-io.c: disabled file async. IO using aio_*. It uses the
	threadpool now. Workaround for bug #73718.

Wed Mar 16 18:08:00 CET 2005 Paolo Molaro <lupus@ximian.com>

	* assembly.h, mono-config.c: added code to deal with bundled configs
	for bundled assemblies.

Wed Mar 16 16:34:38 CET 2005 Paolo Molaro <lupus@ximian.com>

	* *.c, private.h: cleanup, removing old private.h header file.

2005-03-16  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_image_get_method_info): Encode best_fit_mapping
	and throw_on_unmappable_char attributes.

2005-03-13  Sebastien Pouliot  <sebastien@ximian.com>

	* process.c: Fix buffer length in ves_icall_System_Diagnostics_Process
	_ProcessName_internal.

2005-03-13  Zoltan Varga  <vargaz@freemail.hu>

	* object.c (mono_array_new_full): Fix aligning of array size. Fixes
	#73631.

	* icall.c threads.c threads-types.h: Remove slothash icalls as they
	are no longer used.

2005-03-11  Zoltan Varga  <vargaz@freemail.hu>

	* object.c (compute_class_bitmap): Add support for generics. Fixes
	#73527.

2005-03-10  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_reflection_create_runtime_class): Fix 2.0 build.

2005-03-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* filewatcher.c: commented out the code for windows watcher, as we don't
	use it (we use the managed implementation instead).

2005-03-10  Zoltan Varga  <vargaz@freemail.hu>

	* object-internals.h (MonoThread): Remove 'unused1' field.

	* appdomain.c: Bump corlib version.

	* marshal.c: Remove calls to Reset/RestoreDataStoreStatus ().

	* reflection.c (mono_reflection_create_runtime_class): Remove the
	AssemblyBuilder.Save optimization since it causes too many problems.

2005-03-10  Sebastien Pouliot  <sebastien@ximian.com>

	* exception.c|h: Added mono_get_exception_reflection_type_load to
	create a ReflectionTypeLoadException object.
	* icall.c: Updated ves_icall_System_Reflection_Assembly_InternalGetType
	to return NULL is a InheritanceDemand fails during reflection. Updated
	ves_icall_System_Reflection_Assembly_GetTypes to throw a 
	ReflectionTypeLoadException if an InheritanceDemand fails during 
	reflection. Added icall mapping for GetLinkDemandSecurity.
	* security-manager.c|h: Added ves_icall_System_Security_
	SecurityManager_GetLinkDemandSecurity internal call to return the
	class and methods permissions set for a LinkDemand. Removed unused
	fields in MonoSecurityManager.

2005-03-10  Martin Baulig  <martin@ximian.com>

	* class.c (mono_bounded_array_class_get): Initialize `eclass' if
	it's a generic instance.

2005-03-09  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_get_object_from_blob): Applied patch from
	Ankit Jain (radical@gmail.com). Fix enum default values. Fixes #73457.

	* class.c (mono_class_is_assignable_from): Another try at fixing 
	#73469 without breaking anything.

2005-03-08  Zoltan Varga  <vargaz@freemail.hu>

	* class.c: (mono_class_is_assignable_from): Revert the last changes
	since they don't work with generics.
	
	* class.c (mono_class_is_assignable_from): Fix build bustage.

	* class.c (mono_class_is_assignable_from): If oklass is dynamic, call
	the managed IsAssignableFrom method. Fixes #73469.

	* reflection.c (mono_reflection_call_is_assignable_from): New helper
	function.

2005-03-04  Zoltan Varga  <vargaz@freemail.hu>

	* object.c (mono_load_remote_field_new): Fix returning uninitialized
	memory when the remoting callback does not sets the out arguments.
	Fixes #73007.

	* marshal.c (mono_delegate_free_ftnptr): Remove debug array checked in
	by mistake.

	* string-icalls.c: Return String.Empty where needed. Fixes #73310.

	* object-internals.h (MonoStackFrame): Sync with managed object layout.

	* appdomain.c: Bump corlib version.

2005-03-03  Zoltan Varga  <vargaz@freemail.hu>

	* gc-internal.h boehm-gc.c null-gc.c: Add mono_gc_is_gc_thread () API
	function.

	* threads.c (mono_thread_attach): Detect threads which are not started
	by the GC pthread wrappers.

2005-03-03  Sebastien Pouliot  <sebastien@ximian.com>

	* icall.c: Added new icall for RNG.
	* rand.c|h: Added new icall to open the RNG. This allows to share a 
	single handle on Linux to access /dev/urandom and fix #73183.

Thu Mar 3 17:53:17 CET 2005 Paolo Molaro <lupus@ximian.com>

	* object.c: setting the new vtable in a transparent proxy object must
	not change the GC descriptor.

Thu Mar 3 12:11:46 CET 2005 Paolo Molaro <lupus@ximian.com>

	* object.c: fixed compilation without GCJ support.
	* reflection.c: for runtime-created types ensure klass->has_references
	is correct (bug #73215).

2005-03-02  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_is_assignable_from): Make this work if
	`oklass' is a generic instance; fixes #72831.

2005-03-01  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_managed_wrapper): Fix handling of methods
	with hasthis set.
	
	* marshal.c (emit_marshal_array): Emit native->managed marshalling of blittable arrays.

	* marshal.c: Reorganize native->managed marshalling code to also use
	the emit_marshal_... functions.

Tue Mar 1 16:16:42 CET 2005 Paolo Molaro <lupus@ximian.com>

	* object.c: typed allocs have issues with bitmap sizes > 30,
	so check for max_set >= 30.

2005-03-01  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (emit_marshal_array): Implement marshalling of arrays to
	managed code. Fixes #73012.

	* metadata.h (MonoMarshalSpec): Add elem_mult field.

	* metadata.c reflection.c: Load/Emit elem_mult as well.
	
	* metadata.h (MonoMarshalSpec): Add comment.

	* metadata.h: Add MONO_MARSHAL_CONV_LPTSTR_STR.

	* metadata.c (mono_metadata_parse_marshal_spec): Set param_num and
	num_elem to -1 if not given.

	* object-internals.h (MonoReflectionMarshal): Add has_size field.

	* reflection.c (encode_marshal_blob): Differentiate between 0 and not
	given values.

2005-03-01  Marek Safar  <marek.safar@seznam.cz>

	* null-gc.c (mono_gc_free_fixed): Was not compilable.

2005-02-28  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (encode_marshal_blob): Encode param_num field as well.

	* object-internals.h (MonoReflectionMarshal): Add param_num field.

Mon Feb 28 11:59:42 CET 2005 Paolo Molaro <lupus@ximian.com>

	* object.c: generalized the reference bitmap creation
	and added hooks for the new GC.
	* class-internals.c: removed the gc_bitmap field from MonoClass.

Sat Feb 26 16:06:59 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c: help the compiler to produce better code
	in mono_jit_info_table_find ().

Fri Feb 25 16:50:14 CET 2005 Paolo Molaro <lupus@ximian.com>

	* object.c: make all allocations look typed.

Fri Feb 25 16:18:59 CET 2005 Paolo Molaro <lupus@ximian.com>

	* socket-io.c: load Mono.Posix if it's not loaded already
	(fixes bug#73033).

2005-02-24  Martin Baulig  <martin@ximian.com>

	* class.c (dup_type): Correctly duplicate MONO_TYPE_PTR.
	* reflection.c (dup_type): Likewise.

2005-02-24  Zoltan Varga  <vargaz@freemail.hu>

	* gc.c (run_finalize): Set the domain for finalizing delegates as well.
	Thanks to Willibald Krenn and Scott Mohekey for tracking this down.

Thu Feb 24 15:19:35 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c, threads.c, object-internals.h: make the critical thread
	local vars use the fast access mode (even when we're compiled in
	a lib). Provide accessors to be used by the jit during codegen.

2005-02-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* appdomain.c: Changed hook functios behavior to include
	support for the reflection only assemblies. Some icalls were changed
	to support the mentioned assemblies too. Signatures of static methods
	try_assembly_resolve and real_load now have an additional parameter:
	refonly.

	* assembly.c: General changes to mono_assembly_ methods to support
	reflection only api. Functions mono_assembly_open, mono_assembly_load,
	mono_assembly_load_from and mono_assembly_loaded have got a '_full'
	suffix, to support an additional gbool parameter to specify whether
	the assembli is reflection only or not. Created some new hook functions 
	to add support for reflection only assemblies. Signatures of static 
	methods load_in_path, search_loaded, and mono_assembly_load_from_gac 
	have now an additional parameter: refonly.

	* metadata-internals.h: MonoAssembly now has a gbool ref_only flag,
	indicating whether the assembly is reflection only or not.

	* exception.c: Add mono_get_exception_invalid_operation.

	* icall.c: Throw an InvalidOperationException when trying to invoke
	a property/method/event, or trying to set/get the value of a field.
	Also add an icall to retrieve the ref_only flag to the
	MonoReflectionAssembly.

2005-02-23  Chris Toshok  <toshok@ximian.com>

	Part of fix for #72827.
	* mono-debug.c (mono_debug_add_method): add lexical block data to
	the info we write.  Kind of a hack at the moment - we copy the
	lexical block info from the MonoDebugMethodInfo to the
	MonoDebugMethodJitInfo here, before writing it.
	(mono_debug_read_method): read the lexical block info.

	* mono-debug.h (_MonoDebugMethodJitInfo): add lexical block slots.

	* debug-mono-symfile.h: add lexical block support.

	* debug-mono-symfile.c (mono_debug_find_method): add lexical block
	support.

2005-02-23  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c (mono_lookup_pinvoke_call): Fix warning.

	* object.c (mono_runtime_free_method): Call mono_free_method () and
	put the TODOs there.

	* loader.c (mono_free_method): Free up most memory allocated for 
	dynamic methods.

Wed Feb 23 18:54:26 CET 2005 Paolo Molaro <lupus@ximian.com>

	* reflection.c: properly flag a Type argument to a
	named custom attr value (bug #72248).

Wed Feb 23 18:32:35 CET 2005 Paolo Molaro <lupus@ximian.com>

	* reflection.c: reduce code duplication in named custom
	attribute encoding.

Wed Feb 23 17:23:52 CET 2005 Paolo Molaro <lupus@ximian.com>

	* reflection.c: properly encode custom attrs of type object
	(bug #72649).

2005-02-23  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_delegate_free_ftnptr): Make this thread safe.

Tue Feb 22 21:54:47 CET 2005 Paolo Molaro <lupus@ximian.com>

	* socket-io.c: load System.dll if it's not loaded already
	(bug #72850 and #70477).

2005-02-21  Martin Baulig  <martin@ximian.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Add support for
	generic instances.

2005-02-21  Martin Baulig  <martin@ximian.com>

	* reflection.c (mono_image_build_metadata): We also need to
	"fixup" the MethodImpl table after we computed the final method
	indices.  Call fixup_methodimpl() to do that.
	(fixup_methodimpl): New private method.

Mon Feb 21 16:17:14 CET 2005 Paolo Molaro <lupus@ximian.com>

	* assembly.c: special case mscorlib.dll (bug#72536),
	patch from Carlos Alberto Cortez.

2005-02-20  Zoltan Varga  <vargaz@freemail.hu>

	* threads-types.h threads.c: Fix build bustage.

	* threads.c: Use a union for long<->double conversions.

	* threads-types.h threads.c icall.c: Implement the net 2.0 interlocked
	functions based on a patch by Luca Barbieri (luca.barbieri@gmail.com).

	* marshal.c (emit_thread_interrupt_checkpoint_call): Mark the bblock 
	containing the checkpoint call with NOT_TAKEN.
	
	* marshal.c (mono_marshal_get_managed_wrapper): Emit interrupt 
	checkpoint before pushing the arguments, so they won't have to be
	spilled to stack.

Sat Feb 19 15:19:46 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c, assembly.c, domain-internals.h: make some data
	const and relocation-free.

Sat Feb 19 11:12:34 CET 2005 Paolo Molaro <lupus@ximian.com>

	* object.c, appdomain.c, class-internals.h: introduce the
	MonoClassRuntimeInfo structure to hold the info needed to
	use a class at runtime. Made mono_class_vtable() lock-free
	for all the appdomains.

Sat Feb 19 11:11:12 CET 2005 Paolo Molaro <lupus@ximian.com>

	* metadata-internals.h, image.c: introduce a per-image mempool to
	be used for memory that has the same lifetime as the image.

2005-02-18  Lluis Sanchez Gual  <lluis@novell.com>

	* domain.c: In mono_init_internal(), instead of selecting the first
	runtime version supported by an executable, get a list of all
	supported versions and select the one for which an mscorlib exists
	(since even if the runtime supports a given version, it doesn't mean
	that the framework for that version is installed).
	Modified get_runtimes_from_exe to support this behavior.
	In supported_runtimes, added information about additional system
	assembly versions.
	
	* assembly.c: Added support for more than one system assembly version
	per runtime version. Updated the assembly list.
	In mono_assembly_remap_version, removed the initial version check,
	since we don't know to which version we need to compare until we
	get the version set on which the assembly is based.
	Moved the code for loading corlib into the new method
	mono_assembly_load_corlib(), so it can be used by the initialization
	code.
	
	* domain-internals.h: Updated data structures and added declaration
	for mono_assembly_load_corlib.

2005-02-17  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (resolve_object): Fix the creation of the signature in 
	the SignatureHelper case.

	* assembly.c (mono_assembly_remap_version): Fix binary search.
	
2005-02-17  Sebastien Pouliot  <sebastien@ximian.com>
 
	* class.c: Added inheritance check when a method is overloaded (from a
	virtual method or when implementing an interface) and when a class is
	inherited. Added functions to set a failure for a class and to 
	retreive the exception from a failure.
	* class-internals.h: Added fields to MonoClass to keep the exception
	information status for inheritance (or other exceptions) to be thrown
	later (i.e. not at load time).
	* object.c: Throw the inheritance SecurityException when a type is to 
	be created with either class or method inheritance violations.
	* reflection.c|h: Fix when getting declsec from a class. Removed 
	unrequired code for class. Improved sanity in parameter naming.
	* security-manager.c|h: Added functions to check for class and method
	inheritance.

2005-02-17  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_reflection_create_runtime_class): Set has_cctor
	and has_finalize in dynamic types as well.

2005-02-17  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : fixed currency format for en-GB (and so on).

Wed Feb 16 16:28:15 CET 2005 Paolo Molaro <lupus@ximian.com>

	* gc.c: ensure the GC handles never have 0 as a value.

2005-02-16  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (emit_marshal_ptr): Raise an exception if trying to pass
	a pointer to a struct to unmanaged code. Fixes #72625.

2005-02-16  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (mono_debug_open_image): Ignore dynamic images.

2005-02-16  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (emit_marshal_array): Only marshal unicode char arrays as [Out].

2005-02-15  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c (mono_lookup_pinvoke_call): Fix stdcall name mangling.

	* marshal.c (mono_ftnptr_to_delegate): If the delegate has the 
	UnmanagedFunctionPointerAttribute, use it for determining calling convention
	etc. Fixes #71471.

	* reflection.c (mono_custom_attrs_get_attr): New helper function.

	* object-internals.h: Add MonoReflectionUnmanagedFunctionPointerAttribute.

Tue Feb 15 18:03:41 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c, appdomain.c, appdomain.h, object-internals.h, object.h:
	changes to make the current context a field in MonoThread.

2005-02-15  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_native_wrapper): Fix a crash caused by
	the last change.
	
	* marshal.c (mono_marshal_emit_native_wrapper): New helper function
	extracted from mono_marshal_get_native_wrapper.

	* marshal.c (mono_marshal_get_native_func_wrapper): New helper function
	to create wrappers around native functions.

	* marshal.c (mono_ftnptr_to_delegate): Add support for creating 
	delegates for arbitrary function pointers. Fixes #71472.

Tue Feb 15 11:01:09 CET 2005 Paolo Molaro <lupus@ximian.com>

	* threads.c: cleaned up the code a little.

2005-02-15  Martin Baulig  <martin@ximian.com>

	* mono-debug.h (MonoSymbolTable): Allow variable-length chunks in
	the data table.

	* mono-debug.c (DATA_TABLE_CHUNK_SIZE): Set to 32768; we may now
	allocate larger chunks if needed.

2005-02-14  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c (start_wrapper): Remove #ifdef PLATFORM_WIN32 probably left
	in by mistake.

Mon Feb 14 16:48:24 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c: keep the domains in an array and ensure the domain ids
	are kept small, so they can be used as indexes to domain-specific data
	with a small memory overhead.

2005-02-14  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c: Handle byref types in Type icalls. Fixes #72544.

Mon Feb 14 15:39:56 CET 2005 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: remove libmetadata: we build just libmonoruntime now.

2005-02-13  Zoltan Varga  <vargaz@freemail.hu>

	* tabledefs.h (MANIFEST_RESOURCE_VISIBILITY_MASK): Add flags for ManifestResource.

	* loader.c (mono_lookup_pinvoke_call): Correct the search order used for different CharSet
	values.

	* marshal.c (mono_marshal_get_string_encoding): CHAR_SET_AUTO means Unicode on windows.
	
2005-02-12  Ben Maurer  <bmaurer@ximian.com>

	* domain-internals.h: add the hashtable here.

	* class-internals.h: Remove `info' from MonoMethod

	* domain.c: Add a new hashtable, jit_trampoline_hash

Fri Feb 11 17:11:20 CET 2005 Paolo Molaro <lupus@ximian.com>

	* object.c: don't set the value of static fields
	(fixes bug#72494).

2005-02-11  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (DATA_TABLE_CHUNK_SIZE): Increase to 131072.
	(mono_debug_add_method): Silently ignore the method if it's too big.
	(mono_debug_add_type): Likewise.

Fri Feb 11 16:22:10 CET 2005 Paolo Molaro <lupus@ximian.com>

	* threads.c, appdomain.c: remove #ifdefs from the code.

2005-02-10  Sebastien Pouliot  <sebastien@ximian.com>

	* metadata-internals.h: Added flags to MonoAssembly to cache the most
	common security informations. This allows us to stay in unmanaged code
	when doing LinkDemand and it's special cases (except for the first 
	time for initialization). The flags a very much used with --security.
	* reflection.c|h: Added code to get declarative security attributes 
	for LinkDemand and InheritanceDemand. This required to refactor the
	existing code for Demand.
	* security-manager.c|h: Added new method fields for the special cases
	of LinkDemand.

2005-02-10  Martin Baulig  <martin@ximian.com>

	* icall.c (ves_icall_MonoDebugger_MakeArrayType): New interncall.
	(ves_icall_MonoDebugger_GetTypeToken): New interncall.

2005-02-10  Martin Baulig  <martin@ximian.com>

	* mono-debug.c, mono-debug-debugger.c: Completely reworked the
	debugging code; this is almost a complete rewrite.

	* icall.c (ves_icall_MonoDebugger_GetMethodIndex): New interncall.

Thu Feb 10 15:19:01 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c, object.h: expose mono_string_equal () and 
	mono_string_hash ().
	* icall.c, string-icalls.c: remove the string.GetHashCode () icall,
	it's implemented in managed code.

Thu Feb 10 15:03:46 CET 2005 Paolo Molaro <lupus@ximian.com>

	* icall.c, gc.c, gc-internal.h: make sure gchandles can't be used
	lo leak objects between appdomains.

Thu Feb 10 14:25:00 CET 2005 Paolo Molaro <lupus@ximian.com>

	* assembly.c: old compilers compilation fix from 
	robertj@gmx.net (Robert Jordan).

2005-02-09  Ben Maurer  <bmaurer@ximian.com>

	* class-internals.h: Little reminder for the future.

	* debug-helpers.c: Fix up wrapper_type_names

Wed Feb 9 19:34:29 CET 2005 Paolo Molaro <lupus@ximian.com>

	* image.c, metadata-internals.h: when loading an image from a file,
	mmap all of it and use the same codepaths as when using a
	in-memory image: the code is simpler and we use less memory
	(both writable and readonly).

Wed Feb 9 18:32:51 CET 2005 Paolo Molaro <lupus@ximian.com>

	* gc-internal.h, null-gc.c, boehm-gc.c: added functions to the GC
	API to alloc runtime data structures that need to be tracked by the
	GC and contain pointers.
	* appdomain.c, threads.c, object.c, gc.c: use the above changes to
	make the code more readable and eventually use a different GC.

2005-02-09  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (emit_marshal_vtype): Don't do managed->native conversion
	for out arguments.
	
2005-02-09  Lluis Sanchez Gual  <lluis@novell.com>

	* object.c: In release_type_locks(), don't release the cctor lock
	if it has already been released. This fixes a crash in the
	thread5 test.

Tue Feb 8 19:02:59 CET 2005 Paolo Molaro <lupus@ximian.com>

	* gc.c, marshal.c, icall.c: register a delegate for finalization
	only when the native function pointer has been allocated for it.

Tue Feb 8 18:12:27 CET 2005 Paolo Molaro <lupus@ximian.com>

	* object.c: cleaned up some code, allocate objects that are
	pointer free with the atomic malloc variant. Allocate memory
	for static data from the mempool if it's pointer-free.
	Allocate the bounds array at the end of the array data, when needed.
	* object-internals.h, object.h: move a private function in a private
	header.
	* class.c: handle missing case in tracking references in fields.

Tue Feb 8 18:04:51 CET 2005 Paolo Molaro <lupus@ximian.com>

	* class.c, class-internals.h: keep track if a type has
	reference fields in either the instance or static fields.

2005-02-07  Lluis Sanchez Gual  <lluis@novell.com>

	* domain.c, domain-internals.h: Moved RuntimeInfo to domain-internals.h,
	and renamed to MonoRuntimeInfo. Added fields to store the expected
	framework assembly version. Changed mono_get_framework_version and
	mono_get_runtime_version for a single mono_get_runtime_info method.
	
	* assembly.c: Added method to remap system assembly versions to the
	current executing runtime version. Removed old mapping code.
	Remap assembly versions in mono_assembly_load and mono_assembly_loaded.
	
	* icall.c, reflection.c: Track api changes.

2005-02-06  Miguel de Icaza  <miguel@novell.com>

	* loader.c (method_from_memberref): Improve error reporting,
	produce the class name instead of the typeref/typedef index. 

2005-02-07  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_stfld_remote_wrapper): Fix wrapper type.

2005-02-05  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c (mono_lookup_pinvoke_call): Allow for combination of
	stdcall and charset name mangling.  Reorganize the code and add
	some tracing stuff.

2005-02-05  Ben Maurer  <bmaurer@ximian.com>

	* monodiet.c: More iters!

	* marshal.c: Iter usage.

	* icall.c: Iter usage.

	* object.c: Use iters.

	* debug-helpers.c: More iters

2005-02-05  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c (mono_lookup_pinvoke_call): Add brute-force checking for mangled function names
	under win32.

2005-02-05  Ben Maurer  <bmaurer@ximian.com>

	* mono-debug-debugger.c: use iters

	* class.c, class-internals.h: mono_class_setup_events is static
	now

	* All callers: use iters

2005-02-05  Zoltan Varga  <vargaz@freemail.hu>

	* class.c string-icalls.c marshal.c reflection.c: Applied patch from
	Robert Jordan (robertj@gmx.net). Fix compilation errors under gcc-2.95.

2005-02-04  Zoltan Varga  <vargaz@freemail.hu>

	* object.c (mono_class_proxy_vtable): Add missing _setup () calls.

	* marshal.h: Add prototypes for ldfld/stfld_remote.

	* appdomain.c (mono_domain_fire_assembly_load): Handle the case when
	this is called during startup.
	
Fri Feb 4 20:27:58 CET 2005 Paolo Molaro <lupus@ximian.com>

	* appdomain.c, monitor.c, monitor.h, threads-types.h: made the
	MonoThreadsSync struct private in monitor.c. Changed the way
	MonoThreadsSync is allocated so it's faster and there is no
	need to keep track of it with a finalizer and it uses less memory.
	This also finally allows us to allocate mono objects as ptrfree when
	there are no reference fields.

Fri Feb 4 20:24:03 CET 2005 Paolo Molaro <lupus@ximian.com>

	* gc.c, null-gc.c, boehm-gc.c, gc-internal.h: added functions to deal with
	disappearing link to the GC interface and use them to simplify
	the gchandles code.

2005-02-04  Zoltan Varga  <vargaz@freemail.hu>

	* class-internals.h marshal.c: Add two new wrappers, ldfld_remote and
	stfld_remote which call mono_load/store_field_new. This allows methods
	calling ldfld/stfld wrappers to be AOTed.

	* console-io.c: Include sys/filio.h under solaris.
	
	* console-io.c: Include curses.h if needed correctly.

2005-02-03  Zoltan Varga  <vargaz@freemail.hu>
	
	* icall.c (ves_icall_MonoMethod_get_base_definition): Initialize
	method->klass as well.

	* class-internals.h (MonoCachedClassInfo): Add 'finalize_image' field.

	* class.c (mono_class_init): Switch on lazy initialization of 
	methods.

	* class.c (mono_class_get_finalizer): Handle the case when the 
	finalizer is inherited.

2005-02-04 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* console-io.c: <curses.h> is needed by term.h on solaris.

2005-02-03  Ben Maurer  <bmaurer@ximian.com>

	* icall.c, class-internals.h, monodiet.c, class.c: Remove
	mono_class_setup_properties where possible. Remove this ftn from
	the header file, and make it static.

2005-02-03  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c: Add missing setup_... call.

	* class.c: Add missing setup_... calls.

	* class.c (mono_class_init): Switch on lazy initialization of 
	the generic vtable.
	
	* class.c (mono_class_init): Fix generics broken by the recent changes.

	* monodiet.c (handle_type): Add missing setup_... calls.

	* class.c: Back out garbage in previous patch.
	
	* class.c: Add missing setup_... calls.

	* class.c (mono_class_get_method_from_name_flags): Avoid calling
	mono_class_setup_methods () if possible.

	* class-internals.h (MonoClass): Add 'has_cctor' flag.

	* class-internals.h (MonoCachedClassInfo): New structure.

	* class.c: Initialize properties and events fields of MonoClass lazily.

	* class.c: Add infrastructure for lazily initializing the methods and
	vtable fields of MonoClass. Not yet used.

	* class.c (mono_class_get_finalizer): New helper function.

	* class.c: Add infrastructure for loading some class related data from
	an AOT file.

	* object.c: Add infrastructure for initializing the vtable from data
	in the AOT file.

	* gc.c (run_finalize): Use mono_class_get_finalizer ().

	* class.c loader.c object.c icall.c gc.c reflection.c: Call the
	appropriate initialization function before accessing parts of the
	MonoClass structure.

	* marshal.c: Fix warnings.
	
	* marshal.c (emit_marshal_array): Add missing 'break'. Fixes #72169.

	* mono-debug-debugger.c (get_exception_message): Use 
	mono_class_get_method_from_name_flags ().

2005-02-02  Ben Maurer  <bmaurer@ximian.com>

	* reflection.c, appdomain.c: Replace a few manual searches that
	Zoltan missed. (Paolo approved this part of my initial patch).

Wed Feb 2 16:32:08 CET 2005 Paolo Molaro <lupus@ximian.com>

	* profiler.c: disable recording statistical events at report time.

Wed Feb 2 14:14:00 CET 2005 Paolo Molaro <lupus@ximian.com>

	* icall.c: patch from Geoff Norton <gnorton@customerdna.com>
	to byteswap arrays of enum values, too (bug #72080).

2005-02-02  Zoltan Varga  <vargaz@freemail.hu>

	* appdomain.c (set_domain_search_path): Allow this to be called if
	domain->setup is not yet set.

	* loader.c (mono_method_get_index): New helper function.

	* loader.c reflection.c: Use mono_method_get_index ().

	* class.c (mono_class_get_method_from_name_flags): New helper method.

	* debug-helpers.h debug-helpers.c (mono_find_method_by_name): Remove
	this.

	* class.c (mono_class_get_cctor): New helper method.

	* string-icalls.c object.c class.c marshal.c reflection.c: Use
	mono_class_get_method () to look up methods.

2005-02-01  Miguel de Icaza  <miguel@novell.com>

	* console-io.c: Fix the build, this should work on Windows.

2005-01-31  Ben Maurer  <bmaurer@ximian.com>

	* marshal.c (mono_marshal_xdomain_copy_out_value): cached_str must
	be set to null to keep things valid

2005-01-31 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* icall.c: added Console 2.0 icalls.
	* Makefile.am: added console-io.[ch]
	* console-io.[ch]: internal calls for Console 2.0 API.

Mon Jan 31 19:01:29 CET 2005 Paolo Molaro <lupus@ximian.com>

	* class.c: make sure we consider all the interfaces
	when calculating max_interface_id (bug found by
	Jeroen Frijters running ikvm).

2005-01-31  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c (ves_icall_FieldInfo_SetValueInternal): Handle setting of
	valuetype fields to null.

	* object.c (set_value): Ditto. Fixes #71669.	

2005-01-31  Martin Baulig  <martin@ximian.com>

	* metadata.c (mono_metadata_has_generic_params): New public
	function; checks whether something is a generic method.

Sun Jan 30 20:19:48 CET 2005 Paolo Molaro <lupus@ximian.com>

	* appdomain.c: fix infinite recursion when adding assemblies.

2005-01-30  Sebastien Pouliot  <sebastien@ximian.com>

	* object.c: Fix small typo to return all items for Environment.
	GetCommandLineArgs.

Sun Jan 30 16:49:01 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c, appdomain.c, assembly.c, image.c, domain-internals.h,
	reflection.c: more domain and assembly-unload related fixes
	and memory leaks plugs.

2005-01-30  Zoltan Varga  <vargaz@freemail.hu>

	* class.c loader.c security.c loader.h process.c threads.c mono-debug-debugger.c profiler.c marshal.c rand.cpedump.c: Fix 64 bit warnings.

2005-01-29  Ben Maurer  <bmaurer@ximian.com>

	* loader.c (mono_method_signature): Make this method lazy
	(mono_get_method_from_token): Don't computate the signature here.

	Doing this saves quite a bit of memory. I got 90 kb on starting up
	monodoc. It should also save some disk reads on startup.

	* *: MonoMethod->signature might be NULL now. You *MUST* use
	mono_method_signature.

2005-01-29  Zoltan Varga  <vargaz@freemail.hu>

	* object.c (mono_runtime_get_main_args): Return an array from the
	current domain here. Fixes #71938.

Sat Jan 29 15:59:05 CET 2005 Paolo Molaro <lupus@ximian.com>

	* monitor.c: formatting changes to comply with the
	mono coding style and remove #ifdefs from the code.

Sat Jan 29 15:18:54 CET 2005 Paolo Molaro <lupus@ximian.com>

	* metadata.c, private.h: remove some unneeded data
	and use a more compact representation for table schemas.

Fri Jan 28 18:23:44 CET 2005 Paolo Molaro <lupus@ximian.com>

	* metadata.c, metadata-internals.h: add mono_aligned_addr_hash()
	to get a better distribution in hash tables.
	* *.c: use mono_aligned_addr_hash() where appropriate.
	* assembly.c: make var static.

2005-01-28  Zoltan Varga  <vargaz@freemail.hu>

	* domain-internals.h: Put MonoJitInfo on a diet.

	* domain.c: Fix a warning.

Wed Jan 26 22:20:46 CET 2005 Paolo Molaro <lupus@ximian.com>

	* gc.c: rework the gc handles code to reuse handles
	when freed.

Wed Jan 26 17:34:09 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c: fixed long standing bug in mono_string_equal() which
	was brought to light with the ldstr changes.

2005-01-26  Sebastien Pouliot  <sebastien@ximian.com>

	* reflection.c: Remove warning by adding missing include for marshal.h

Tue Jan 25 18:06:00 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c, object.c: change the ldstr_table to hold
	MonoString* as keys: makes the runtime isinterned lookup
	faster and simplifies memory management.

2005-01-25  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* icall.c: Renamed GetEnvironmentVariable so internal* so it was
	possible to add imperative security checks before calling the icall.
	* reflection.c: Return security attributes on the original MonoMethod
	(and not the wrapped one). This fix permissions on icalls.

2005-01-25  Dick Porter  <dick@ximian.com>

	* icall.c (ves_icall_System_CurrentTimeZone_GetTimeZoneData): Make
	the check for mktime() support actually test the mktime() return
	value.  "Fixes" bug 71682, though the output is still different to
	MS.

2005-01-25  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_is_assignable_from): Make this work for
	generic instances.

2005-01-24  Ben Maurer  <bmaurer@ximian.com>

	* marshal.c (mono_string_utf8_to_builder)
	(mono_string_builder_to_utf16): We might not have ownership of the
	string. In thise case, we need to create a new buffer.

	* object-internals.h (mono_stringbuilder_capacity): sb->str might
	be null, in which case, use the default capacity.

Mon Jan 24 16:42:29 CET 2005 Paolo Molaro <lupus@ximian.com>

	* gc-internal.h, null-gc.c, profiler.c, boehm-gc.c: hook the
	GC events to the profiler.

Mon Jan 24 15:59:54 CET 2005 Paolo Molaro <lupus@ximian.com>

	* gc.c: remove valgrind detection nonsense. Set GC_DONT_GC
	if you don't want the GC to run.

Mon Jan 24 15:53:25 CET 2005 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, gc.c, mono-gc.h, boehm-gc.c, null-gc.c, gc-internal.h:
	start providing a GC API and keeping different implementations in
	their own file.
	* profiler.h, profiler.c, profiler-private.h: provide the GC events API.

2005-01-22  Ben Maurer  <bmaurer@ximian.com>

	* debug-mono-symfile.c (mono_debug_open_mono_symbol_file): Use
	mmap rather than allocating a huge buffer.
	(mono_debug_close_mono_symbol_file): Free the buffer allocated
	above.

2005-01-22  Sebastien Pouliot  <sebastien@ximian.com>

	* icall.c: Add new internal calls for SecurityManager.SecurityEnabled
	and CheckExecutionRights.
	* reflection.c|h: Keep the index of the declarative security to be 
	used, instead of the pointer, when AOT compiler is used. Also add 
	class initialization when requesting demands.
	* security-manager.c|h: Implement SecurityManager.SecurityEnabled and
	CheckExecutionRights. Both properties are now FALSE by default, and
	unmodifiable, unless the --security option is used.

Fri Jan 21 15:29:27 CET 2005 Paolo Molaro <lupus@ximian.com>

	* domain.c, appdomain.c, assembly.c, image.c, metadata-internals.h,
	reflection.c: properly refcount images and assemblies, many leaks fixed.

2005-01-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* threadpool.c: increase the timeout for threads in the thread pool to
	10s.  Fixes bug #67159.

2005-01-20  Bernie Solomon  <bernard@ugsolutions.com>

	* class-internals.h: Sun's compiler insists on explicit
	signed on bit fields to handle then correctly.

2005-01-19  Miguel de Icaza  <miguel@ximian.com>

	* file-io.c (ves_icall_System_IO_MonoIO_get_InvalidPathChars):
	Make the size of the array fit only the number of invalid path
	chars that we have.

	* class.c (_mono_class_get): Improve the error reporting when a
	class referenced is not found, to assist debugging. 

Wed Jan 19 19:57:43 CET 2005 Paolo Molaro <lupus@ximian.com>

	* threads.c: fix off-by-one error.
	* domain.c: free data allocated in the domain.

2005-01-19  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_method_body_get_object): Fill out exception info
	as well.

	* object-internals.h: Add MonoReflectionExceptionHandlingClause 
	structure.
	
2005-01-19  Martin Baulig  <martin@ximian.com>

	* loader.c (mono_get_method_constrained): Make this work again.

2005-01-19  Zoltan Varga  <vargaz@freemail.hu>

	* object-internals.h (_MonoReflectionMethodBody): Make local_index a 
	guint16 to match the managed side.

	* reflection.c (mono_reflection_body_get_object): Fill out local
	variables array.

	* reflection.c (mono_method_body_get_object): Fill out local_var_sig_token
	as well.

	* object-internals.h (_MonoReflectionMethodBody): Rename 'sig_token' to
	'local_var_sig_token'.

2005-01-18  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c (mono_lookup_pinvoke_call): Revert the previous patch as it breaks 
	System.Drawing.

	* reflection.c (mono_method_body_get_object): Handle abstract and
	runtime methods.

Mon Jan 17 19:22:39 CET 2005 Paolo Molaro <lupus@ximian.com>

	* marshal.c, loader.c, class-internals.h, reflection.c:
	store the emthod data for a wrapper in an array instead of a list.

Mon Jan 17 18:48:53 CET 2005 Paolo Molaro <lupus@ximian.com>

	* marshal.c: change the code to allocate memory more
	conservatively for method wrappers.

Mon Jan 17 18:03:30 CET 2005 Paolo Molaro <lupus@ximian.com>

	* class-internals.h, marshal.c: move the str_to_ptr and ptr_to_str
	fields from MonoClass to the marshal info structure where they belong.

Mon Jan 17 16:14:46 CET 2005 Paolo Molaro <lupus@ximian.com>

	* class.c, object.c, class-internals.h, marshal.c: rearrange
	some fields and tweak some types to lower memory usage.

2005-01-17  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c (signal_thread_state_change): Handle the case when the
	target thread is the current thread.

	* marshal.c (mono_struct_delete_old): Do not free lpwstr fields.

	* marshal.c: Rename emit_ptr_to_str_conv and its pair to 
	emit_ptr_to_object_conv. 

	* marshal.c (emit_ptr_to_object_conv): Add support for lpwstr->str
	marshalling. Fixes #71352.

Mon Jan 17 10:59:20 CET 2005 Paolo Molaro <lupus@ximian.com>

	* metadata.h, blob.h: move table enum to blob.h so it can be included
	in any header.
	* image.c, metadata.c, metadata-internals.h, pedump.c, reflection.c:
	cut the size of MonoImage/MonoDynamicImage.

2005-01-16  Zoltan Varga  <vargaz@freemail.hu>

	* profiler.c (mono_profiler_install_simple): Fix default arguments.

Sun Jan 16 12:25:22 CET 2005 Paolo Molaro <lupus@ximian.com>

	* reflection.c, reflection.h, icall.c: add a function to check
	if an attribute type is defined for a metadata object.

2005-01-14  Lluis Sanchez Gual  <lluis@novell.com>

	* object-internals.h: Added some needed fields from StringBuilder class.
	* marshal.c: Set the maxCapacity when creating a StringBuilder.

2005-01-13  Zoltan Varga  <vargaz@freemail.hu>

	* icall.c (ves_icall_System_Environment_Exit): Suspend all managed
	threads before shutting down the runtime.

	* threads.c (mono_thread_suspend_all_other_threads): New helper function.

Thu Jan 13 18:16:35 CET 2005 Paolo Molaro <lupus@ximian.com>

	* object-internal.h, threads.c: implement stacksize and 
	parameterized thread start functionality (requires
	matching corlib). Marked broken code for later removal.

2005-01-12  Martin Baulig  <martin@ximian.com>

	* class-internals.h (MonoGenericClass): Moved the `initialized'
	flag to MonoDynamicGenericClass, removed `init_pending'.
	(MonoGenericInst): Added `is_reference' flag.

2005-01-12  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (mono_image_create_pefile): Only set the pe_offset
	inside the MSDOS header. Fixes #71201.

	* gc.c (mono_gc_cleanup): Handle the case when this is called from the
	gc thread.
	(mono_domain_finalize): Ditto.

2005-01-12  Martin Baulig  <martin@ximian.com>

	* class.c (mono_get_shared_generic_class): Use the cache for
	non-dynamic generic classes.

	* class-internals.h (mono_class_create_generic_2): Removed
	function prototype, this function is now static inside class.c.

	* class.c (mono_class_create_generic_2): Made this static, only
	call it from mono_class_init() and mono_class_setup_parent().
	(collect_implemented_interfaces_aux): Call mono_class_init() on
	the interfaces we collect.
	(mono_class_setup_vtable): Call mono_class_init (class->parent).

2005-01-11  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c (mono_thread_attach): Call DuplicateHandle on the thread handle on win32 to make
	it a real thread handle.

	* domain-internals.h: Move exvar_offset from MonoJitInfo to 
	MonoJitExceptionInfo, since each catch clause needs its own variable.
	
2005-01-11  Dick Porter  <dick@ximian.com>

	* image.c (mono_pe_file_open): New variant on mono_image_open()
	that does not set up the CLI metadata; used for FileVersionInfo so
	it can get the data for windows binaries too.
	
	* process.c (process_read_string_block): Don't read off the end of
	the StringTable block.

	These both fix bug 70766.

Tue Jan 11 15:26:00 CET 2005 Paolo Molaro <lupus@ximian.comt>

	* gc.c: set some fields to NULL at GC cleanup time.
	* threads.c: if we quit the main thread, call exit ().

2005-01-11  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c (interruption_request_apc): Decore APC callbacks with CALLBACK under win32.

Mon Jan 10 18:47:28 CET 2005 Paolo Molaro <lupus@ximian.com>

	* threads.h, threads.c, object.c: added accessor and settor for
	main_thread. Handle it specially when exiting from it: wait
	for other foreground threads to exit.

Mon Jan 10 12:06:18 CET 2005 Paolo Molaro <lupus@ximian.com>

	* process.c, verify.c: remove some bloat.

2005-01-09  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c (mono_lookup_pinvoke_call): If we found the function without name mangling, change
	the calling convention to cdecl under win32.

2005-01-08  Ben Maurer  <bmaurer@ximian.com>

	* object.c (mono_object_get_size): New function to get the size of
	an object instance.

	* profiler.c (simple_allocation): Use above.

2005-01-08  Sebastien Pouliot  <sebastien@ximian.com>

	* appdomain.c: Replaced ves_icall_System_AppDomain_getDomainByID by
	ves_icall_System_AppDomain_getRootDomain (as it's not required to
	get an appdomain by it's id and we can't assume the root's id is 0).
	* domain-internals.h: Change the function prototype to match.
	* icall.c: Change the icall table for AppDomain.

2005-01-08  Miguel de Icaza  <miguel@ximian.com>

	* locales.c (string_invariant_compare_char): Only compute
	GUnicodeTypes in the case where we need them.  Test for ordinality
	first and return if so.

	From the commit:

		/*
		 * FIXME: here we must use the information from c1type and c2type
		 * to find out the proper collation, even on the InvariantCulture, the
		 * sorting is not done by computing the unicode values, but their
		 * actual sort order.
		 */

Sat Jan 8 19:03:26 CET 2005 Paolo Molaro <lupus@ximian.com>

	* loader.c: for P/Invoke methods, allow the "Internal" shared
	library name to refer to the calling process symbol namespace.

2005-01-07  Sebastien Pouliot  <sebastien@ximian.com>

	* Makefile.am: Add the security manager to the build.
	* security-manager.c|h: New. Initialization of the security manager.

2005-01-07  Dick Porter  <dick@ximian.com>

	* threads.c: 
	* monitor.c: Update thread state during Monitor and WaitHandle
	waits.  Fixes bug 71031.

2005-01-07  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (property_encode_signature): Correctly handle when the
	property has no methods.

2005-01-06  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (reflection_methodbuilder_to_mono_method): Remove debug stuff.
	
	* reflection.c (reflection_methodbuilder_from_method_builder): Copy
	fields from mb, not rmb. Fixes #71017.

	* marshal.c (emit_ptr_to_str_conv): Add support for 
	ByValTStr -> string conversion. Fixes #71015.

	* appdomain.c (mono_domain_owns_vtable_slot): New helper function.

	* mempool.c (mono_mempool_contains_addr): New helper function.

2005-01-05  Zoltan Varga  <vargaz@freemail.hu>

	* metadata.c (mono_metadata_compute_size): Fix size calculation of
	HasSematics encoded fields.
	
	* metadata.c (mono_type_to_unmanaged): Improve error message for 
	invalid string marshalling.

	* metadata.c: Fix warnings.
	
Wed Jan 5 16:17:27 CET 2005 Paolo Molaro <lupus@ximian.com>

	* profiler-private.h, profiler.c, profiler.h, gc.c: sample statistical
	profiler support.

2005-01-05  Zoltan Varga  <vargaz@freemail.hu>

	* domain.c object.c domain-internals.h: Revert part of r38077 since the
	keys to proxy_vtable_hash are GCd objects. Fixes running the class lib
	tests.

2005-01-03  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c: Use MONO_CLASSCONST instead of MONO_LDPTR in some places,
	so methods containing these can be AOTed.

2005-01-03  Martin Baulig  <martin@ximian.com>

	* loader.c (find_method): Removed the hack for generic instances.
	(method_from_memberref): If our parent is a generic instance, pass
	its generic type definition to find_method() and then inflate the
	method.
	(mono_get_method_constrained): Pass the generic type definition to
	find_method() and inflate the method later.

	* class-internals.h (MonoStats): Added `generic_class_count'.

	* icall.c (ves_icall_MonoGenericMethod_get_reflected_type):
	Renamed to ves_icall_MonoGenericMethod_get_ReflectedType().

	* reflection.c (mono_custom_attrs_from_params): Don't ignore
	generic type definitions.

2004-12-30  Zoltan Varga  <vargaz@freemail.hu>

	* loader.c icall.c: Fix warnings.

2004-12-29  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_managed_wrapper): Fix returning of
	blittable types. Fixes #70864.

2004-12-29  Martin Baulig  <martin@ximian.com>

	* icall.c
	(ves_icall_MonoGenericMethod_get_reflected_type): New interncall.

	* reflection.c (mono_method_get_object): Create a
	"System.Reflection.MonoGenericMethod" for inflated methods; don't
	call mono_get_inflated_method().

	* class-internals.h (MonoStats): Added `inflated_method_count_2'.

2004-12-27  Martin Baulig  <martin@ximian.com>

	* class-internals.h (MonoMethod): Added `is_inflated' flag.
	(MonoMethodInflated): Added `inflated' field.

	* class.c (mono_class_inflate_generic_method): Don't really
	inflate the method here; just set the `is_inflated' flag in the
	MonoMethod.
	(mono_class_get_inflated_method): Actually inflate the method here
	if it's not already inflated; we use the MonoMethodInflated's new
	`inflated' field as a cache.

2004-12-26  Martin Baulig  <martin@ximian.com>

	* class.c
	(inflate_generic_class): Moved some code out of inflate_generic_type().
	(mono_class_inflate_generic_method): If we're already inflated,
	inflate the context and use the declaring method; ie. make sure
	the declaring method of an inflated method is always the generic
	method definition.
	(mono_class_create_from_typedef): Create
	`class->generic_container->context->gclass'.

2004-12-24  Ben Maurer  <bmaurer@ximian.com>

	* metadata-internals.h, marshal.c, reflection.c: More
	MonoGHashTable->GHashTable.

	* domain-internals.h, class.c: Change MonoGHashTable's into
	GHashTables for some cases where no gc stuff is used

	All users: update apis

2004-12-23  Ben Maurer  <bmaurer@ximian.com>

	* metadata.c (builtin_types): Make this `const'. Makes this get
	put into the shareable section.
	(mono_metadata_init): Casts to make gcc happy.

2004-12-22  Zoltan Varga  <vargaz@freemail.hu>

	* gc.c (mono_gc_init): Add a '\n' to the valgrind warning.

2004-12-21  Sebastien Pouliot  <sebastien@ximian.com> 

	* icall.c: Added an internal call to retrieve the position and length
	of assembly-level declarative security attributes (RequestMinimum, 
	RequestOptional and RequestRefuse). This is used by the Assembly class
	to re-create the corresponding permission sets.

Tue Dec 21 14:50:31 CET 2004 Paolo Molaro <lupus@ximian.com>

	* marshal.c: fix the stelemref wrapper to be type correct
	(and faster).

2004-12-20  Ben Maurer  <bmaurer@ximian.com>

	* icall.c (ves_icall_System_Object_GetHashCode): There was no need
	to do key & 0x7fffffff. Hashtable already does this. It just
	results in longer code.

2004-12-20  Sebastien Pouliot  <sebastien@ximian.com>

	* appdomain.c: Bump corlib version.
	* class-internals.h: Added RuntimeSecurityFrame to mono_defaults.
	* domain.c: Add RuntimeSecurityFrame to mono_defaults.
	* reflection.c|h: Add functions to get declarative security infos
	(blob position and length) for assemblies, classes and methods.

Mon Dec 20 15:28:54 CET 2004 Paolo Molaro <lupus@ximian.com>

	* reflection.c: sort the constant table (bug #70693).

Mon Dec 20 12:19:37 CET 2004 Paolo Molaro <lupus@ximian.com>

	* object-internals.h, threads.c, domain.c: add accessors for
	the MonoThread and MonoDomain tls keys.

2004-12-18  Martin Baulig  <martin@ximian.com>

	* class.c (inflate_generic_type): If we're inflating a generic
	instance, set `ngclass->context->container = context->container';
	ie. the container we inflated into.

	* metadata.c (mono_metadata_parse_generic_param): Reflect above
	inflate_generic_type() changes.

2004-12-17  Martin Baulig  <martin@ximian.com>

	* class-internals.h
	(MonoGenericClass): Replaced `MonoType *generic_type' with
	`MonoClass *generic_class'.  Removed `dynamic_info'; if
	`is_dynamic' is true, we're a `MonoDynamicGenericClass'.
	(MonoDynamicGenericClass): Derive from `MonoGenericClass'.

2004-12-16  Zoltan Varga  <vargaz@freemail.hu>

	* exception.c (mono_exception_from_token): New helper function.

2004-12-15  Zoltan Varga  <vargaz@freemail.hu>

	* assembly.c (mono_assembly_load_with_partial_name): Call 
	mono_assembly_loaded before invoking the preload hooks. Fixes
	#70564.

	* object-internals.h (MonoThread): Change culture_info and 
	ui_culture_info into an array.

	* threads.c: Cache culture info objects from more than one appdomain.

	* threads.c threads-types.h icall.c: Add icalls for manipulating the 
	current UI culture.

2004-12-14  Zoltan Varga  <vargaz@freemail.hu>

	* threads.h threads.c appdomain.c: Clear the culture_info field of
	all threads during unloading if they point to an object in the dying
	appdomain.

2004-12-13  Ben Maurer  <bmaurer@ximian.com>

	* culture-info.h (TextInfoEntry): New struct
	* object-internals.h: sync with managed
	* locales.c: fill the `text_info_data' field
	* culture-info-tables.h: update

Mon Dec 13 18:10:50 CET 2004 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, monodiet.c: add monodiet, an IL code garbage
	collector.

2004-12-12  Ben Maurer  <bmaurer@ximian.com>

	* icall.c (ves_icall_ModuleBuilder_getToken): Check for null
	(ves_icall_ModuleBuilder_getMethodToken): Ditto

2004-12-12  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.c (write_type): If we're an enum and the
	builtin types have already been initialized, call mono_class_init().

2004-12-11  Martin Baulig  <martin@ximian.com>

	* metadata.c (mono_metadata_load_generic_params): Added
	`MonoGenericContainer *parent_container' argument; automatically
	compute `container->is_method'; pass the correct owner to
	get_constraints().	

	* reflection.c (compare_genericparam): Sort the GenericParam table
	according to increasing owners.	

Fri Dec 10 18:43:46 CET 2004 Paolo Molaro <lupus@ximian.com>

	* profiler.c: allow disabling the default profiler.

Fri Dec 10 18:42:11 CET 2004 Paolo Molaro <lupus@ximian.com>

	* decimal.c, icall.c: allow disabling System.Decimal support.

2004-12-09  Marek Safar <marek.safar@seznam.cz>

	* reflection.c: Add support for null attribute arguments.

2004-12-09  Martin Baulig  <martin@ximian.com>

	* metadata.h, loader.h: Use `idx' instead of `index' in parameter
	names to get rid of compiler warnings.

2004-12-08  Zoltan Varga  <vargaz@freemail.hu>

	* marshal.c (mono_marshal_get_struct_to_ptr): Call 
	mono_marshal_load_type_info (). Fixes #69625.
	(mono_marshal_get_ptr_to_struct): Likewise.

2004-12-08  Martin Baulig  <martin@ximian.com>

	* mono-debug.h: Bumped version number to 47.

	* mono-debug-debugger.c
	(mono_debugger_event_handler, mono_debugger_event): Take two
	guint64 arguments insteed of a gpointer and a guint32.	

2004-12-08  Martin Baulig  <martin@ximian.com>

	* debug-mono-symfile.h
	(MonoDebugLineNumberEntry): Renamed `offset' to `il_offset' and
	`address' to `native_offset'.

2004-12-08  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_create_from_typespec): Only inflate if we
	either have `context->gclass' or `context->gmethod'.

2004-12-08  Zoltan Varga  <vargaz@freemail.hu>

	* metadata-internals.h (MonoAssembly): Add 'corlib_internal' field.

	* object-internals.h (MonoReflectionAssemblyBuilder): Move 'corlib_internal' field from Assembly to AssemblyBuilder.

	* reflection.c (mono_image_basic_init): Initialize assembly->corlib_internal from the assembly builder.

	* reflection.c (mono_assembly_get_object): Remove the workaround put
	in for the release.
	
	* appdomain.c: Use the corlib_internal field from MonoAssembly.

	* appdomain.c: Bump corlib version.

	* reflection.c (mono_assembly_get_object): Add a workaround so __MetadataTypes won't
	be visible in other appdomains.

2004-12-07  Ben Maurer  <bmaurer@ximian.com>

	* threads.c: Interlocked inc and dec for longs were messed up,
	use a KISS based impl for this. Fixes 70234

2004-12-07  Zoltan Varga  <vargaz@freemail.hu>

	* threads.c (ves_icall_System_Threading_Thread_GetCachedCurrentCulture): Make this lock-less.

Tue Dec 7 10:47:09 CET 2004 Paolo Molaro <lupus@ximian.com>

	* icall.c: fix to follow policy not to allow struct
	arguments in icalls.

2004-12-06 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* process.c: make the patch that handles spaces in file paths work
	on mono/windows too.

2004-12-06  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_create_generic): Call
	mono_class_setup_supertypes() if we're dynamic.
	(mono_class_is_subclass_of): `g_assert (klass->idepth > 0)'.

2004-12-06  Zoltan Varga  <vargaz@freemail.hu>

	* object-internals.h: Add new fields to MonoThread.

	* appdomain.c (MONO_CORLIB_VERSION): Bump corlib version.

	* icall.c threads-types.h threads.c: Add new icalls.

	* object-internals.h (MonoThread): Remove unused 'unmanaged' field.

	* object-internals.h (MonoReflectionAssembly): Sync object layout with
	managed side.

	* appdomain.c: Bump corlib version.

	* appdomain.c (ves_icall_System_AppDomain_GetAssemblies): Skip
	internal assemblies. Fixes #69181.

2004-12-05  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_inflate_generic_signature): Make this a
	no-op if `context' is NULL or we don't have any type parameters;
	also copy `sentinelpos'.	

2004-12-04  Zoltan Varga  <vargaz@freemail.hu>

	* image.c: Add unbox_wrapper_cache.

	* class-internals.h debug-helpers.c: Add MONO_WRAPPER_UNBOX.

	* marshal.h marshal.c (mono_marshal_get_unbox_wrapper): New wrapper
	function generator.
	
	* object.c (mono_delegate_ctor): Call unbox wrapper if neccesary.
	Fixes #70173.

	* metadata-internals.h image.c: Add MonoImage->unbox_wrapper_cache.
	
2004-12-04  Martin Baulig  <martin@ximian.com>

	* loader.c (mono_method_get_signature_full): New public function;
	like mono_method_get_signature(), but with an additional
	`MonoGenericContext *' argument.

	* class.c (mono_class_inflate_generic_signature): Formerly known
	as inflate_generic_signature(); make this public.

2004-12-04  Martin Baulig  <martin@ximian.com>

	* metadata.c
	(mono_metadata_parse_type_full): Take a `MonoGenericContext *'
	instead of a `MonoGenericContainer *'.	
	(mono_metadata_parse_array_full): Likewise.
	(mono_metadata_parse_signature_full): Likewise.
	(mono_metadata_parse_method_signature_full): Likewise.
	(mono_metadata_parse_generic_inst): Likewise.
	(mono_metadata_parse_generic_param): Likewise.
	(mono_metadata_parse_mh_full): Likewise.
	(mono_type_create_from_typespec_full): Likewise.

2004-12-03  Martin Baulig  <martin@ximian.com>

	* class-internals.h (MonoGenericContainer): Replaced the
	`MonoGenericContext * pointer with a `MonoGenericContext'
	structure and made it the first element.

2004-12-03  Martin Baulig  <martin@ximian.com>

	* class.c
	(inflate_generic_type): Set the `context->container' when creating
	a new MonoGenericContext.
	(mono_class_inflate_generic_method): Likewise.
	(mono_class_create_from_typespec): Just use `context->container'
	to get the container.

	* loader.c (method_from_methodspec): Set `context->parent' from
	`context->container' - and if that's a method container, use its
	parent.  Also set the `context->container' when creating a new
	MonoGenericContext.
	(mono_get_method_from_token): Use just `context->container' to get
	the container.

	* metadata.c (do_mono_metadata_parse_generic_class): Also set
	`gclass->context->container'.

	* reflection.c (do_mono_reflection_bind_generic_parameters): Set
	the `context->container' when creating a new MonoGenericContext.

2004-12-03  Zoltan Varga  <vargaz@freemail.hu>

	* reflection.c (compare_genericparam): Sort params with identical
	owner by their number. Fixes gen-111 on sparc.

2004-12-02  Zoltan Varga  <vargaz@freemail.hu>

	* threadpool.c (async_invoke_thread): Call push/pop_appdomain_ref
	around the domain changes.

	* appdomain.c (mono_domain_unload): Handle the case when the thread
	calling Unload is itself being aborted during unloading. Fixes #70022.

	* appdomain.h: Add prototype for mono_install_runtime_cleanup.

	* marshal.c (emit_thread_interrupt_checkpoint_call): Call 
	checkpoint_func as an icall so it gets a wrapper.
	(mono_marshal_get_xappdomain_invoke): Call push/pop_appdomain_ref ()
	in the cross-appdomain wrappers too.

	* threads.c (mono_thread_has_appdomain_ref): Make this public.

	* assembly.c (mono_assembly_open_from_bundle): Fix warning.

	* reflection.c: Fix some memory leaks.
	
2004-12-02  Martin Baulig  <martin@ximian.com>

	* metadata-internals.h (MonoImage): Removed `generic_class_cache'.

	* metadata.c (generic_class_cache): New static hashtable.
	(mono_metadata_lookup_generic_class): New public method.

2004-12-02  Martin Baulig  <martin@ximian.com>

	* class.c (mono_class_create_from_typedef): Call
	mono_class_setup_parent() and mono_class_create_mono_type() before
	parsing the interfaces.

2004-12-02  Martin Baulig  <martin@ximian.com>

	* metadata.c (generic_inst_cache): New static hashtable.
	(mono_metadata_lookup_generic_inst): New public function.
	(mono_metadata_inflate_generic_inst): New public function.
	(mono_metadata_parse_generic_inst): New public function.
	(do_mono_metadata_parse_generic_class): Use the new
	mono_metadata_parse_generic_inst() for parsing the `gclass->inst'
